/* gpx-graph.c generated by valac 0.21.2, the Vala compiler
 * generated from gpx-graph.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2011 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include "gpx.h"
#include <pango/pango.h>
#include <cairo.h>
#include <time.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pangocairo.h>
#include <glib/gi18n-lib.h>
#include <gpx-viewer.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GpxGraphPrivate {
	gboolean _do_miles;
	GpxGraphGraphMode _mode;
	gint _smooth_factor;
	gboolean _show_points;
	PangoFontDescription* fd;
	cairo_surface_t* surf;
	gint LEFT_OFFSET;
	gint BOTTOM_OFFSET;
	time_t highlight;
	GpxPoint* draw_current;
	GpxPoint* start;
	GpxPoint* stop;
};


static gpointer gpx_graph_parent_class = NULL;
static gchar** gpx_graph_GraphModeName;
static gint gpx_graph_GraphModeName_length1;
static gchar** gpx_graph_GraphModeName = NULL;
static gint gpx_graph_GraphModeName_length1 = 0;
static gint _gpx_graph_GraphModeName_size_ = 0;
static gchar** gpx_graph_GraphModeMiles;
static gint gpx_graph_GraphModeMiles_length1;
static gchar** gpx_graph_GraphModeMiles = NULL;
static gint gpx_graph_GraphModeMiles_length1 = 0;
static gint _gpx_graph_GraphModeMiles_size_ = 0;

#define LOG_DOMAIN "GPX_GRAPH"
#define unique_graph VERSION
#define GPX_GRAPH_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_GRAPH, GpxGraphPrivate))
enum  {
	GPX_GRAPH_DUMMY_PROPERTY,
	GPX_GRAPH_SMOOTH_FACTOR,
	GPX_GRAPH_SHOW_POINTS,
	GPX_GRAPH_MODE
};
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void gpx_graph_size_allocate_cb (GpxGraph* self, GtkAllocation* alloc);
static void _gpx_graph_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self);
static gboolean gpx_graph_button_press_event_cb (GpxGraph* self, GdkEventButton* event);
static gboolean _gpx_graph_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean gpx_graph_motion_notify_event_cb (GpxGraph* self, GdkEventMotion* event);
static gboolean _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean gpx_graph_button_release_event_cb (GpxGraph* self, GdkEventButton* event);
static gboolean _gpx_graph_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean gpx_graph_a_expose_event (GpxGraph* self, cairo_t* ctx);
static gboolean _gpx_graph_a_expose_event_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self);
static GpxPoint* gpx_graph_get_point_from_position (GpxGraph* self, gdouble x, gdouble y);
static void gpx_graph_update_surface (GpxGraph* self, GtkWidget* win);
static void gpx_graph_draw_grid (GpxGraph* self, cairo_t* ctx, PangoLayout* layout, gdouble graph_width, gdouble graph_height, gdouble min_value, gdouble max_value, gdouble elapsed_time);
static gdouble gpx_graph_calculate_graph_point_value (GpxGraph* self, GList* ii);
static gdouble gpx_graph_calculate_graph_point_smooth_value (GpxGraph* self, GList* iter);
static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void gpx_graph_finalize (GObject* obj);
static void _vala_gpx_graph_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpx_graph_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType gpx_graph_graph_mode_get_type (void) {
	static volatile gsize gpx_graph_graph_mode_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_graph_graph_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GPX_GRAPH_GRAPH_MODE_SPEED, "GPX_GRAPH_GRAPH_MODE_SPEED", "speed"}, {GPX_GRAPH_GRAPH_MODE_ELEVATION, "GPX_GRAPH_GRAPH_MODE_ELEVATION", "elevation"}, {GPX_GRAPH_GRAPH_MODE_DISTANCE, "GPX_GRAPH_GRAPH_MODE_DISTANCE", "distance"}, {GPX_GRAPH_GRAPH_MODE_ACCELERATION_H, "GPX_GRAPH_GRAPH_MODE_ACCELERATION_H", "acceleration-h"}, {GPX_GRAPH_GRAPH_MODE_SPEED_V, "GPX_GRAPH_GRAPH_MODE_SPEED_V", "speed-v"}, {GPX_GRAPH_GRAPH_MODE_NUM_GRAPH_MODES, "GPX_GRAPH_GRAPH_MODE_NUM_GRAPH_MODES", "num-graph-modes"}, {0, NULL, NULL}};
		GType gpx_graph_graph_mode_type_id;
		gpx_graph_graph_mode_type_id = g_enum_register_static ("GpxGraphGraphMode", values);
		g_once_init_leave (&gpx_graph_graph_mode_type_id__volatile, gpx_graph_graph_mode_type_id);
	}
	return gpx_graph_graph_mode_type_id__volatile;
}


static void _vala_PangoFontDescription_free (PangoFontDescription* self) {
	g_boxed_free (pango_font_description_get_type (), self);
}


void gpx_graph_hide_info (GpxGraph* self) {
	g_return_if_fail (self != NULL);
	self->priv->draw_current = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void gpx_graph_show_info (GpxGraph* self, GpxPoint* cur_point) {
	GpxPoint* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = cur_point;
	self->priv->draw_current = _tmp0_;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


/** 
 * @param p A Gpx.Point we want to highlight.
 * pass null to unhighlight.
 */
void gpx_graph_highlight_point (GpxGraph* self, GpxPoint* p) {
	time_t _tmp0_ = 0;
	GpxPoint* _tmp1_ = NULL;
	time_t pt = 0;
	time_t _tmp4_ = 0;
	g_return_if_fail (self != NULL);
	_tmp1_ = p;
	if (_tmp1_ == NULL) {
		_tmp0_ = (time_t) 0;
	} else {
		GpxPoint* _tmp2_ = NULL;
		time_t _tmp3_ = 0;
		_tmp2_ = p;
		_tmp3_ = gpx_point_get_time (_tmp2_);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _tmp0_;
	pt = _tmp4_;
	gpx_graph_set_highlight (self, pt);
}


void gpx_graph_set_highlight (GpxGraph* self, time_t highlight) {
	time_t _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = highlight;
	self->priv->highlight = _tmp0_;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static void _gpx_graph_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender, GtkAllocation* allocation, gpointer self) {
	gpx_graph_size_allocate_cb (self, allocation);
}


static gboolean _gpx_graph_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = gpx_graph_button_press_event_cb (self, event);
	return result;
}


static gboolean _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = gpx_graph_motion_notify_event_cb (self, event);
	return result;
}


static gboolean _gpx_graph_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = gpx_graph_button_release_event_cb (self, event);
	return result;
}


static gboolean _gpx_graph_a_expose_event_gtk_widget_draw (GtkWidget* _sender, cairo_t* cr, gpointer self) {
	gboolean result;
	result = gpx_graph_a_expose_event (self, cr);
	return result;
}


GpxGraph* gpx_graph_construct (GType object_type) {
	GpxGraph * self = NULL;
	PangoFontDescription* _tmp0_ = NULL;
	PangoFontDescription* _tmp1_ = NULL;
	self = (GpxGraph*) g_object_new (object_type, NULL);
	_tmp0_ = pango_font_description_new ();
	__vala_PangoFontDescription_free0 (self->priv->fd);
	self->priv->fd = _tmp0_;
	_tmp1_ = self->priv->fd;
	pango_font_description_set_family (_tmp1_, "sans mono");
	gtk_widget_set_app_paintable ((GtkWidget*) self, TRUE);
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _gpx_graph_size_allocate_cb_gtk_widget_size_allocate, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _gpx_graph_button_press_event_cb_gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _gpx_graph_button_release_event_cb_gtk_widget_button_release_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) _gpx_graph_a_expose_event_gtk_widget_draw, self, 0);
	return self;
}


GpxGraph* gpx_graph_new (void) {
	return gpx_graph_construct (GPX_TYPE_GRAPH);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void gpx_graph_set_track (GpxGraph* self, GpxTrack* track) {
	GpxTrack* _tmp0_ = NULL;
	GpxTrack* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GpxTrack* _tmp3_ = NULL;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->highlight = (time_t) 0;
	_tmp0_ = track;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->track);
	self->track = _tmp1_;
	_cairo_surface_destroy0 (self->priv->surf);
	self->priv->surf = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
	_gpx_point_unref0 (self->priv->start);
	self->priv->start = NULL;
	_gpx_point_unref0 (self->priv->stop);
	self->priv->stop = NULL;
	_tmp3_ = self->track;
	if (_tmp3_ != NULL) {
		GpxTrack* _tmp4_ = NULL;
		GList* _tmp5_ = NULL;
		_tmp4_ = self->track;
		_tmp5_ = _tmp4_->points;
		_tmp2_ = _tmp5_ != NULL;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp6_ = _tmp2_;
	if (_tmp6_) {
		GpxTrack* _tmp7_ = NULL;
		GpxTrack* _tmp8_ = NULL;
		GList* _tmp9_ = NULL;
		GList* _tmp10_ = NULL;
		gconstpointer _tmp11_ = NULL;
		GpxTrack* _tmp12_ = NULL;
		GList* _tmp13_ = NULL;
		GList* _tmp14_ = NULL;
		gconstpointer _tmp15_ = NULL;
		_tmp7_ = self->track;
		_tmp8_ = self->track;
		_tmp9_ = _tmp8_->points;
		_tmp10_ = g_list_first (_tmp9_);
		_tmp11_ = _tmp10_->data;
		_tmp12_ = self->track;
		_tmp13_ = _tmp12_->points;
		_tmp14_ = g_list_last (_tmp13_);
		_tmp15_ = _tmp14_->data;
		g_signal_emit_by_name (self, "selection-changed", _tmp7_, (GpxPoint*) _tmp11_, (GpxPoint*) _tmp15_);
	} else {
		GpxTrack* _tmp16_ = NULL;
		_tmp16_ = self->track;
		g_signal_emit_by_name (self, "selection-changed", _tmp16_, NULL, NULL);
	}
}


/**
 * Private functions
 */
static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


static GpxPoint* gpx_graph_get_point_from_position (GpxGraph* self, gdouble x, gdouble y) {
	GpxPoint* result = NULL;
	GtkAllocation alloc = {0};
	GpxTrack* _tmp0_ = NULL;
	GtkAllocation _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	gboolean _tmp8_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->track;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
	alloc = _tmp1_;
	_tmp3_ = x;
	_tmp4_ = self->priv->LEFT_OFFSET;
	if (_tmp3_ > ((gdouble) _tmp4_)) {
		gdouble _tmp5_ = 0.0;
		GtkAllocation _tmp6_ = {0};
		gint _tmp7_ = 0;
		_tmp5_ = x;
		_tmp6_ = alloc;
		_tmp7_ = _tmp6_.width;
		_tmp2_ = _tmp5_ < ((gdouble) (_tmp7_ - 10));
	} else {
		_tmp2_ = FALSE;
	}
	_tmp8_ = _tmp2_;
	if (_tmp8_) {
		gdouble elapsed_time = 0.0;
		GpxTrack* _tmp9_ = NULL;
		time_t _tmp10_ = 0;
		time_t time = 0;
		gdouble _tmp11_ = 0.0;
		gint _tmp12_ = 0;
		GtkAllocation _tmp13_ = {0};
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gdouble _tmp16_ = 0.0;
		GList* iter = NULL;
		GpxTrack* _tmp17_ = NULL;
		GList* _tmp18_ = NULL;
		GList* _tmp19_ = NULL;
		time_t _tmp20_ = 0;
		GList* _tmp21_ = NULL;
		gconstpointer _tmp22_ = NULL;
		time_t _tmp23_ = 0;
		_tmp9_ = self->track;
		_tmp10_ = gpx_track_get_total_time (_tmp9_);
		elapsed_time = (gdouble) _tmp10_;
		_tmp11_ = x;
		_tmp12_ = self->priv->LEFT_OFFSET;
		_tmp13_ = alloc;
		_tmp14_ = _tmp13_.width;
		_tmp15_ = self->priv->LEFT_OFFSET;
		_tmp16_ = elapsed_time;
		time = (time_t) (((_tmp11_ - _tmp12_) / ((_tmp14_ - 10) - _tmp15_)) * _tmp16_);
		_tmp17_ = self->track;
		_tmp18_ = _tmp17_->points;
		_tmp19_ = g_list_first (_tmp18_);
		iter = _tmp19_;
		_tmp20_ = time;
		_tmp21_ = iter;
		_tmp22_ = _tmp21_->data;
		_tmp23_ = gpx_point_get_time ((GpxPoint*) _tmp22_);
		time = _tmp20_ + _tmp23_;
		while (TRUE) {
			GList* _tmp24_ = NULL;
			GList* _tmp25_ = NULL;
			gboolean _tmp26_ = FALSE;
			time_t _tmp27_ = 0;
			GList* _tmp28_ = NULL;
			GList* _tmp29_ = NULL;
			gconstpointer _tmp30_ = NULL;
			time_t _tmp31_ = 0;
			gboolean _tmp42_ = FALSE;
			GList* _tmp46_ = NULL;
			GList* _tmp47_ = NULL;
			_tmp24_ = iter;
			_tmp25_ = _tmp24_->next;
			if (!(_tmp25_ != NULL)) {
				break;
			}
			_tmp27_ = time;
			_tmp28_ = iter;
			_tmp29_ = _tmp28_->next;
			_tmp30_ = _tmp29_->data;
			_tmp31_ = gpx_point_get_time ((GpxPoint*) _tmp30_);
			if (_tmp27_ < _tmp31_) {
				gboolean _tmp32_ = FALSE;
				time_t _tmp33_ = 0;
				GList* _tmp34_ = NULL;
				gconstpointer _tmp35_ = NULL;
				time_t _tmp36_ = 0;
				gboolean _tmp41_ = FALSE;
				_tmp33_ = time;
				_tmp34_ = iter;
				_tmp35_ = _tmp34_->data;
				_tmp36_ = gpx_point_get_time ((GpxPoint*) _tmp35_);
				if (_tmp33_ == _tmp36_) {
					_tmp32_ = TRUE;
				} else {
					time_t _tmp37_ = 0;
					GList* _tmp38_ = NULL;
					gconstpointer _tmp39_ = NULL;
					time_t _tmp40_ = 0;
					_tmp37_ = time;
					_tmp38_ = iter;
					_tmp39_ = _tmp38_->data;
					_tmp40_ = gpx_point_get_time ((GpxPoint*) _tmp39_);
					_tmp32_ = _tmp37_ > _tmp40_;
				}
				_tmp41_ = _tmp32_;
				_tmp26_ = _tmp41_;
			} else {
				_tmp26_ = FALSE;
			}
			_tmp42_ = _tmp26_;
			if (_tmp42_) {
				GList* _tmp43_ = NULL;
				gconstpointer _tmp44_ = NULL;
				GpxPoint* _tmp45_ = NULL;
				_tmp43_ = iter;
				_tmp44_ = _tmp43_->data;
				_tmp45_ = _gpx_point_ref0 ((GpxPoint*) _tmp44_);
				result = _tmp45_;
				return result;
			}
			_tmp46_ = iter;
			_tmp47_ = _tmp46_->next;
			iter = _tmp47_;
		}
	}
	result = NULL;
	return result;
}


static gboolean gpx_graph_button_press_event_cb (GpxGraph* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GpxTrack* _tmp0_ = NULL;
	GpxPoint* point = NULL;
	GdkEventButton _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	GdkEventButton _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	GpxPoint* _tmp5_ = NULL;
	GpxPoint* _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->track;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = *event;
	_tmp2_ = _tmp1_.x;
	_tmp3_ = *event;
	_tmp4_ = _tmp3_.y;
	_tmp5_ = gpx_graph_get_point_from_position (self, _tmp2_, _tmp4_);
	point = _tmp5_;
	_tmp6_ = point;
	if (_tmp6_ != NULL) {
		GdkEventButton _tmp7_ = {0};
		guint _tmp8_ = 0U;
		_tmp7_ = *event;
		_tmp8_ = _tmp7_.button;
		if (_tmp8_ == ((guint) 1)) {
			GpxPoint* _tmp9_ = NULL;
			GpxPoint* _tmp10_ = NULL;
			_tmp9_ = point;
			_tmp10_ = _gpx_point_ref0 (_tmp9_);
			_gpx_point_unref0 (self->priv->start);
			self->priv->start = _tmp10_;
		} else {
			GpxPoint* _tmp11_ = NULL;
			_gpx_point_unref0 (self->priv->start);
			self->priv->start = NULL;
			_tmp11_ = point;
			g_signal_emit_by_name (self, "point-clicked", _tmp11_);
		}
	}
	result = FALSE;
	return result;
}


static gboolean gpx_graph_motion_notify_event_cb (GpxGraph* self, GdkEventMotion* event) {
	gboolean result = FALSE;
	GpxTrack* _tmp0_ = NULL;
	GpxPoint* _tmp1_ = NULL;
	GpxPoint* point = NULL;
	GdkEventMotion _tmp2_ = {0};
	gdouble _tmp3_ = 0.0;
	GdkEventMotion _tmp4_ = {0};
	gdouble _tmp5_ = 0.0;
	GpxPoint* _tmp6_ = NULL;
	GpxPoint* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->track;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = self->priv->start;
	if (_tmp1_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp2_ = *event;
	_tmp3_ = _tmp2_.x;
	_tmp4_ = *event;
	_tmp5_ = _tmp4_.y;
	_tmp6_ = gpx_graph_get_point_from_position (self, _tmp3_, _tmp5_);
	point = _tmp6_;
	_tmp7_ = point;
	if (_tmp7_ != NULL) {
		GpxPoint* _tmp8_ = NULL;
		GpxPoint* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		GpxPoint* _tmp11_ = NULL;
		gboolean _tmp13_ = FALSE;
		GpxTrack* _tmp28_ = NULL;
		GpxTrack* _tmp29_ = NULL;
		GList* _tmp30_ = NULL;
		GList* _tmp31_ = NULL;
		gconstpointer _tmp32_ = NULL;
		GpxTrack* _tmp33_ = NULL;
		GList* _tmp34_ = NULL;
		GList* _tmp35_ = NULL;
		gconstpointer _tmp36_ = NULL;
		_tmp8_ = point;
		_tmp9_ = _gpx_point_ref0 (_tmp8_);
		_gpx_point_unref0 (self->priv->stop);
		self->priv->stop = _tmp9_;
		gtk_widget_queue_draw ((GtkWidget*) self);
		_tmp11_ = self->priv->start;
		if (_tmp11_ != NULL) {
			GpxPoint* _tmp12_ = NULL;
			_tmp12_ = self->priv->stop;
			_tmp10_ = _tmp12_ != NULL;
		} else {
			_tmp10_ = FALSE;
		}
		_tmp13_ = _tmp10_;
		if (_tmp13_) {
			GpxPoint* _tmp14_ = NULL;
			time_t _tmp15_ = 0;
			GpxPoint* _tmp16_ = NULL;
			time_t _tmp17_ = 0;
			_tmp14_ = self->priv->start;
			_tmp15_ = gpx_point_get_time (_tmp14_);
			_tmp16_ = self->priv->stop;
			_tmp17_ = gpx_point_get_time (_tmp16_);
			if (_tmp15_ != _tmp17_) {
				GpxPoint* _tmp18_ = NULL;
				time_t _tmp19_ = 0;
				GpxPoint* _tmp20_ = NULL;
				time_t _tmp21_ = 0;
				_tmp18_ = self->priv->start;
				_tmp19_ = gpx_point_get_time (_tmp18_);
				_tmp20_ = self->priv->stop;
				_tmp21_ = gpx_point_get_time (_tmp20_);
				if (_tmp19_ < _tmp21_) {
					GpxTrack* _tmp22_ = NULL;
					GpxPoint* _tmp23_ = NULL;
					GpxPoint* _tmp24_ = NULL;
					_tmp22_ = self->track;
					_tmp23_ = self->priv->start;
					_tmp24_ = self->priv->stop;
					g_signal_emit_by_name (self, "selection-changed", _tmp22_, _tmp23_, _tmp24_);
				} else {
					GpxTrack* _tmp25_ = NULL;
					GpxPoint* _tmp26_ = NULL;
					GpxPoint* _tmp27_ = NULL;
					_tmp25_ = self->track;
					_tmp26_ = self->priv->stop;
					_tmp27_ = self->priv->start;
					g_signal_emit_by_name (self, "selection-changed", _tmp25_, _tmp26_, _tmp27_);
				}
				result = FALSE;
				return result;
			}
		}
		_tmp28_ = self->track;
		_tmp29_ = self->track;
		_tmp30_ = _tmp29_->points;
		_tmp31_ = g_list_first (_tmp30_);
		_tmp32_ = _tmp31_->data;
		_tmp33_ = self->track;
		_tmp34_ = _tmp33_->points;
		_tmp35_ = g_list_last (_tmp34_);
		_tmp36_ = _tmp35_->data;
		g_signal_emit_by_name (self, "selection-changed", _tmp28_, (GpxPoint*) _tmp32_, (GpxPoint*) _tmp36_);
	}
	result = FALSE;
	return result;
}


static gboolean gpx_graph_button_release_event_cb (GpxGraph* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GpxTrack* _tmp0_ = NULL;
	GpxPoint* point = NULL;
	GdkEventButton _tmp1_ = {0};
	gdouble _tmp2_ = 0.0;
	GdkEventButton _tmp3_ = {0};
	gdouble _tmp4_ = 0.0;
	GpxPoint* _tmp5_ = NULL;
	GpxPoint* _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->track;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	_tmp1_ = *event;
	_tmp2_ = _tmp1_.x;
	_tmp3_ = *event;
	_tmp4_ = _tmp3_.y;
	_tmp5_ = gpx_graph_get_point_from_position (self, _tmp2_, _tmp4_);
	point = _tmp5_;
	_tmp6_ = point;
	if (_tmp6_ != NULL) {
		GdkEventButton _tmp7_ = {0};
		guint _tmp8_ = 0U;
		GdkEventButton _tmp11_ = {0};
		guint _tmp12_ = 0U;
		_tmp7_ = *event;
		_tmp8_ = _tmp7_.button;
		if (_tmp8_ == ((guint) 1)) {
			GpxPoint* _tmp9_ = NULL;
			GpxPoint* _tmp10_ = NULL;
			_tmp9_ = point;
			_tmp10_ = _gpx_point_ref0 (_tmp9_);
			_gpx_point_unref0 (self->priv->stop);
			self->priv->stop = _tmp10_;
		} else {
			_gpx_point_unref0 (self->priv->stop);
			self->priv->stop = NULL;
		}
		gtk_widget_queue_draw ((GtkWidget*) self);
		_tmp11_ = *event;
		_tmp12_ = _tmp11_.button;
		if (_tmp12_ == ((guint) 1)) {
			gboolean _tmp13_ = FALSE;
			GpxPoint* _tmp14_ = NULL;
			gboolean _tmp16_ = FALSE;
			GpxTrack* _tmp31_ = NULL;
			GpxTrack* _tmp32_ = NULL;
			GList* _tmp33_ = NULL;
			GList* _tmp34_ = NULL;
			gconstpointer _tmp35_ = NULL;
			GpxTrack* _tmp36_ = NULL;
			GList* _tmp37_ = NULL;
			GList* _tmp38_ = NULL;
			gconstpointer _tmp39_ = NULL;
			_tmp14_ = self->priv->start;
			if (_tmp14_ != NULL) {
				GpxPoint* _tmp15_ = NULL;
				_tmp15_ = self->priv->stop;
				_tmp13_ = _tmp15_ != NULL;
			} else {
				_tmp13_ = FALSE;
			}
			_tmp16_ = _tmp13_;
			if (_tmp16_) {
				GpxPoint* _tmp17_ = NULL;
				time_t _tmp18_ = 0;
				GpxPoint* _tmp19_ = NULL;
				time_t _tmp20_ = 0;
				_tmp17_ = self->priv->start;
				_tmp18_ = gpx_point_get_time (_tmp17_);
				_tmp19_ = self->priv->stop;
				_tmp20_ = gpx_point_get_time (_tmp19_);
				if (_tmp18_ != _tmp20_) {
					GpxPoint* _tmp21_ = NULL;
					time_t _tmp22_ = 0;
					GpxPoint* _tmp23_ = NULL;
					time_t _tmp24_ = 0;
					_tmp21_ = self->priv->start;
					_tmp22_ = gpx_point_get_time (_tmp21_);
					_tmp23_ = self->priv->stop;
					_tmp24_ = gpx_point_get_time (_tmp23_);
					if (_tmp22_ < _tmp24_) {
						GpxTrack* _tmp25_ = NULL;
						GpxPoint* _tmp26_ = NULL;
						GpxPoint* _tmp27_ = NULL;
						_tmp25_ = self->track;
						_tmp26_ = self->priv->start;
						_tmp27_ = self->priv->stop;
						g_signal_emit_by_name (self, "selection-changed", _tmp25_, _tmp26_, _tmp27_);
					} else {
						GpxTrack* _tmp28_ = NULL;
						GpxPoint* _tmp29_ = NULL;
						GpxPoint* _tmp30_ = NULL;
						_tmp28_ = self->track;
						_tmp29_ = self->priv->stop;
						_tmp30_ = self->priv->start;
						g_signal_emit_by_name (self, "selection-changed", _tmp28_, _tmp29_, _tmp30_);
					}
					result = FALSE;
					return result;
				}
			}
			_tmp31_ = self->track;
			_tmp32_ = self->track;
			_tmp33_ = _tmp32_->points;
			_tmp34_ = g_list_first (_tmp33_);
			_tmp35_ = _tmp34_->data;
			_tmp36_ = self->track;
			_tmp37_ = _tmp36_->points;
			_tmp38_ = g_list_last (_tmp37_);
			_tmp39_ = _tmp38_->data;
			g_signal_emit_by_name (self, "selection-changed", _tmp31_, (GpxPoint*) _tmp35_, (GpxPoint*) _tmp39_);
		}
	}
	result = FALSE;
	return result;
}


static void gpx_graph_size_allocate_cb (GpxGraph* self, GtkAllocation* alloc) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (alloc != NULL);
	_cairo_surface_destroy0 (self->priv->surf);
	self->priv->surf = NULL;
}


static gboolean gpx_graph_a_expose_event (GpxGraph* self, cairo_t* ctx) {
	gboolean result = FALSE;
	cairo_surface_t* _tmp0_ = NULL;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp1_ = {0};
	cairo_t* _tmp2_ = NULL;
	cairo_surface_t* _tmp3_ = NULL;
	cairo_t* _tmp4_ = NULL;
	cairo_t* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	GpxPoint* _tmp8_ = NULL;
	gboolean _tmp10_ = FALSE;
	time_t _tmp45_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	_tmp0_ = self->priv->surf;
	if (_tmp0_ == NULL) {
		gpx_graph_update_surface (self, (GtkWidget*) self);
	}
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp1_);
	alloc = _tmp1_;
	_tmp2_ = ctx;
	_tmp3_ = self->priv->surf;
	cairo_set_source_surface (_tmp2_, _tmp3_, (gdouble) 0, (gdouble) 0);
	_tmp4_ = ctx;
	cairo_paint (_tmp4_);
	_tmp5_ = ctx;
	_tmp6_ = self->priv->LEFT_OFFSET;
	cairo_translate (_tmp5_, (gdouble) _tmp6_, (gdouble) 20);
	_tmp8_ = self->priv->start;
	if (_tmp8_ != NULL) {
		GpxPoint* _tmp9_ = NULL;
		_tmp9_ = self->priv->stop;
		_tmp7_ = _tmp9_ != NULL;
	} else {
		_tmp7_ = FALSE;
	}
	_tmp10_ = _tmp7_;
	if (_tmp10_) {
		GpxPoint* _tmp11_ = NULL;
		time_t _tmp12_ = 0;
		GpxPoint* _tmp13_ = NULL;
		time_t _tmp14_ = 0;
		_tmp11_ = self->priv->start;
		_tmp12_ = gpx_point_get_time (_tmp11_);
		_tmp13_ = self->priv->stop;
		_tmp14_ = gpx_point_get_time (_tmp13_);
		if (_tmp12_ != _tmp14_) {
			GpxPoint* f = NULL;
			GpxTrack* _tmp15_ = NULL;
			GList* _tmp16_ = NULL;
			GList* _tmp17_ = NULL;
			gconstpointer _tmp18_ = NULL;
			GpxPoint* _tmp19_ = NULL;
			gdouble elapsed_time = 0.0;
			GpxTrack* _tmp20_ = NULL;
			time_t _tmp21_ = 0;
			gdouble graph_width = 0.0;
			GtkAllocation _tmp22_ = {0};
			gint _tmp23_ = 0;
			gint _tmp24_ = 0;
			gdouble graph_height = 0.0;
			GtkAllocation _tmp25_ = {0};
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			cairo_t* _tmp28_ = NULL;
			cairo_t* _tmp29_ = NULL;
			GpxPoint* _tmp30_ = NULL;
			time_t _tmp31_ = 0;
			GpxPoint* _tmp32_ = NULL;
			time_t _tmp33_ = 0;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			GpxPoint* _tmp36_ = NULL;
			time_t _tmp37_ = 0;
			GpxPoint* _tmp38_ = NULL;
			time_t _tmp39_ = 0;
			gdouble _tmp40_ = 0.0;
			gdouble _tmp41_ = 0.0;
			gdouble _tmp42_ = 0.0;
			cairo_t* _tmp43_ = NULL;
			cairo_t* _tmp44_ = NULL;
			_tmp15_ = self->track;
			_tmp16_ = _tmp15_->points;
			_tmp17_ = g_list_first (_tmp16_);
			_tmp18_ = _tmp17_->data;
			_tmp19_ = _gpx_point_ref0 ((GpxPoint*) _tmp18_);
			f = _tmp19_;
			_tmp20_ = self->track;
			_tmp21_ = gpx_track_get_total_time (_tmp20_);
			elapsed_time = (gdouble) _tmp21_;
			_tmp22_ = alloc;
			_tmp23_ = _tmp22_.width;
			_tmp24_ = self->priv->LEFT_OFFSET;
			graph_width = (gdouble) ((_tmp23_ - _tmp24_) - 10);
			_tmp25_ = alloc;
			_tmp26_ = _tmp25_.height;
			_tmp27_ = self->priv->BOTTOM_OFFSET;
			graph_height = (gdouble) ((_tmp26_ - 20) - _tmp27_);
			_tmp28_ = ctx;
			cairo_set_source_rgba (_tmp28_, 0.3, 0.2, 0.3, 0.8);
			_tmp29_ = ctx;
			_tmp30_ = self->priv->start;
			_tmp31_ = gpx_point_get_time (_tmp30_);
			_tmp32_ = f;
			_tmp33_ = gpx_point_get_time (_tmp32_);
			_tmp34_ = elapsed_time;
			_tmp35_ = graph_width;
			_tmp36_ = self->priv->stop;
			_tmp37_ = gpx_point_get_time (_tmp36_);
			_tmp38_ = self->priv->start;
			_tmp39_ = gpx_point_get_time (_tmp38_);
			_tmp40_ = elapsed_time;
			_tmp41_ = graph_width;
			_tmp42_ = graph_height;
			cairo_rectangle (_tmp29_, ((_tmp31_ - _tmp33_) / _tmp34_) * _tmp35_, (gdouble) 0, ((_tmp37_ - _tmp39_) / _tmp40_) * _tmp41_, _tmp42_);
			_tmp43_ = ctx;
			cairo_stroke_preserve (_tmp43_);
			_tmp44_ = ctx;
			cairo_fill (_tmp44_);
			_gpx_point_unref0 (f);
		}
	}
	_tmp45_ = self->priv->highlight;
	if (_tmp45_ > ((time_t) 0)) {
		GpxPoint* f = NULL;
		GpxTrack* _tmp46_ = NULL;
		GList* _tmp47_ = NULL;
		GList* _tmp48_ = NULL;
		gconstpointer _tmp49_ = NULL;
		GpxPoint* _tmp50_ = NULL;
		gdouble elapsed_time = 0.0;
		GpxTrack* _tmp51_ = NULL;
		time_t _tmp52_ = 0;
		gdouble graph_width = 0.0;
		GtkAllocation _tmp53_ = {0};
		gint _tmp54_ = 0;
		gint _tmp55_ = 0;
		gdouble graph_height = 0.0;
		GtkAllocation _tmp56_ = {0};
		gint _tmp57_ = 0;
		gint _tmp58_ = 0;
		gdouble hl = 0.0;
		time_t _tmp59_ = 0;
		GpxPoint* _tmp60_ = NULL;
		time_t _tmp61_ = 0;
		gdouble _tmp62_ = 0.0;
		gdouble _tmp63_ = 0.0;
		cairo_t* _tmp64_ = NULL;
		cairo_t* _tmp65_ = NULL;
		gdouble _tmp66_ = 0.0;
		cairo_t* _tmp67_ = NULL;
		gdouble _tmp68_ = 0.0;
		gdouble _tmp69_ = 0.0;
		cairo_t* _tmp70_ = NULL;
		cairo_t* _tmp71_ = NULL;
		GpxPoint* _tmp72_ = NULL;
		_tmp46_ = self->track;
		_tmp47_ = _tmp46_->points;
		_tmp48_ = g_list_first (_tmp47_);
		_tmp49_ = _tmp48_->data;
		_tmp50_ = _gpx_point_ref0 ((GpxPoint*) _tmp49_);
		f = _tmp50_;
		_tmp51_ = self->track;
		_tmp52_ = gpx_track_get_total_time (_tmp51_);
		elapsed_time = (gdouble) _tmp52_;
		_tmp53_ = alloc;
		_tmp54_ = _tmp53_.width;
		_tmp55_ = self->priv->LEFT_OFFSET;
		graph_width = (gdouble) ((_tmp54_ - _tmp55_) - 10);
		_tmp56_ = alloc;
		_tmp57_ = _tmp56_.height;
		_tmp58_ = self->priv->BOTTOM_OFFSET;
		graph_height = (gdouble) ((_tmp57_ - 20) - _tmp58_);
		_tmp59_ = self->priv->highlight;
		_tmp60_ = f;
		_tmp61_ = gpx_point_get_time (_tmp60_);
		_tmp62_ = elapsed_time;
		_tmp63_ = graph_width;
		hl = ((_tmp59_ - _tmp61_) / _tmp62_) * _tmp63_;
		_tmp64_ = ctx;
		cairo_set_source_rgba (_tmp64_, 0.8, 0.2, 0.3, 0.8);
		_tmp65_ = ctx;
		_tmp66_ = hl;
		cairo_move_to (_tmp65_, _tmp66_, (gdouble) 0);
		_tmp67_ = ctx;
		_tmp68_ = hl;
		_tmp69_ = graph_height;
		cairo_line_to (_tmp67_, _tmp68_, _tmp69_);
		_tmp70_ = ctx;
		cairo_stroke_preserve (_tmp70_);
		_tmp71_ = ctx;
		cairo_fill (_tmp71_);
		_tmp72_ = self->priv->draw_current;
		if (_tmp72_ != NULL) {
			PangoLayout* layout = NULL;
			cairo_t* _tmp73_ = NULL;
			PangoLayout* _tmp74_ = NULL;
			gint w = 0;
			gint h = 0;
			gchar* text = NULL;
			gchar* _tmp75_ = NULL;
			gdouble x_pos = 0.0;
			const gchar* _tmp76_ = NULL;
			gchar* _tmp77_ = NULL;
			gchar* _tmp78_ = NULL;
			GpxPoint* _tmp79_ = NULL;
			gdouble _tmp80_ = 0.0;
			gchar* _tmp81_ = NULL;
			gchar* _tmp82_ = NULL;
			gchar* _tmp83_ = NULL;
			const gchar* _tmp84_ = NULL;
			const gchar* _tmp85_ = NULL;
			gchar* _tmp86_ = NULL;
			gchar* _tmp87_ = NULL;
			gchar* _tmp88_ = NULL;
			gchar* _tmp89_ = NULL;
			GpxPoint* _tmp90_ = NULL;
			gdouble _tmp91_ = 0.0;
			gchar* _tmp92_ = NULL;
			gchar* _tmp93_ = NULL;
			gchar* _tmp94_ = NULL;
			gchar* _tmp95_ = NULL;
			gchar* _tmp96_ = NULL;
			const gchar* _tmp97_ = NULL;
			const gchar* _tmp98_ = NULL;
			gchar* _tmp99_ = NULL;
			gchar* _tmp100_ = NULL;
			gchar* _tmp101_ = NULL;
			gchar* _tmp102_ = NULL;
			GpxPoint* _tmp103_ = NULL;
			gdouble _tmp104_ = 0.0;
			gchar* _tmp105_ = NULL;
			gchar* _tmp106_ = NULL;
			gchar* _tmp107_ = NULL;
			gchar* _tmp108_ = NULL;
			gchar* _tmp109_ = NULL;
			PangoFontDescription* _tmp110_ = NULL;
			PangoLayout* _tmp111_ = NULL;
			PangoFontDescription* _tmp112_ = NULL;
			PangoLayout* _tmp113_ = NULL;
			const gchar* _tmp114_ = NULL;
			PangoLayout* _tmp115_ = NULL;
			gint _tmp116_ = 0;
			gint _tmp117_ = 0;
			gdouble _tmp118_ = 0.0;
			gint _tmp119_ = 0;
			gdouble _tmp120_ = 0.0;
			gint _tmp121_ = 0;
			cairo_t* _tmp127_ = NULL;
			gdouble _tmp128_ = 0.0;
			gint _tmp129_ = 0;
			gdouble _tmp130_ = 0.0;
			gint _tmp131_ = 0;
			gint _tmp132_ = 0;
			cairo_t* _tmp133_ = NULL;
			cairo_t* _tmp134_ = NULL;
			cairo_t* _tmp135_ = NULL;
			cairo_t* _tmp136_ = NULL;
			cairo_t* _tmp137_ = NULL;
			gdouble _tmp138_ = 0.0;
			gint _tmp139_ = 0;
			gdouble _tmp140_ = 0.0;
			cairo_t* _tmp141_ = NULL;
			PangoLayout* _tmp142_ = NULL;
			cairo_t* _tmp143_ = NULL;
			cairo_t* _tmp144_ = NULL;
			_tmp73_ = ctx;
			_tmp74_ = pango_cairo_create_layout (_tmp73_);
			layout = _tmp74_;
			_tmp75_ = g_strdup ("");
			text = _tmp75_;
			x_pos = 0.0;
			_tmp76_ = _ ("Speed");
			_tmp77_ = g_strconcat (_tmp76_, ":\t", NULL);
			_tmp78_ = _tmp77_;
			_tmp79_ = self->priv->draw_current;
			_tmp80_ = _tmp79_->speed;
			_tmp81_ = gpx_viewer_misc_convert (_tmp80_, SPEED);
			_tmp82_ = _tmp81_;
			_tmp83_ = g_strconcat (_tmp78_, _tmp82_, NULL);
			_g_free0 (text);
			text = _tmp83_;
			_g_free0 (_tmp82_);
			_g_free0 (_tmp78_);
			_tmp84_ = text;
			_tmp85_ = _ ("Elevation");
			_tmp86_ = g_strconcat ("\n", _tmp85_, NULL);
			_tmp87_ = _tmp86_;
			_tmp88_ = g_strconcat (_tmp87_, ":\t", NULL);
			_tmp89_ = _tmp88_;
			_tmp90_ = self->priv->draw_current;
			_tmp91_ = _tmp90_->elevation;
			_tmp92_ = gpx_viewer_misc_convert (_tmp91_, ELEVATION);
			_tmp93_ = _tmp92_;
			_tmp94_ = g_strconcat (_tmp89_, _tmp93_, NULL);
			_tmp95_ = _tmp94_;
			_tmp96_ = g_strconcat (_tmp84_, _tmp95_, NULL);
			_g_free0 (text);
			text = _tmp96_;
			_g_free0 (_tmp95_);
			_g_free0 (_tmp93_);
			_g_free0 (_tmp89_);
			_g_free0 (_tmp87_);
			_tmp97_ = text;
			_tmp98_ = _ ("Distance");
			_tmp99_ = g_strconcat ("\n", _tmp98_, NULL);
			_tmp100_ = _tmp99_;
			_tmp101_ = g_strconcat (_tmp100_, ":\t", NULL);
			_tmp102_ = _tmp101_;
			_tmp103_ = self->priv->draw_current;
			_tmp104_ = _tmp103_->distance;
			_tmp105_ = gpx_viewer_misc_convert (_tmp104_, DISTANCE);
			_tmp106_ = _tmp105_;
			_tmp107_ = g_strconcat (_tmp102_, _tmp106_, NULL);
			_tmp108_ = _tmp107_;
			_tmp109_ = g_strconcat (_tmp97_, _tmp108_, NULL);
			_g_free0 (text);
			text = _tmp109_;
			_g_free0 (_tmp108_);
			_g_free0 (_tmp106_);
			_g_free0 (_tmp102_);
			_g_free0 (_tmp100_);
			_tmp110_ = self->priv->fd;
			pango_font_description_set_absolute_size (_tmp110_, (gdouble) (12 * 1024));
			_tmp111_ = layout;
			_tmp112_ = self->priv->fd;
			pango_layout_set_font_description (_tmp111_, _tmp112_);
			_tmp113_ = layout;
			_tmp114_ = text;
			pango_layout_set_text (_tmp113_, _tmp114_, -1);
			_tmp115_ = layout;
			pango_layout_get_pixel_size (_tmp115_, &_tmp116_, &_tmp117_);
			w = _tmp116_;
			h = _tmp117_;
			_tmp118_ = hl;
			_tmp119_ = w;
			x_pos = _tmp118_ - ((_tmp119_ + 8) / 2.0);
			_tmp120_ = x_pos;
			_tmp121_ = self->priv->LEFT_OFFSET;
			if (_tmp120_ < ((gdouble) (-_tmp121_))) {
				x_pos = 0.0;
			} else {
				gdouble _tmp122_ = 0.0;
				gint _tmp123_ = 0;
				gdouble _tmp124_ = 0.0;
				_tmp122_ = hl;
				_tmp123_ = w;
				_tmp124_ = graph_width;
				if ((_tmp122_ + ((_tmp123_ + 8) / 2.0)) >= _tmp124_) {
					gdouble _tmp125_ = 0.0;
					gint _tmp126_ = 0;
					_tmp125_ = graph_width;
					_tmp126_ = w;
					x_pos = ((gdouble) _tmp125_) - ((gdouble) (_tmp126_ + 8.0));
				}
			}
			_tmp127_ = ctx;
			_tmp128_ = x_pos;
			_tmp129_ = h;
			_tmp130_ = MAX ((gdouble) ((-_tmp129_) - 2), (gdouble) (-18));
			_tmp131_ = w;
			_tmp132_ = h;
			cairo_rectangle (_tmp127_, _tmp128_, _tmp130_, (gdouble) (_tmp131_ + 8), (gdouble) (_tmp132_ + 4));
			_tmp133_ = ctx;
			cairo_set_source_rgba (_tmp133_, 0.0, 0.0, 0.0, 1.0);
			_tmp134_ = ctx;
			cairo_stroke_preserve (_tmp134_);
			_tmp135_ = ctx;
			cairo_set_source_rgba (_tmp135_, 0.7, 0.7, 0.7, 0.9);
			_tmp136_ = ctx;
			cairo_fill (_tmp136_);
			_tmp137_ = ctx;
			_tmp138_ = x_pos;
			_tmp139_ = h;
			_tmp140_ = MAX ((gdouble) (-_tmp139_), (gdouble) (-16));
			cairo_move_to (_tmp137_, _tmp138_ + 4, _tmp140_);
			_tmp141_ = ctx;
			_tmp142_ = layout;
			pango_cairo_layout_path (_tmp141_, _tmp142_);
			_tmp143_ = ctx;
			cairo_set_source_rgba (_tmp143_, 0.0, 0.0, 0.0, 1.0);
			_tmp144_ = ctx;
			cairo_fill (_tmp144_);
			_g_free0 (text);
			_g_object_unref0 (layout);
		}
		_gpx_point_unref0 (f);
	}
	result = FALSE;
	return result;
}


/**
 * Draw the graph to the required surface.
 */
static void gpx_graph_draw_grid (GpxGraph* self, cairo_t* ctx, PangoLayout* layout, gdouble graph_width, gdouble graph_height, gdouble min_value, gdouble max_value, gdouble elapsed_time) {
	gdouble j = 0.0;
	gdouble step_size = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble range = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	cairo_t* _tmp3_ = NULL;
	PangoFontDescription* _tmp4_ = NULL;
	PangoLayout* _tmp5_ = NULL;
	PangoFontDescription* _tmp6_ = NULL;
	PangoLayout* _tmp7_ = NULL;
	gint wt = 0;
	gint ht = 0;
	PangoLayout* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gint _tmp13_ = 0;
	gdouble _tmp14_ = 0.0;
	cairo_t* _tmp60_ = NULL;
	cairo_t* _tmp61_ = NULL;
	cairo_t* _tmp62_ = NULL;
	cairo_t* _tmp63_ = NULL;
	gdouble _tmp64_ = 0.0;
	cairo_t* _tmp65_ = NULL;
	cairo_t* _tmp66_ = NULL;
	gdouble _tmp67_ = 0.0;
	gdouble _tmp68_ = 0.0;
	gdouble _tmp69_ = 0.0;
	gdouble _tmp70_ = 0.0;
	cairo_t* _tmp71_ = NULL;
	gdouble _tmp72_ = 0.0;
	gdouble _tmp73_ = 0.0;
	gdouble _tmp74_ = 0.0;
	gdouble _tmp75_ = 0.0;
	gdouble _tmp76_ = 0.0;
	cairo_t* _tmp77_ = NULL;
	GList* iter = NULL;
	GpxTrack* _tmp78_ = NULL;
	GList* _tmp79_ = NULL;
	GList* _tmp80_ = NULL;
	PangoFontDescription* _tmp81_ = NULL;
	PangoLayout* _tmp82_ = NULL;
	PangoFontDescription* _tmp83_ = NULL;
	guint interval = 0U;
	gdouble _tmp84_ = 0.0;
	gdouble _tmp85_ = 0.0;
	gint current = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (ctx != NULL);
	g_return_if_fail (layout != NULL);
	j = 0.0;
	_tmp0_ = graph_height;
	step_size = _tmp0_ / 8.0;
	_tmp1_ = max_value;
	_tmp2_ = min_value;
	range = _tmp1_ - _tmp2_;
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:385: Draw grid lines");
	_tmp3_ = ctx;
	cairo_set_source_rgba (_tmp3_, 0.0, 0.0, 0.0, 1.0);
	_tmp4_ = self->priv->fd;
	pango_font_description_set_absolute_size (_tmp4_, (gdouble) (12 * 1024));
	_tmp5_ = layout;
	_tmp6_ = self->priv->fd;
	pango_layout_set_font_description (_tmp5_, _tmp6_);
	_tmp7_ = layout;
	pango_layout_set_text (_tmp7_, "0.0", -1);
	_tmp8_ = layout;
	pango_layout_get_pixel_size (_tmp8_, &_tmp9_, &_tmp10_);
	wt = _tmp9_;
	ht = _tmp10_;
	_tmp11_ = graph_height;
	_tmp12_ = graph_height;
	_tmp13_ = ht;
	_tmp14_ = ceil ((_tmp12_ / (_tmp13_ + 10)) / 5);
	step_size = _tmp11_ / (_tmp14_ * 5);
	{
		gboolean _tmp15_ = FALSE;
		j = (gdouble) 0;
		_tmp15_ = TRUE;
		while (TRUE) {
			gboolean _tmp16_ = FALSE;
			gdouble _tmp19_ = 0.0;
			gdouble _tmp20_ = 0.0;
			gdouble speed = 0.0;
			gdouble _tmp21_ = 0.0;
			gdouble _tmp22_ = 0.0;
			gdouble _tmp23_ = 0.0;
			gdouble _tmp24_ = 0.0;
			gdouble _tmp25_ = 0.0;
			gchar* text = NULL;
			gdouble _tmp26_ = 0.0;
			gchar* _tmp27_ = NULL;
			gint w = 0;
			gint h = 0;
			cairo_t* _tmp28_ = NULL;
			PangoLayout* _tmp29_ = NULL;
			const gchar* _tmp30_ = NULL;
			PangoLayout* _tmp31_ = NULL;
			gint _tmp32_ = 0;
			gint _tmp33_ = 0;
			cairo_t* _tmp34_ = NULL;
			gint _tmp35_ = 0;
			gdouble _tmp36_ = 0.0;
			gint _tmp37_ = 0;
			cairo_t* _tmp38_ = NULL;
			PangoLayout* _tmp39_ = NULL;
			cairo_t* _tmp40_ = NULL;
			const gchar* _tmp41_ = NULL;
			cairo_t* _tmp42_ = NULL;
			gdouble _tmp43_ = 0.0;
			cairo_t* _tmp44_ = NULL;
			gdouble _tmp45_ = 0.0;
			cairo_t* _tmp46_ = NULL;
			gboolean _tmp47_ = FALSE;
			gdouble _tmp48_ = 0.0;
			gboolean _tmp51_ = FALSE;
			cairo_t* _tmp52_ = NULL;
			cairo_t* _tmp53_ = NULL;
			cairo_t* _tmp54_ = NULL;
			gdouble _tmp55_ = 0.0;
			cairo_t* _tmp56_ = NULL;
			gdouble _tmp57_ = 0.0;
			gdouble _tmp58_ = 0.0;
			cairo_t* _tmp59_ = NULL;
			_tmp16_ = _tmp15_;
			if (!_tmp16_) {
				gdouble _tmp17_ = 0.0;
				gdouble _tmp18_ = 0.0;
				_tmp17_ = j;
				_tmp18_ = step_size;
				j = _tmp17_ + _tmp18_;
			}
			_tmp15_ = FALSE;
			_tmp19_ = j;
			_tmp20_ = graph_height;
			if (!(_tmp19_ <= _tmp20_)) {
				break;
			}
			_tmp21_ = min_value;
			_tmp22_ = range;
			_tmp23_ = graph_height;
			_tmp24_ = j;
			_tmp25_ = graph_height;
			speed = _tmp21_ + (_tmp22_ * ((_tmp23_ - _tmp24_) / _tmp25_));
			_tmp26_ = speed;
			_tmp27_ = g_strdup_printf ("%.1f", _tmp26_);
			text = _tmp27_;
			_tmp28_ = ctx;
			cairo_set_source_rgba (_tmp28_, 0.0, 0.0, 0.0, 1.0);
			_tmp29_ = layout;
			_tmp30_ = text;
			pango_layout_set_text (_tmp29_, _tmp30_, -1);
			_tmp31_ = layout;
			pango_layout_get_pixel_size (_tmp31_, &_tmp32_, &_tmp33_);
			w = _tmp32_;
			h = _tmp33_;
			_tmp34_ = ctx;
			_tmp35_ = w;
			_tmp36_ = j;
			_tmp37_ = h;
			cairo_move_to (_tmp34_, (gdouble) ((-_tmp35_) - 5), _tmp36_ - (_tmp37_ / 2.0));
			_tmp38_ = ctx;
			_tmp39_ = layout;
			pango_cairo_layout_path (_tmp38_, _tmp39_);
			_tmp40_ = ctx;
			cairo_fill (_tmp40_);
			_tmp41_ = text;
			g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:407: Set speed tick: %s", _tmp41_);
			_tmp42_ = ctx;
			_tmp43_ = j;
			cairo_move_to (_tmp42_, (gdouble) (-4), _tmp43_);
			_tmp44_ = ctx;
			_tmp45_ = j;
			cairo_line_to (_tmp44_, (gdouble) 0, _tmp45_);
			_tmp46_ = ctx;
			cairo_stroke (_tmp46_);
			_tmp48_ = j;
			if (_tmp48_ <= 0.00001) {
				_tmp47_ = TRUE;
			} else {
				gdouble _tmp49_ = 0.0;
				gdouble _tmp50_ = 0.0;
				_tmp49_ = j;
				_tmp50_ = graph_height;
				_tmp47_ = _tmp49_ >= (_tmp50_ - 0.00001);
			}
			_tmp51_ = _tmp47_;
			if (_tmp51_) {
				_g_free0 (text);
				continue;
			}
			_tmp52_ = ctx;
			cairo_set_source_rgba (_tmp52_, 0.4, 0.4, 0.4, 0.6);
			_tmp53_ = ctx;
			cairo_set_line_width (_tmp53_, (gdouble) 1);
			_tmp54_ = ctx;
			_tmp55_ = j;
			cairo_move_to (_tmp54_, 0.0, _tmp55_);
			_tmp56_ = ctx;
			_tmp57_ = graph_width;
			_tmp58_ = j;
			cairo_line_to (_tmp56_, _tmp57_, _tmp58_);
			_tmp59_ = ctx;
			cairo_stroke (_tmp59_);
			_g_free0 (text);
		}
	}
	_tmp60_ = ctx;
	cairo_set_line_width (_tmp60_, 2.5);
	_tmp61_ = ctx;
	cairo_set_source_rgba (_tmp61_, 0.0, 0.0, 0.0, (gdouble) 1);
	_tmp62_ = ctx;
	cairo_move_to (_tmp62_, 0.0, 0.0);
	_tmp63_ = ctx;
	_tmp64_ = graph_height;
	cairo_line_to (_tmp63_, 0.0, _tmp64_);
	_tmp65_ = ctx;
	cairo_stroke (_tmp65_);
	_tmp66_ = ctx;
	_tmp67_ = graph_height;
	_tmp68_ = graph_height;
	_tmp69_ = range;
	_tmp70_ = min_value;
	cairo_line_to (_tmp66_, 0.0, _tmp67_ + ((_tmp68_ / _tmp69_) * _tmp70_));
	_tmp71_ = ctx;
	_tmp72_ = graph_width;
	_tmp73_ = graph_height;
	_tmp74_ = graph_height;
	_tmp75_ = range;
	_tmp76_ = min_value;
	cairo_line_to (_tmp71_, _tmp72_, _tmp73_ + ((_tmp74_ / _tmp75_) * _tmp76_));
	_tmp77_ = ctx;
	cairo_stroke (_tmp77_);
	_tmp78_ = self->track;
	_tmp79_ = _tmp78_->points;
	_tmp80_ = g_list_first (_tmp79_);
	iter = _tmp80_;
	_tmp81_ = self->priv->fd;
	pango_font_description_set_absolute_size (_tmp81_, (gdouble) (12 * 1024));
	_tmp82_ = layout;
	_tmp83_ = self->priv->fd;
	pango_layout_set_font_description (_tmp82_, _tmp83_);
	_tmp84_ = elapsed_time;
	_tmp85_ = graph_width;
	interval = ((guint) _tmp84_) / ((guint) (_tmp85_ / (5 * 12.0)));
	current = 0;
	{
		guint i = 0U;
		i = (guint) 0;
		{
			gboolean _tmp86_ = FALSE;
			_tmp86_ = TRUE;
			while (TRUE) {
				gboolean _tmp87_ = FALSE;
				gboolean _tmp90_ = FALSE;
				guint _tmp91_ = 0U;
				gdouble _tmp92_ = 0.0;
				gboolean _tmp94_ = FALSE;
				gdouble _tmp95_ = 0.0;
				guint _tmp96_ = 0U;
				gdouble _tmp97_ = 0.0;
				gint _tmp150_ = 0;
				_tmp87_ = _tmp86_;
				if (!_tmp87_) {
					guint _tmp88_ = 0U;
					guint _tmp89_ = 0U;
					_tmp88_ = i;
					_tmp89_ = interval;
					i = _tmp88_ + _tmp89_;
				}
				_tmp86_ = FALSE;
				_tmp91_ = i;
				_tmp92_ = elapsed_time;
				if (((gdouble) _tmp91_) < _tmp92_) {
					guint _tmp93_ = 0U;
					_tmp93_ = interval;
					_tmp90_ = _tmp93_ > ((guint) 0);
				} else {
					_tmp90_ = FALSE;
				}
				_tmp94_ = _tmp90_;
				if (!_tmp94_) {
					break;
				}
				_tmp95_ = graph_width;
				_tmp96_ = i;
				_tmp97_ = elapsed_time;
				if ((_tmp95_ * (1 - (_tmp96_ / _tmp97_))) > (2.5 * 12)) {
					gint w = 0;
					gint h = 0;
					gchar* text = NULL;
					guint _tmp98_ = 0U;
					guint _tmp99_ = 0U;
					gchar* _tmp100_ = NULL;
					PangoLayout* _tmp101_ = NULL;
					const gchar* _tmp102_ = NULL;
					PangoLayout* _tmp103_ = NULL;
					gint _tmp104_ = 0;
					gint _tmp105_ = 0;
					cairo_t* _tmp106_ = NULL;
					gdouble _tmp107_ = 0.0;
					guint _tmp108_ = 0U;
					gdouble _tmp109_ = 0.0;
					gint _tmp110_ = 0;
					gdouble _tmp111_ = 0.0;
					cairo_t* _tmp112_ = NULL;
					PangoLayout* _tmp113_ = NULL;
					cairo_t* _tmp114_ = NULL;
					cairo_t* _tmp115_ = NULL;
					cairo_t* _tmp116_ = NULL;
					const gchar* _tmp117_ = NULL;
					cairo_t* _tmp118_ = NULL;
					cairo_t* _tmp119_ = NULL;
					cairo_t* _tmp120_ = NULL;
					gdouble _tmp121_ = 0.0;
					guint _tmp122_ = 0U;
					gdouble _tmp123_ = 0.0;
					gdouble _tmp124_ = 0.0;
					cairo_t* _tmp125_ = NULL;
					gdouble _tmp126_ = 0.0;
					guint _tmp127_ = 0U;
					gdouble _tmp128_ = 0.0;
					gdouble _tmp129_ = 0.0;
					cairo_t* _tmp130_ = NULL;
					cairo_t* _tmp131_ = NULL;
					cairo_t* _tmp132_ = NULL;
					cairo_t* _tmp133_ = NULL;
					gdouble _tmp134_ = 0.0;
					guint _tmp135_ = 0U;
					gdouble _tmp136_ = 0.0;
					gdouble _tmp137_ = 0.0;
					gdouble _tmp138_ = 0.0;
					gdouble _tmp139_ = 0.0;
					gdouble _tmp140_ = 0.0;
					cairo_t* _tmp141_ = NULL;
					gdouble _tmp142_ = 0.0;
					guint _tmp143_ = 0U;
					gdouble _tmp144_ = 0.0;
					gdouble _tmp145_ = 0.0;
					gdouble _tmp146_ = 0.0;
					gdouble _tmp147_ = 0.0;
					gdouble _tmp148_ = 0.0;
					cairo_t* _tmp149_ = NULL;
					_tmp98_ = i;
					_tmp99_ = i;
					_tmp100_ = g_strdup_printf ("%02i:%02i", ((gint) _tmp98_) / 3600, (((gint) _tmp99_) % 3600) / 60);
					text = _tmp100_;
					_tmp101_ = layout;
					_tmp102_ = text;
					pango_layout_set_text (_tmp101_, _tmp102_, -1);
					_tmp103_ = layout;
					pango_layout_get_pixel_size (_tmp103_, &_tmp104_, &_tmp105_);
					w = _tmp104_;
					h = _tmp105_;
					_tmp106_ = ctx;
					_tmp107_ = graph_width;
					_tmp108_ = i;
					_tmp109_ = elapsed_time;
					_tmp110_ = w;
					_tmp111_ = graph_height;
					cairo_move_to (_tmp106_, (_tmp107_ * ((gdouble) (_tmp108_ / _tmp109_))) - (_tmp110_ / 2.0), _tmp111_ + 10);
					_tmp112_ = ctx;
					_tmp113_ = layout;
					pango_cairo_layout_path (_tmp112_, _tmp113_);
					_tmp114_ = ctx;
					cairo_set_line_width (_tmp114_, 1.0);
					_tmp115_ = ctx;
					cairo_set_source_rgba (_tmp115_, 0.0, 0.0, 0.0, 1.0);
					_tmp116_ = ctx;
					cairo_fill (_tmp116_);
					_tmp117_ = text;
					g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:455: Set time tick: %s", _tmp117_);
					_tmp118_ = ctx;
					cairo_set_source_rgba (_tmp118_, 0.4, 0.4, 0.4, 0.6);
					_tmp119_ = ctx;
					cairo_set_line_width (_tmp119_, (gdouble) 1);
					_tmp120_ = ctx;
					_tmp121_ = graph_width;
					_tmp122_ = i;
					_tmp123_ = elapsed_time;
					_tmp124_ = graph_height;
					cairo_move_to (_tmp120_, _tmp121_ * ((gdouble) (_tmp122_ / _tmp123_)), _tmp124_);
					_tmp125_ = ctx;
					_tmp126_ = graph_width;
					_tmp127_ = i;
					_tmp128_ = elapsed_time;
					_tmp129_ = graph_height;
					cairo_line_to (_tmp125_, _tmp126_ * ((gdouble) (_tmp127_ / _tmp128_)), _tmp129_ * 0);
					_tmp130_ = ctx;
					cairo_stroke (_tmp130_);
					_tmp131_ = ctx;
					cairo_set_line_width (_tmp131_, 1.5);
					_tmp132_ = ctx;
					cairo_set_source_rgba (_tmp132_, 0.0, 0.0, 0.0, 1.0);
					_tmp133_ = ctx;
					_tmp134_ = graph_width;
					_tmp135_ = i;
					_tmp136_ = elapsed_time;
					_tmp137_ = graph_height;
					_tmp138_ = graph_height;
					_tmp139_ = range;
					_tmp140_ = min_value;
					cairo_move_to (_tmp133_, _tmp134_ * ((gdouble) (_tmp135_ / _tmp136_)), _tmp137_ + ((_tmp138_ / _tmp139_) * _tmp140_));
					_tmp141_ = ctx;
					_tmp142_ = graph_width;
					_tmp143_ = i;
					_tmp144_ = elapsed_time;
					_tmp145_ = graph_height;
					_tmp146_ = graph_height;
					_tmp147_ = range;
					_tmp148_ = min_value;
					cairo_line_to (_tmp141_, _tmp142_ * ((gdouble) (_tmp143_ / _tmp144_)), (_tmp145_ + ((_tmp146_ / _tmp147_) * _tmp148_)) + 5);
					_tmp149_ = ctx;
					cairo_stroke (_tmp149_);
					_g_free0 (text);
				}
				_tmp150_ = current;
				current = _tmp150_ + 1;
			}
		}
	}
}


static gdouble gpx_graph_calculate_graph_point_value (GpxGraph* self, GList* ii) {
	gdouble result = 0.0;
	gdouble value = 0.0;
	GpxGraphGraphMode _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0.0);
	value = (gdouble) 0;
	_tmp0_ = self->priv->_mode;
	if (_tmp0_ == GPX_GRAPH_GRAPH_MODE_SPEED) {
		GList* _tmp1_ = NULL;
		gconstpointer _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		_tmp1_ = ii;
		_tmp2_ = _tmp1_->data;
		_tmp3_ = ((GpxPoint*) _tmp2_)->speed;
		value = _tmp3_;
	} else {
		GpxGraphGraphMode _tmp4_ = 0;
		_tmp4_ = self->priv->_mode;
		if (_tmp4_ == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
			GList* _tmp5_ = NULL;
			gconstpointer _tmp6_ = NULL;
			gdouble _tmp7_ = 0.0;
			_tmp5_ = ii;
			_tmp6_ = _tmp5_->data;
			_tmp7_ = ((GpxPoint*) _tmp6_)->elevation;
			value = _tmp7_;
		} else {
			GpxGraphGraphMode _tmp8_ = 0;
			_tmp8_ = self->priv->_mode;
			if (_tmp8_ == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
				GList* _tmp9_ = NULL;
				gconstpointer _tmp10_ = NULL;
				GList* _tmp11_ = NULL;
				GList* _tmp12_ = NULL;
				gconstpointer _tmp13_ = NULL;
				gdouble _tmp14_ = 0.0;
				_tmp9_ = ii;
				_tmp10_ = _tmp9_->data;
				_tmp11_ = ii;
				_tmp12_ = g_list_first (_tmp11_);
				_tmp13_ = _tmp12_->data;
				_tmp14_ = gpx_track_calculate_distance ((GpxPoint*) _tmp10_, (GpxPoint*) _tmp13_);
				value = _tmp14_;
			} else {
				gboolean _tmp15_ = FALSE;
				GpxGraphGraphMode _tmp16_ = 0;
				gboolean _tmp19_ = FALSE;
				_tmp16_ = self->priv->_mode;
				if (_tmp16_ == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H) {
					GList* _tmp17_ = NULL;
					GList* _tmp18_ = NULL;
					_tmp17_ = ii;
					_tmp18_ = _tmp17_->prev;
					_tmp15_ = _tmp18_ != NULL;
				} else {
					_tmp15_ = FALSE;
				}
				_tmp19_ = _tmp15_;
				if (_tmp19_) {
					GList* _tmp20_ = NULL;
					gconstpointer _tmp21_ = NULL;
					gdouble _tmp22_ = 0.0;
					GList* _tmp23_ = NULL;
					GList* _tmp24_ = NULL;
					gconstpointer _tmp25_ = NULL;
					gdouble _tmp26_ = 0.0;
					GList* _tmp27_ = NULL;
					gconstpointer _tmp28_ = NULL;
					time_t _tmp29_ = 0;
					GList* _tmp30_ = NULL;
					GList* _tmp31_ = NULL;
					gconstpointer _tmp32_ = NULL;
					time_t _tmp33_ = 0;
					_tmp20_ = ii;
					_tmp21_ = _tmp20_->data;
					_tmp22_ = ((GpxPoint*) _tmp21_)->speed;
					_tmp23_ = ii;
					_tmp24_ = _tmp23_->prev;
					_tmp25_ = _tmp24_->data;
					_tmp26_ = ((GpxPoint*) _tmp25_)->speed;
					_tmp27_ = ii;
					_tmp28_ = _tmp27_->data;
					_tmp29_ = gpx_point_get_time ((GpxPoint*) _tmp28_);
					_tmp30_ = ii;
					_tmp31_ = _tmp30_->prev;
					_tmp32_ = _tmp31_->data;
					_tmp33_ = gpx_point_get_time ((GpxPoint*) _tmp32_);
					value = (_tmp22_ - _tmp26_) / (3.6 * (_tmp29_ - _tmp33_));
				} else {
					gboolean _tmp34_ = FALSE;
					GpxGraphGraphMode _tmp35_ = 0;
					gboolean _tmp38_ = FALSE;
					_tmp35_ = self->priv->_mode;
					if (_tmp35_ == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
						GList* _tmp36_ = NULL;
						GList* _tmp37_ = NULL;
						_tmp36_ = ii;
						_tmp37_ = _tmp36_->prev;
						_tmp34_ = _tmp37_ != NULL;
					} else {
						_tmp34_ = FALSE;
					}
					_tmp38_ = _tmp34_;
					if (_tmp38_) {
						GList* _tmp39_ = NULL;
						gconstpointer _tmp40_ = NULL;
						gdouble _tmp41_ = 0.0;
						GList* _tmp42_ = NULL;
						GList* _tmp43_ = NULL;
						gconstpointer _tmp44_ = NULL;
						gdouble _tmp45_ = 0.0;
						GList* _tmp46_ = NULL;
						gconstpointer _tmp47_ = NULL;
						time_t _tmp48_ = 0;
						GList* _tmp49_ = NULL;
						GList* _tmp50_ = NULL;
						gconstpointer _tmp51_ = NULL;
						time_t _tmp52_ = 0;
						_tmp39_ = ii;
						_tmp40_ = _tmp39_->data;
						_tmp41_ = ((GpxPoint*) _tmp40_)->elevation;
						_tmp42_ = ii;
						_tmp43_ = _tmp42_->prev;
						_tmp44_ = _tmp43_->data;
						_tmp45_ = ((GpxPoint*) _tmp44_)->elevation;
						_tmp46_ = ii;
						_tmp47_ = _tmp46_->data;
						_tmp48_ = gpx_point_get_time ((GpxPoint*) _tmp47_);
						_tmp49_ = ii;
						_tmp50_ = _tmp49_->prev;
						_tmp51_ = _tmp50_->data;
						_tmp52_ = gpx_point_get_time ((GpxPoint*) _tmp51_);
						value = (_tmp41_ - _tmp45_) / (3.6 * (_tmp48_ - _tmp52_));
					}
				}
			}
		}
	}
	result = value;
	return result;
}


static gdouble gpx_graph_calculate_graph_point_smooth_value (GpxGraph* self, GList* iter) {
	gdouble result = 0.0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_smooth_factor;
	if (_tmp0_ == 1) {
		GList* _tmp1_ = NULL;
		gdouble _tmp2_ = 0.0;
		_tmp1_ = iter;
		_tmp2_ = gpx_graph_calculate_graph_point_value (self, _tmp1_);
		result = _tmp2_;
		return result;
	} else {
		gdouble speed = 0.0;
		GList* ii = NULL;
		GList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gboolean _tmp5_ = FALSE;
		GList* _tmp6_ = NULL;
		gconstpointer _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp10_ = FALSE;
		gint sf = 0;
		gint _tmp12_ = 0;
		gint i = 0;
		gint items = 0;
		GList* _tmp28_ = NULL;
		GList* _tmp29_ = NULL;
		gdouble _tmp48_ = 0.0;
		gint _tmp49_ = 0;
		speed = (gdouble) 0;
		_tmp3_ = iter;
		ii = _tmp3_;
		_tmp6_ = ii;
		_tmp7_ = _tmp6_->data;
		_tmp8_ = ((GpxPoint*) _tmp7_)->stopped;
		if (_tmp8_) {
			GpxGraphGraphMode _tmp9_ = 0;
			_tmp9_ = self->priv->_mode;
			_tmp5_ = _tmp9_ == GPX_GRAPH_GRAPH_MODE_SPEED;
		} else {
			_tmp5_ = FALSE;
		}
		_tmp10_ = _tmp5_;
		if (_tmp10_) {
			_tmp4_ = 1;
		} else {
			gint _tmp11_ = 0;
			_tmp11_ = self->priv->_smooth_factor;
			_tmp4_ = _tmp11_;
		}
		_tmp12_ = _tmp4_;
		sf = _tmp12_;
		items = 0;
		{
			gboolean _tmp13_ = FALSE;
			i = 0;
			_tmp13_ = TRUE;
			while (TRUE) {
				gboolean _tmp14_ = FALSE;
				gboolean _tmp16_ = FALSE;
				gint _tmp17_ = 0;
				gint _tmp18_ = 0;
				gboolean _tmp21_ = FALSE;
				gdouble _tmp22_ = 0.0;
				GList* _tmp23_ = NULL;
				gdouble _tmp24_ = 0.0;
				gint _tmp25_ = 0;
				GList* _tmp26_ = NULL;
				GList* _tmp27_ = NULL;
				_tmp14_ = _tmp13_;
				if (!_tmp14_) {
					gint _tmp15_ = 0;
					_tmp15_ = i;
					i = _tmp15_ + 1;
				}
				_tmp13_ = FALSE;
				_tmp17_ = i;
				_tmp18_ = sf;
				if (_tmp17_ < _tmp18_) {
					GList* _tmp19_ = NULL;
					GList* _tmp20_ = NULL;
					_tmp19_ = ii;
					_tmp20_ = _tmp19_->prev;
					_tmp16_ = _tmp20_ != NULL;
				} else {
					_tmp16_ = FALSE;
				}
				_tmp21_ = _tmp16_;
				if (!_tmp21_) {
					break;
				}
				_tmp22_ = speed;
				_tmp23_ = ii;
				_tmp24_ = gpx_graph_calculate_graph_point_value (self, _tmp23_);
				speed = _tmp22_ + _tmp24_;
				_tmp25_ = items;
				items = _tmp25_ + 1;
				_tmp26_ = ii;
				_tmp27_ = _tmp26_->prev;
				ii = _tmp27_;
			}
		}
		_tmp28_ = iter;
		_tmp29_ = _tmp28_->next;
		ii = _tmp29_;
		{
			gboolean _tmp30_ = FALSE;
			i = 1;
			_tmp30_ = TRUE;
			while (TRUE) {
				gboolean _tmp31_ = FALSE;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				gint _tmp35_ = 0;
				gint _tmp36_ = 0;
				gboolean _tmp38_ = FALSE;
				gboolean _tmp41_ = FALSE;
				gdouble _tmp42_ = 0.0;
				GList* _tmp43_ = NULL;
				gdouble _tmp44_ = 0.0;
				gint _tmp45_ = 0;
				GList* _tmp46_ = NULL;
				GList* _tmp47_ = NULL;
				_tmp31_ = _tmp30_;
				if (!_tmp31_) {
					gint _tmp32_ = 0;
					_tmp32_ = i;
					i = _tmp32_ + 1;
				}
				_tmp30_ = FALSE;
				_tmp35_ = i;
				_tmp36_ = sf;
				if (_tmp35_ < _tmp36_) {
					GList* _tmp37_ = NULL;
					_tmp37_ = ii;
					_tmp34_ = _tmp37_ != NULL;
				} else {
					_tmp34_ = FALSE;
				}
				_tmp38_ = _tmp34_;
				if (_tmp38_) {
					GList* _tmp39_ = NULL;
					GList* _tmp40_ = NULL;
					_tmp39_ = ii;
					_tmp40_ = _tmp39_->next;
					_tmp33_ = _tmp40_ != NULL;
				} else {
					_tmp33_ = FALSE;
				}
				_tmp41_ = _tmp33_;
				if (!_tmp41_) {
					break;
				}
				_tmp42_ = speed;
				_tmp43_ = ii;
				_tmp44_ = gpx_graph_calculate_graph_point_value (self, _tmp43_);
				speed = _tmp42_ + _tmp44_;
				_tmp45_ = items;
				items = _tmp45_ + 1;
				_tmp46_ = ii;
				_tmp47_ = _tmp46_->next;
				ii = _tmp47_;
			}
		}
		_tmp48_ = speed;
		_tmp49_ = items;
		speed = _tmp48_ / _tmp49_;
		result = speed;
		return result;
	}
}


static void gpx_graph_update_surface (GpxGraph* self, GtkWidget* win) {
	cairo_t* ctx = NULL;
	GtkWidget* _tmp0_ = NULL;
	GdkWindow* _tmp1_ = NULL;
	cairo_t* _tmp2_ = NULL;
	GtkAllocation alloc = {0};
	GtkWidget* _tmp3_ = NULL;
	GtkAllocation _tmp4_ = {0};
	cairo_t* _tmp5_ = NULL;
	cairo_surface_t* _tmp6_ = NULL;
	GtkAllocation _tmp7_ = {0};
	gint _tmp8_ = 0;
	GtkAllocation _tmp9_ = {0};
	gint _tmp10_ = 0;
	cairo_surface_t* _tmp11_ = NULL;
	cairo_surface_t* _tmp12_ = NULL;
	cairo_t* _tmp13_ = NULL;
	cairo_t* _tmp14_ = NULL;
	cairo_t* _tmp15_ = NULL;
	gboolean _tmp16_ = FALSE;
	GpxTrack* _tmp17_ = NULL;
	gboolean _tmp20_ = FALSE;
	gdouble max_value = 0.0;
	gdouble min_value = 0.0;
	gdouble range = 0.0;
	gboolean _tmp21_ = FALSE;
	GpxGraphGraphMode _tmp22_ = 0;
	gboolean _tmp24_ = FALSE;
	gdouble _tmp76_ = 0.0;
	gdouble _tmp77_ = 0.0;
	gdouble _tmp78_ = 0.0;
	gdouble _tmp79_ = 0.0;
	gdouble elapsed_time = 0.0;
	GpxTrack* _tmp80_ = NULL;
	time_t _tmp81_ = 0;
	cairo_t* _tmp82_ = NULL;
	gint _tmp83_ = 0;
	GpxPoint* f = NULL;
	GpxTrack* _tmp84_ = NULL;
	GList* _tmp85_ = NULL;
	gconstpointer _tmp86_ = NULL;
	GpxPoint* _tmp87_ = NULL;
	gdouble graph_width = 0.0;
	GtkAllocation _tmp88_ = {0};
	gint _tmp89_ = 0;
	gint _tmp90_ = 0;
	gdouble graph_height = 0.0;
	GtkAllocation _tmp91_ = {0};
	gint _tmp92_ = 0;
	gint _tmp93_ = 0;
	gdouble _tmp94_ = 0.0;
	PangoLayout* layout = NULL;
	cairo_t* _tmp95_ = NULL;
	PangoLayout* _tmp96_ = NULL;
	cairo_t* _tmp97_ = NULL;
	PangoLayout* _tmp98_ = NULL;
	gdouble _tmp99_ = 0.0;
	gdouble _tmp100_ = 0.0;
	gdouble _tmp101_ = 0.0;
	gdouble _tmp102_ = 0.0;
	gdouble _tmp103_ = 0.0;
	cairo_t* _tmp104_ = NULL;
	cairo_t* _tmp105_ = NULL;
	GList* iter = NULL;
	GpxTrack* _tmp106_ = NULL;
	GList* _tmp107_ = NULL;
	GList* _tmp108_ = NULL;
	gboolean _tmp109_ = FALSE;
	gdouble _tmp110_ = 0.0;
	gboolean _tmp112_ = FALSE;
	gboolean _tmp180_ = FALSE;
	gdouble _tmp181_ = 0.0;
	gboolean _tmp183_ = FALSE;
	cairo_t* _tmp192_ = NULL;
	cairo_t* _tmp193_ = NULL;
	cairo_t* _tmp194_ = NULL;
	cairo_t* _tmp195_ = NULL;
	gboolean _tmp196_ = FALSE;
	gboolean _tmp197_ = FALSE;
	GpxGraphGraphMode _tmp229_ = 0;
	gint w = 0;
	gint h = 0;
	cairo_t* _tmp268_ = NULL;
	PangoFontDescription* _tmp269_ = NULL;
	PangoLayout* _tmp270_ = NULL;
	PangoFontDescription* _tmp271_ = NULL;
	gchar* mtext = NULL;
	gchar* _tmp272_ = NULL;
	gboolean _tmp273_ = FALSE;
	gint _tmp284_ = 0;
	PangoLayout* _tmp295_ = NULL;
	gint _tmp296_ = 0;
	gint _tmp297_ = 0;
	cairo_t* _tmp298_ = NULL;
	gdouble _tmp299_ = 0.0;
	gint _tmp300_ = 0;
	cairo_t* _tmp301_ = NULL;
	PangoLayout* _tmp302_ = NULL;
	cairo_t* _tmp303_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (win != NULL);
	_tmp0_ = win;
	_tmp1_ = gtk_widget_get_window (_tmp0_);
	_tmp2_ = gdk_cairo_create (_tmp1_);
	ctx = _tmp2_;
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:525: Updating surface");
	_tmp3_ = win;
	gtk_widget_get_allocation (_tmp3_, &_tmp4_);
	alloc = _tmp4_;
	_tmp5_ = ctx;
	_tmp6_ = cairo_get_target (_tmp5_);
	_tmp7_ = alloc;
	_tmp8_ = _tmp7_.width;
	_tmp9_ = alloc;
	_tmp10_ = _tmp9_.height;
	_tmp11_ = cairo_surface_create_similar (_tmp6_, CAIRO_CONTENT_COLOR_ALPHA, _tmp8_, _tmp10_);
	_cairo_surface_destroy0 (self->priv->surf);
	self->priv->surf = _tmp11_;
	_tmp12_ = self->priv->surf;
	_tmp13_ = cairo_create (_tmp12_);
	_cairo_destroy0 (ctx);
	ctx = _tmp13_;
	_tmp14_ = ctx;
	cairo_set_source_rgba (_tmp14_, (gdouble) 1, (gdouble) 1, (gdouble) 1, (gdouble) 1);
	_tmp15_ = ctx;
	cairo_paint (_tmp15_);
	_tmp17_ = self->track;
	if (_tmp17_ == NULL) {
		_tmp16_ = TRUE;
	} else {
		GpxTrack* _tmp18_ = NULL;
		GList* _tmp19_ = NULL;
		_tmp18_ = self->track;
		_tmp19_ = _tmp18_->points;
		_tmp16_ = _tmp19_ == NULL;
	}
	_tmp20_ = _tmp16_;
	if (_tmp20_) {
		_cairo_destroy0 (ctx);
		return;
	}
	max_value = (gdouble) 0;
	min_value = (gdouble) 0;
	range = (gdouble) 0;
	_tmp22_ = self->priv->_mode;
	if (_tmp22_ == GPX_GRAPH_GRAPH_MODE_SPEED) {
		_tmp21_ = TRUE;
	} else {
		GpxGraphGraphMode _tmp23_ = 0;
		_tmp23_ = self->priv->_mode;
		_tmp21_ = _tmp23_ == GPX_GRAPH_GRAPH_MODE_DISTANCE;
	}
	_tmp24_ = _tmp21_;
	if (_tmp24_) {
		GList* iter = NULL;
		GpxTrack* _tmp25_ = NULL;
		GList* _tmp26_ = NULL;
		GList* _tmp27_ = NULL;
		_tmp25_ = self->track;
		_tmp26_ = _tmp25_->points;
		_tmp27_ = g_list_first (_tmp26_);
		iter = _tmp27_;
		while (TRUE) {
			GList* _tmp28_ = NULL;
			GList* _tmp29_ = NULL;
			GList* ii = NULL;
			GList* _tmp30_ = NULL;
			GList* _tmp31_ = NULL;
			gdouble speed = 0.0;
			GList* _tmp32_ = NULL;
			gdouble _tmp33_ = 0.0;
			gdouble _tmp34_ = 0.0;
			gdouble _tmp35_ = 0.0;
			gdouble _tmp36_ = 0.0;
			gdouble _tmp37_ = 0.0;
			gdouble _tmp40_ = 0.0;
			GList* _tmp41_ = NULL;
			GList* _tmp42_ = NULL;
			_tmp28_ = iter;
			_tmp29_ = _tmp28_->next;
			if (!(_tmp29_ != NULL)) {
				break;
			}
			_tmp30_ = iter;
			_tmp31_ = _tmp30_->next;
			ii = _tmp31_;
			_tmp32_ = ii;
			_tmp33_ = gpx_graph_calculate_graph_point_smooth_value (self, _tmp32_);
			_tmp34_ = min_value;
			speed = _tmp33_ - _tmp34_;
			_tmp36_ = speed;
			_tmp37_ = max_value;
			if (_tmp36_ > _tmp37_) {
				gdouble _tmp38_ = 0.0;
				_tmp38_ = speed;
				_tmp35_ = _tmp38_;
			} else {
				gdouble _tmp39_ = 0.0;
				_tmp39_ = max_value;
				_tmp35_ = _tmp39_;
			}
			_tmp40_ = _tmp35_;
			max_value = _tmp40_;
			_tmp41_ = iter;
			_tmp42_ = _tmp41_->next;
			iter = _tmp42_;
		}
	} else {
		GpxGraphGraphMode _tmp43_ = 0;
		_tmp43_ = self->priv->_mode;
		if (_tmp43_ == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
			GpxTrack* _tmp44_ = NULL;
			gdouble _tmp45_ = 0.0;
			GpxTrack* _tmp46_ = NULL;
			gdouble _tmp47_ = 0.0;
			_tmp44_ = self->track;
			_tmp45_ = _tmp44_->max_elevation;
			max_value = _tmp45_;
			_tmp46_ = self->track;
			_tmp47_ = _tmp46_->min_elevation;
			min_value = _tmp47_;
		} else {
			gboolean _tmp48_ = FALSE;
			GpxGraphGraphMode _tmp49_ = 0;
			gboolean _tmp51_ = FALSE;
			_tmp49_ = self->priv->_mode;
			if (_tmp49_ == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
				_tmp48_ = TRUE;
			} else {
				GpxGraphGraphMode _tmp50_ = 0;
				_tmp50_ = self->priv->_mode;
				_tmp48_ = _tmp50_ == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H;
			}
			_tmp51_ = _tmp48_;
			if (_tmp51_) {
				GList* iter = NULL;
				GpxTrack* _tmp52_ = NULL;
				GList* _tmp53_ = NULL;
				GList* _tmp54_ = NULL;
				_tmp52_ = self->track;
				_tmp53_ = _tmp52_->points;
				_tmp54_ = g_list_first (_tmp53_);
				iter = _tmp54_;
				while (TRUE) {
					GList* _tmp55_ = NULL;
					GList* _tmp56_ = NULL;
					GList* ii = NULL;
					GList* _tmp57_ = NULL;
					GList* _tmp58_ = NULL;
					gdouble speed = 0.0;
					GList* _tmp59_ = NULL;
					gdouble _tmp60_ = 0.0;
					gdouble _tmp61_ = 0.0;
					gdouble _tmp62_ = 0.0;
					gdouble _tmp63_ = 0.0;
					gdouble _tmp64_ = 0.0;
					gdouble _tmp67_ = 0.0;
					gdouble _tmp68_ = 0.0;
					gdouble _tmp69_ = 0.0;
					gdouble _tmp70_ = 0.0;
					gdouble _tmp73_ = 0.0;
					GList* _tmp74_ = NULL;
					GList* _tmp75_ = NULL;
					_tmp55_ = iter;
					_tmp56_ = _tmp55_->next;
					if (!(_tmp56_ != NULL)) {
						break;
					}
					_tmp57_ = iter;
					_tmp58_ = _tmp57_->next;
					ii = _tmp58_;
					_tmp59_ = ii;
					_tmp60_ = gpx_graph_calculate_graph_point_smooth_value (self, _tmp59_);
					_tmp61_ = min_value;
					speed = _tmp60_ - _tmp61_;
					_tmp63_ = speed;
					_tmp64_ = max_value;
					if (_tmp63_ > _tmp64_) {
						gdouble _tmp65_ = 0.0;
						_tmp65_ = speed;
						_tmp62_ = _tmp65_;
					} else {
						gdouble _tmp66_ = 0.0;
						_tmp66_ = max_value;
						_tmp62_ = _tmp66_;
					}
					_tmp67_ = _tmp62_;
					max_value = _tmp67_;
					_tmp69_ = speed;
					_tmp70_ = min_value;
					if (_tmp69_ < _tmp70_) {
						gdouble _tmp71_ = 0.0;
						_tmp71_ = speed;
						_tmp68_ = _tmp71_;
					} else {
						gdouble _tmp72_ = 0.0;
						_tmp72_ = min_value;
						_tmp68_ = _tmp72_;
					}
					_tmp73_ = _tmp68_;
					min_value = _tmp73_;
					_tmp74_ = iter;
					_tmp75_ = _tmp74_->next;
					iter = _tmp75_;
				}
			}
		}
	}
	_tmp76_ = max_value;
	_tmp77_ = ceil (_tmp76_);
	max_value = _tmp77_;
	_tmp78_ = max_value;
	_tmp79_ = min_value;
	range = _tmp78_ - _tmp79_;
	_tmp80_ = self->track;
	_tmp81_ = gpx_track_get_total_time (_tmp80_);
	elapsed_time = (gdouble) _tmp81_;
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:575: Draw Axis");
	_tmp82_ = ctx;
	_tmp83_ = self->priv->LEFT_OFFSET;
	cairo_translate (_tmp82_, (gdouble) _tmp83_, (gdouble) 20);
	_tmp84_ = self->track;
	_tmp85_ = _tmp84_->points;
	_tmp86_ = _tmp85_->data;
	_tmp87_ = _gpx_point_ref0 ((GpxPoint*) _tmp86_);
	f = _tmp87_;
	_tmp88_ = alloc;
	_tmp89_ = _tmp88_.width;
	_tmp90_ = self->priv->LEFT_OFFSET;
	graph_width = (gdouble) ((_tmp89_ - _tmp90_) - 10);
	_tmp91_ = alloc;
	_tmp92_ = _tmp91_.height;
	_tmp93_ = self->priv->BOTTOM_OFFSET;
	graph_height = (gdouble) ((_tmp92_ - 20) - _tmp93_);
	_tmp94_ = graph_height;
	if (_tmp94_ < ((gdouble) 50)) {
		_gpx_point_unref0 (f);
		_cairo_destroy0 (ctx);
		return;
	}
	_tmp95_ = ctx;
	_tmp96_ = pango_cairo_create_layout (_tmp95_);
	layout = _tmp96_;
	_tmp97_ = ctx;
	_tmp98_ = layout;
	_tmp99_ = graph_width;
	_tmp100_ = graph_height;
	_tmp101_ = min_value;
	_tmp102_ = max_value;
	_tmp103_ = elapsed_time;
	gpx_graph_draw_grid (self, _tmp97_, _tmp98_, _tmp99_, _tmp100_, _tmp101_, _tmp102_, _tmp103_);
	_tmp104_ = ctx;
	cairo_set_source_rgba (_tmp104_, 0.1, 0.2, 0.3, (gdouble) 1);
	_tmp105_ = ctx;
	cairo_set_line_width (_tmp105_, (gdouble) 1);
	_tmp106_ = self->track;
	_tmp107_ = _tmp106_->points;
	_tmp108_ = g_list_first (_tmp107_);
	iter = _tmp108_;
	_tmp110_ = min_value;
	if (_tmp110_ < ((gdouble) 0)) {
		gdouble _tmp111_ = 0.0;
		_tmp111_ = max_value;
		_tmp109_ = _tmp111_ > ((gdouble) 0);
	} else {
		_tmp109_ = FALSE;
	}
	_tmp112_ = _tmp109_;
	if (_tmp112_) {
		cairo_t* _tmp113_ = NULL;
		gdouble _tmp114_ = 0.0;
		gdouble _tmp115_ = 0.0;
		gdouble _tmp116_ = 0.0;
		_tmp113_ = ctx;
		_tmp114_ = graph_height;
		_tmp115_ = max_value;
		_tmp116_ = range;
		cairo_move_to (_tmp113_, 0.0, _tmp114_ * (_tmp115_ / _tmp116_));
	} else {
		cairo_t* _tmp117_ = NULL;
		gdouble _tmp118_ = 0.0;
		_tmp117_ = ctx;
		_tmp118_ = graph_height;
		cairo_move_to (_tmp117_, 0.0, _tmp118_);
	}
	while (TRUE) {
		GList* _tmp119_ = NULL;
		GList* _tmp120_ = NULL;
		gdouble time_offset = 0.0;
		GList* _tmp121_ = NULL;
		gconstpointer _tmp122_ = NULL;
		time_t _tmp123_ = 0;
		GpxPoint* _tmp124_ = NULL;
		time_t _tmp125_ = 0;
		gdouble speed = 0.0;
		GList* _tmp126_ = NULL;
		gdouble _tmp127_ = 0.0;
		gdouble _tmp128_ = 0.0;
		GpxGraphGraphMode _tmp129_ = 0;
		GList* _tmp178_ = NULL;
		GList* _tmp179_ = NULL;
		_tmp119_ = iter;
		_tmp120_ = _tmp119_->next;
		if (!(_tmp120_ != NULL)) {
			break;
		}
		_tmp121_ = iter;
		_tmp122_ = _tmp121_->data;
		_tmp123_ = gpx_point_get_time ((GpxPoint*) _tmp122_);
		_tmp124_ = f;
		_tmp125_ = gpx_point_get_time (_tmp124_);
		time_offset = (gdouble) (_tmp123_ - _tmp125_);
		_tmp126_ = iter;
		_tmp127_ = gpx_graph_calculate_graph_point_smooth_value (self, _tmp126_);
		_tmp128_ = min_value;
		speed = _tmp127_ - _tmp128_;
		_tmp129_ = self->priv->_mode;
		if (_tmp129_ == GPX_GRAPH_GRAPH_MODE_SPEED) {
			gboolean _tmp130_ = FALSE;
			GList* _tmp131_ = NULL;
			GList* _tmp132_ = NULL;
			gboolean _tmp137_ = FALSE;
			GList* _tmp143_ = NULL;
			gconstpointer _tmp144_ = NULL;
			gboolean _tmp145_ = FALSE;
			gboolean _tmp158_ = FALSE;
			GList* _tmp159_ = NULL;
			GList* _tmp160_ = NULL;
			gboolean _tmp165_ = FALSE;
			_tmp131_ = iter;
			_tmp132_ = _tmp131_->prev;
			if (_tmp132_ != NULL) {
				GList* _tmp133_ = NULL;
				GList* _tmp134_ = NULL;
				gconstpointer _tmp135_ = NULL;
				gboolean _tmp136_ = FALSE;
				_tmp133_ = iter;
				_tmp134_ = _tmp133_->prev;
				_tmp135_ = _tmp134_->data;
				_tmp136_ = ((GpxPoint*) _tmp135_)->stopped;
				_tmp130_ = _tmp136_;
			} else {
				_tmp130_ = FALSE;
			}
			_tmp137_ = _tmp130_;
			if (_tmp137_) {
				cairo_t* _tmp138_ = NULL;
				gdouble _tmp139_ = 0.0;
				gdouble _tmp140_ = 0.0;
				gdouble _tmp141_ = 0.0;
				gdouble _tmp142_ = 0.0;
				_tmp138_ = ctx;
				_tmp139_ = graph_width;
				_tmp140_ = time_offset;
				_tmp141_ = elapsed_time;
				_tmp142_ = graph_height;
				cairo_line_to (_tmp138_, _tmp139_ * ((gdouble) (_tmp140_ / ((gdouble) _tmp141_))), _tmp142_);
			}
			_tmp143_ = iter;
			_tmp144_ = _tmp143_->data;
			_tmp145_ = ((GpxPoint*) _tmp144_)->stopped;
			if (_tmp145_) {
				cairo_t* _tmp146_ = NULL;
				gdouble _tmp147_ = 0.0;
				gdouble _tmp148_ = 0.0;
				gdouble _tmp149_ = 0.0;
				gdouble _tmp150_ = 0.0;
				_tmp146_ = ctx;
				_tmp147_ = graph_width;
				_tmp148_ = time_offset;
				_tmp149_ = elapsed_time;
				_tmp150_ = graph_height;
				cairo_line_to (_tmp146_, _tmp147_ * ((gdouble) (_tmp148_ / ((gdouble) _tmp149_))), _tmp150_);
			} else {
				cairo_t* _tmp151_ = NULL;
				gdouble _tmp152_ = 0.0;
				gdouble _tmp153_ = 0.0;
				gdouble _tmp154_ = 0.0;
				gdouble _tmp155_ = 0.0;
				gdouble _tmp156_ = 0.0;
				gdouble _tmp157_ = 0.0;
				_tmp151_ = ctx;
				_tmp152_ = graph_width;
				_tmp153_ = time_offset;
				_tmp154_ = elapsed_time;
				_tmp155_ = graph_height;
				_tmp156_ = speed;
				_tmp157_ = range;
				cairo_line_to (_tmp151_, _tmp152_ * ((gdouble) (_tmp153_ / ((gdouble) _tmp154_))), _tmp155_ * ((gdouble) (1.0 - (_tmp156_ / _tmp157_))));
			}
			_tmp159_ = iter;
			_tmp160_ = _tmp159_->next;
			if (_tmp160_ != NULL) {
				GList* _tmp161_ = NULL;
				GList* _tmp162_ = NULL;
				gconstpointer _tmp163_ = NULL;
				gboolean _tmp164_ = FALSE;
				_tmp161_ = iter;
				_tmp162_ = _tmp161_->next;
				_tmp163_ = _tmp162_->data;
				_tmp164_ = ((GpxPoint*) _tmp163_)->stopped;
				_tmp158_ = _tmp164_;
			} else {
				_tmp158_ = FALSE;
			}
			_tmp165_ = _tmp158_;
			if (_tmp165_) {
				cairo_t* _tmp166_ = NULL;
				gdouble _tmp167_ = 0.0;
				gdouble _tmp168_ = 0.0;
				gdouble _tmp169_ = 0.0;
				gdouble _tmp170_ = 0.0;
				_tmp166_ = ctx;
				_tmp167_ = graph_width;
				_tmp168_ = time_offset;
				_tmp169_ = elapsed_time;
				_tmp170_ = graph_height;
				cairo_line_to (_tmp166_, _tmp167_ * ((gdouble) (_tmp168_ / ((gdouble) _tmp169_))), _tmp170_ * ((gdouble) 1.0));
			}
		} else {
			cairo_t* _tmp171_ = NULL;
			gdouble _tmp172_ = 0.0;
			gdouble _tmp173_ = 0.0;
			gdouble _tmp174_ = 0.0;
			gdouble _tmp175_ = 0.0;
			gdouble _tmp176_ = 0.0;
			gdouble _tmp177_ = 0.0;
			_tmp171_ = ctx;
			_tmp172_ = graph_width;
			_tmp173_ = time_offset;
			_tmp174_ = elapsed_time;
			_tmp175_ = graph_height;
			_tmp176_ = speed;
			_tmp177_ = range;
			cairo_line_to (_tmp171_, _tmp172_ * ((gdouble) (_tmp173_ / ((gdouble) _tmp174_))), _tmp175_ * ((gdouble) (1.0 - (_tmp176_ / _tmp177_))));
		}
		_tmp178_ = iter;
		_tmp179_ = _tmp178_->next;
		iter = _tmp179_;
	}
	_tmp181_ = min_value;
	if (_tmp181_ < ((gdouble) 0)) {
		gdouble _tmp182_ = 0.0;
		_tmp182_ = max_value;
		_tmp180_ = _tmp182_ > ((gdouble) 0);
	} else {
		_tmp180_ = FALSE;
	}
	_tmp183_ = _tmp180_;
	if (_tmp183_) {
		cairo_t* _tmp184_ = NULL;
		gdouble _tmp185_ = 0.0;
		gdouble _tmp186_ = 0.0;
		gdouble _tmp187_ = 0.0;
		gdouble _tmp188_ = 0.0;
		_tmp184_ = ctx;
		_tmp185_ = graph_width;
		_tmp186_ = graph_height;
		_tmp187_ = max_value;
		_tmp188_ = range;
		cairo_line_to (_tmp184_, _tmp185_, _tmp186_ * (_tmp187_ / _tmp188_));
	} else {
		cairo_t* _tmp189_ = NULL;
		gdouble _tmp190_ = 0.0;
		gdouble _tmp191_ = 0.0;
		_tmp189_ = ctx;
		_tmp190_ = graph_width;
		_tmp191_ = graph_height;
		cairo_line_to (_tmp189_, _tmp190_, _tmp191_ * 1);
	}
	_tmp192_ = ctx;
	cairo_close_path (_tmp192_);
	_tmp193_ = ctx;
	cairo_stroke_preserve (_tmp193_);
	_tmp194_ = ctx;
	cairo_set_source_rgba (_tmp194_, 0.6, 0.8, 0.9, 0.8);
	_tmp195_ = ctx;
	cairo_fill (_tmp195_);
	_tmp196_ = gpx_graph_get_show_points (self);
	_tmp197_ = _tmp196_;
	if (_tmp197_) {
		cairo_t* _tmp198_ = NULL;
		GpxTrack* _tmp199_ = NULL;
		GList* _tmp200_ = NULL;
		GList* _tmp201_ = NULL;
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:651: Draw data points");
		_tmp198_ = ctx;
		cairo_set_source_rgba (_tmp198_, 0.0, 0.0, 0.0, 1.0);
		_tmp199_ = self->track;
		_tmp200_ = _tmp199_->points;
		_tmp201_ = g_list_first (_tmp200_);
		iter = _tmp201_;
		while (TRUE) {
			GList* _tmp202_ = NULL;
			GList* _tmp203_ = NULL;
			GList* ii = NULL;
			GList* _tmp204_ = NULL;
			GList* _tmp205_ = NULL;
			gdouble time_offset = 0.0;
			GList* _tmp206_ = NULL;
			gconstpointer _tmp207_ = NULL;
			time_t _tmp208_ = 0;
			GpxPoint* _tmp209_ = NULL;
			time_t _tmp210_ = 0;
			gdouble speed = 0.0;
			GList* _tmp211_ = NULL;
			gdouble _tmp212_ = 0.0;
			gdouble _tmp213_ = 0.0;
			GList* _tmp214_ = NULL;
			gconstpointer _tmp215_ = NULL;
			gboolean _tmp216_ = FALSE;
			cairo_t* _tmp219_ = NULL;
			gdouble _tmp220_ = 0.0;
			gdouble _tmp221_ = 0.0;
			gdouble _tmp222_ = 0.0;
			gdouble _tmp223_ = 0.0;
			gdouble _tmp224_ = 0.0;
			gdouble _tmp225_ = 0.0;
			cairo_t* _tmp226_ = NULL;
			GList* _tmp227_ = NULL;
			GList* _tmp228_ = NULL;
			_tmp202_ = iter;
			_tmp203_ = _tmp202_->next;
			if (!(_tmp203_ != NULL)) {
				break;
			}
			_tmp204_ = iter;
			_tmp205_ = _tmp204_->next;
			ii = _tmp205_;
			_tmp206_ = ii;
			_tmp207_ = _tmp206_->data;
			_tmp208_ = gpx_point_get_time ((GpxPoint*) _tmp207_);
			_tmp209_ = f;
			_tmp210_ = gpx_point_get_time (_tmp209_);
			time_offset = (gdouble) (_tmp208_ - _tmp210_);
			_tmp211_ = ii;
			_tmp212_ = gpx_graph_calculate_graph_point_smooth_value (self, _tmp211_);
			_tmp213_ = min_value;
			speed = _tmp212_ - _tmp213_;
			_tmp214_ = ii;
			_tmp215_ = _tmp214_->data;
			_tmp216_ = ((GpxPoint*) _tmp215_)->stopped;
			if (_tmp216_) {
				cairo_t* _tmp217_ = NULL;
				_tmp217_ = ctx;
				cairo_set_source_rgba (_tmp217_, 1.0, 0.0, 0.0, 1.0);
			} else {
				cairo_t* _tmp218_ = NULL;
				_tmp218_ = ctx;
				cairo_set_source_rgba (_tmp218_, 0.0, 0.0, 0.0, 1.0);
			}
			_tmp219_ = ctx;
			_tmp220_ = graph_width;
			_tmp221_ = time_offset;
			_tmp222_ = elapsed_time;
			_tmp223_ = graph_height;
			_tmp224_ = speed;
			_tmp225_ = range;
			cairo_rectangle (_tmp219_, (_tmp220_ * ((gdouble) (_tmp221_ / ((gdouble) _tmp222_)))) - 1, (_tmp223_ * ((gdouble) (1.0 - (_tmp224_ / _tmp225_)))) - 1, (gdouble) 2, (gdouble) 2);
			_tmp226_ = ctx;
			cairo_stroke (_tmp226_);
			_tmp227_ = iter;
			_tmp228_ = _tmp227_->next;
			iter = _tmp228_;
		}
	}
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:673: Draw graph");
	_tmp229_ = self->priv->_mode;
	if (_tmp229_ == GPX_GRAPH_GRAPH_MODE_SPEED) {
		gdouble avg = 0.0;
		GpxTrack* _tmp230_ = NULL;
		gdouble _tmp231_ = 0.0;
		cairo_t* _tmp232_ = NULL;
		gdouble _tmp233_ = 0.0;
		gdouble _tmp234_ = 0.0;
		gdouble _tmp235_ = 0.0;
		cairo_t* _tmp236_ = NULL;
		gdouble _tmp237_ = 0.0;
		gdouble _tmp238_ = 0.0;
		gdouble _tmp239_ = 0.0;
		gdouble _tmp240_ = 0.0;
		cairo_t* _tmp241_ = NULL;
		cairo_t* _tmp242_ = NULL;
		cairo_t* _tmp243_ = NULL;
		gdouble _tmp244_ = 0.0;
		time_t moving_time = 0;
		GpxTrack* _tmp245_ = NULL;
		GpxTrack* _tmp246_ = NULL;
		GList* _tmp247_ = NULL;
		GList* _tmp248_ = NULL;
		gconstpointer _tmp249_ = NULL;
		GpxTrack* _tmp250_ = NULL;
		GList* _tmp251_ = NULL;
		GList* _tmp252_ = NULL;
		gconstpointer _tmp253_ = NULL;
		time_t _tmp254_ = 0;
		gdouble _tmp255_ = 0.0;
		cairo_t* _tmp256_ = NULL;
		cairo_t* _tmp257_ = NULL;
		gdouble _tmp258_ = 0.0;
		gdouble _tmp259_ = 0.0;
		gdouble _tmp260_ = 0.0;
		cairo_t* _tmp261_ = NULL;
		gdouble _tmp262_ = 0.0;
		gdouble _tmp263_ = 0.0;
		gdouble _tmp264_ = 0.0;
		gdouble _tmp265_ = 0.0;
		cairo_t* _tmp266_ = NULL;
		gdouble _tmp267_ = 0.0;
		_tmp230_ = self->track;
		_tmp231_ = gpx_track_get_track_average (_tmp230_);
		avg = _tmp231_;
		_tmp232_ = ctx;
		_tmp233_ = graph_height;
		_tmp234_ = avg;
		_tmp235_ = max_value;
		cairo_move_to (_tmp232_, 0.0, _tmp233_ * (1 - (_tmp234_ / _tmp235_)));
		_tmp236_ = ctx;
		_tmp237_ = graph_width;
		_tmp238_ = graph_height;
		_tmp239_ = avg;
		_tmp240_ = max_value;
		cairo_line_to (_tmp236_, _tmp237_, _tmp238_ * (1 - (_tmp239_ / _tmp240_)));
		_tmp241_ = ctx;
		cairo_set_line_width (_tmp241_, 2.5);
		_tmp242_ = ctx;
		cairo_set_source_rgba (_tmp242_, 1.00, 0.33, 0.00, 1.0);
		_tmp243_ = ctx;
		cairo_stroke (_tmp243_);
		_tmp244_ = avg;
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:685: Draw average speed line @ %.02f km/h", _tmp244_);
		_tmp245_ = self->track;
		_tmp246_ = self->track;
		_tmp247_ = _tmp246_->points;
		_tmp248_ = g_list_first (_tmp247_);
		_tmp249_ = _tmp248_->data;
		_tmp250_ = self->track;
		_tmp251_ = _tmp250_->points;
		_tmp252_ = g_list_last (_tmp251_);
		_tmp253_ = _tmp252_->data;
		_tmp255_ = gpx_track_calculate_moving_average (_tmp245_, (GpxPoint*) _tmp249_, (GpxPoint*) _tmp253_, &_tmp254_);
		moving_time = _tmp254_;
		avg = _tmp255_;
		_tmp256_ = ctx;
		cairo_set_source_rgba (_tmp256_, 0.7, 0.0, 0.0, 1.0);
		_tmp257_ = ctx;
		_tmp258_ = graph_height;
		_tmp259_ = avg;
		_tmp260_ = max_value;
		cairo_move_to (_tmp257_, 0.0, _tmp258_ * (1 - (_tmp259_ / _tmp260_)));
		_tmp261_ = ctx;
		_tmp262_ = graph_width;
		_tmp263_ = graph_height;
		_tmp264_ = avg;
		_tmp265_ = max_value;
		cairo_line_to (_tmp261_, _tmp262_, _tmp263_ * (1 - (_tmp264_ / _tmp265_)));
		_tmp266_ = ctx;
		cairo_stroke (_tmp266_);
		_tmp267_ = avg;
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:695: Draw moving average speed line @ %.02f km/h", _tmp267_);
	}
	_tmp268_ = ctx;
	cairo_set_source_rgba (_tmp268_, 0.0, 0.0, 0.0, 1.0);
	_tmp269_ = self->priv->fd;
	pango_font_description_set_absolute_size (_tmp269_, (gdouble) (12 * 1024));
	_tmp270_ = layout;
	_tmp271_ = self->priv->fd;
	pango_layout_set_font_description (_tmp270_, _tmp271_);
	_tmp272_ = g_strdup ("");
	mtext = _tmp272_;
	_tmp273_ = self->priv->_do_miles;
	if (_tmp273_) {
		gchar** _tmp274_ = NULL;
		gint _tmp274__length1 = 0;
		GpxGraphGraphMode _tmp275_ = 0;
		const gchar* _tmp276_ = NULL;
		const gchar* _tmp277_ = NULL;
		gchar* _tmp278_ = NULL;
		_tmp274_ = gpx_graph_GraphModeMiles;
		_tmp274__length1 = gpx_graph_GraphModeMiles_length1;
		_tmp275_ = self->priv->_mode;
		_tmp276_ = _tmp274_[_tmp275_];
		_tmp277_ = _ (_tmp276_);
		_tmp278_ = g_strdup (_tmp277_);
		_g_free0 (mtext);
		mtext = _tmp278_;
	} else {
		gchar** _tmp279_ = NULL;
		gint _tmp279__length1 = 0;
		GpxGraphGraphMode _tmp280_ = 0;
		const gchar* _tmp281_ = NULL;
		const gchar* _tmp282_ = NULL;
		gchar* _tmp283_ = NULL;
		_tmp279_ = gpx_graph_GraphModeName;
		_tmp279__length1 = gpx_graph_GraphModeName_length1;
		_tmp280_ = self->priv->_mode;
		_tmp281_ = _tmp279_[_tmp280_];
		_tmp282_ = _ (_tmp281_);
		_tmp283_ = g_strdup (_tmp282_);
		_g_free0 (mtext);
		mtext = _tmp283_;
	}
	_tmp284_ = self->priv->_smooth_factor;
	if (_tmp284_ != 1) {
		gchar* markup = NULL;
		const gchar* _tmp285_ = NULL;
		const gchar* _tmp286_ = NULL;
		gint _tmp287_ = 0;
		gchar* _tmp288_ = NULL;
		PangoLayout* _tmp289_ = NULL;
		const gchar* _tmp290_ = NULL;
		const gchar* _tmp291_ = NULL;
		_tmp285_ = _ ("%s <i>(smooth window: %i)</i>");
		_tmp286_ = mtext;
		_tmp287_ = self->priv->_smooth_factor;
		_tmp288_ = g_strdup_printf (_tmp285_, _tmp286_, _tmp287_);
		markup = _tmp288_;
		_tmp289_ = layout;
		_tmp290_ = markup;
		pango_layout_set_markup (_tmp289_, _tmp290_, -1);
		_tmp291_ = markup;
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:713: Set graph title: %s", _tmp291_);
		_g_free0 (markup);
	} else {
		PangoLayout* _tmp292_ = NULL;
		const gchar* _tmp293_ = NULL;
		const gchar* _tmp294_ = NULL;
		_tmp292_ = layout;
		_tmp293_ = mtext;
		pango_layout_set_text (_tmp292_, _tmp293_, -1);
		_tmp294_ = mtext;
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:719: Set graph title: %s", _tmp294_);
	}
	_tmp295_ = layout;
	pango_layout_get_pixel_size (_tmp295_, &_tmp296_, &_tmp297_);
	w = _tmp296_;
	h = _tmp297_;
	_tmp298_ = ctx;
	_tmp299_ = graph_width;
	_tmp300_ = w;
	cairo_move_to (_tmp298_, (_tmp299_ / 2) - (_tmp300_ / 2), (gdouble) (-20));
	_tmp301_ = ctx;
	_tmp302_ = layout;
	pango_cairo_layout_path (_tmp301_, _tmp302_);
	_tmp303_ = ctx;
	cairo_fill (_tmp303_);
	_g_free0 (mtext);
	_g_object_unref0 (layout);
	_gpx_point_unref0 (f);
	_cairo_destroy0 (ctx);
}


gint gpx_graph_get_smooth_factor (GpxGraph* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_smooth_factor;
	result = _tmp0_;
	return result;
}


void gpx_graph_set_smooth_factor (GpxGraph* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_smooth_factor = _tmp0_;
	_cairo_surface_destroy0 (self->priv->surf);
	self->priv->surf = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "smooth-factor");
}


gboolean gpx_graph_get_show_points (GpxGraph* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_points;
	result = _tmp0_;
	return result;
}


void gpx_graph_set_show_points (GpxGraph* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_show_points = _tmp0_;
	_cairo_surface_destroy0 (self->priv->surf);
	self->priv->surf = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "show-points");
}


GpxGraphGraphMode gpx_graph_get_mode (GpxGraph* self) {
	GpxGraphGraphMode result;
	GpxGraphGraphMode _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_mode;
	result = _tmp0_;
	return result;
}


void gpx_graph_set_mode (GpxGraph* self, GpxGraphGraphMode value) {
	GpxGraphGraphMode _tmp0_ = 0;
	GpxGraphGraphMode _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = self->priv->_mode;
	if (_tmp0_ != _tmp1_) {
		GpxGraphGraphMode _tmp2_ = 0;
		_tmp2_ = value;
		self->priv->_mode = _tmp2_;
		_cairo_surface_destroy0 (self->priv->surf);
		self->priv->surf = NULL;
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	g_object_notify ((GObject *) self, "mode");
}


static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__GPX_POINT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__GPX_POINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, gpx_value_get_point (param_values + 1), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), gpx_value_get_point (param_values + 2), gpx_value_get_point (param_values + 3), data2);
}


static void gpx_graph_class_init (GpxGraphClass * klass) {
	gchar** _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gpx_graph_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxGraphPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpx_graph_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpx_graph_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpx_graph_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_SMOOTH_FACTOR, g_param_spec_int ("smooth-factor", "smooth-factor", "smooth-factor", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_SHOW_POINTS, g_param_spec_boolean ("show-points", "show-points", "show-points", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_MODE, g_param_spec_enum ("mode", "mode", "mode", GPX_GRAPH_TYPE_GRAPH_MODE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("point_clicked", GPX_TYPE_GRAPH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GPX_POINT, G_TYPE_NONE, 1, GPX_TYPE_POINT);
	g_signal_new ("selection_changed", GPX_TYPE_GRAPH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT, G_TYPE_NONE, 3, GPX_TYPE_TRACK, GPX_TYPE_POINT, GPX_TYPE_POINT);
	_tmp0_ = g_new0 (gchar*, 5 + 1);
	_tmp0_[0] = "Speed (km/h) vs Time (HH:MM)";
	_tmp0_[1] = "Elevation (m) vs Time (HH:MM)";
	_tmp0_[2] = "Absolute Distance (km) vs Time (HH:MM)";
	_tmp0_[3] = "Horizontal acceleration (m/s²) vs Time (HH:MM)";
	_tmp0_[4] = "Vertical speed (m/s) vs Time (HH:MM)";
	gpx_graph_GraphModeName = _tmp0_;
	gpx_graph_GraphModeName_length1 = 5;
	_tmp1_ = g_new0 (gchar*, 5 + 1);
	_tmp1_[0] = "Speed (Miles/h) vs Time (HH:MM)";
	_tmp1_[1] = "Elevation (feet) vs Time (HH:MM)";
	_tmp1_[2] = "Distance (Miles) vs Time (HH:MM)";
	_tmp1_[3] = "Horizontal acceleration (Miles/s²) vs Time (HH:MM)";
	_tmp1_[4] = "Vertical speed (feet/s) vs Time (HH:MM)";
	gpx_graph_GraphModeMiles = _tmp1_;
	gpx_graph_GraphModeMiles_length1 = 5;
}


static void gpx_graph_instance_init (GpxGraph * self) {
	self->priv = GPX_GRAPH_GET_PRIVATE (self);
	self->track = NULL;
	self->priv->_do_miles = FALSE;
	self->priv->_mode = GPX_GRAPH_GRAPH_MODE_ELEVATION;
	self->priv->_smooth_factor = 1;
	self->priv->_show_points = TRUE;
	self->priv->fd = NULL;
	self->priv->surf = NULL;
	self->priv->LEFT_OFFSET = 60;
	self->priv->BOTTOM_OFFSET = 30;
	self->priv->highlight = (time_t) 0;
	self->priv->draw_current = NULL;
	self->priv->start = NULL;
	self->priv->stop = NULL;
}


static void gpx_graph_finalize (GObject* obj) {
	GpxGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_GRAPH, GpxGraph);
	g_debug ("gpx-graph.vala:729: Destroying graph");
	_g_object_unref0 (self->track);
	__vala_PangoFontDescription_free0 (self->priv->fd);
	_cairo_surface_destroy0 (self->priv->surf);
	_gpx_point_unref0 (self->priv->start);
	_gpx_point_unref0 (self->priv->stop);
	G_OBJECT_CLASS (gpx_graph_parent_class)->finalize (obj);
}


GType gpx_graph_get_type (void) {
	static volatile gsize gpx_graph_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_graph_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxGraphClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_graph_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxGraph), 0, (GInstanceInitFunc) gpx_graph_instance_init, NULL };
		GType gpx_graph_type_id;
		gpx_graph_type_id = g_type_register_static (GTK_TYPE_EVENT_BOX, "GpxGraph", &g_define_type_info, 0);
		g_once_init_leave (&gpx_graph_type_id__volatile, gpx_graph_type_id);
	}
	return gpx_graph_type_id__volatile;
}


static void _vala_gpx_graph_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GpxGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_GRAPH, GpxGraph);
	switch (property_id) {
		case GPX_GRAPH_SMOOTH_FACTOR:
		g_value_set_int (value, gpx_graph_get_smooth_factor (self));
		break;
		case GPX_GRAPH_SHOW_POINTS:
		g_value_set_boolean (value, gpx_graph_get_show_points (self));
		break;
		case GPX_GRAPH_MODE:
		g_value_set_enum (value, gpx_graph_get_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpx_graph_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GpxGraph * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_GRAPH, GpxGraph);
	switch (property_id) {
		case GPX_GRAPH_SMOOTH_FACTOR:
		gpx_graph_set_smooth_factor (self, g_value_get_int (value));
		break;
		case GPX_GRAPH_SHOW_POINTS:
		gpx_graph_set_show_points (self, g_value_get_boolean (value));
		break;
		case GPX_GRAPH_MODE:
		gpx_graph_set_mode (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



