/* gpx-parser.c generated by valac 0.21.2, the Vala compiler
 * generated from gpx-parser.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2011 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "gpx.h"
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <libxml/tree.h>
#include <libxml/xmlreader.h>
#include <libxml/xmlIO.h>
#include <gobject/gvaluecollector.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
typedef struct _GpxParamSpecPoint GpxParamSpecPoint;
#define __g_list_free__gpx_point_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__gpx_point_unref0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _xmlFreeTextReader0(var) ((var == NULL) ? NULL : (var = (xmlFreeTextReader (var), NULL)))

struct _GpxPointPrivate {
	gchar* _name;
	time_t utime;
};

struct _GpxParamSpecPoint {
	GParamSpec parent_instance;
};

struct _GpxTrackPrivate {
	gchar* _name;
	GpxPoint* last;
};

struct _GpxFilePrivate {
	GFileInputStream* stream;
};


static gpointer gpx_point_parent_class = NULL;
static gpointer gpx_track_parent_class = NULL;
static gpointer gpx_file_parent_class = NULL;

#define GPX_POINT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_POINT, GpxPointPrivate))
enum  {
	GPX_POINT_DUMMY_PROPERTY
};
static void gpx_point_finalize (GpxPoint* obj);
#define GPX_TRACK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_TRACK, GpxTrackPrivate))
enum  {
	GPX_TRACK_DUMMY_PROPERTY,
	GPX_TRACK_NAME
};
static void _gpx_point_unref0_ (gpointer var);
static void _g_list_free__gpx_point_unref0_ (GList* self);
static void gpx_track_finalize (GObject* obj);
static void _vala_gpx_track_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_gpx_track_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define GPX_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_FILE, GpxFilePrivate))
enum  {
	GPX_FILE_DUMMY_PROPERTY
};
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
static GpxTrack* gpx_file_parse_track (GpxFile* self, xmlNode* node);
static void gpx_file_parse_waypoint (GpxFile* self, xmlNode* node);
static GpxTrack* gpx_file_parse_route (GpxFile* self, xmlNode* node);
static gint gpx_file_read_file (GpxFile* self, guint8* buffer, int buffer_length1);
static gint gpx_file_close_file (GpxFile* self);
static void gpx_file_finalize (GObject* obj);


/**
         * Make a clean copy off the point.
         * Only position and time is copied.
         */
GpxPoint* gpx_point_copy (GpxPoint* self) {
	GpxPoint* result = NULL;
	GpxPoint* p = NULL;
	GpxPoint* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gdouble _tmp8_ = 0.0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gpx_point_new ();
	p = _tmp0_;
	_tmp1_ = self->priv->_name;
	gpx_point_set_name (p, _tmp1_);
	_tmp2_ = self->lat;
	p->lat = _tmp2_;
	_tmp3_ = self->lon;
	p->lon = _tmp3_;
	_tmp4_ = self->lat_dec;
	p->lat_dec = _tmp4_;
	_tmp5_ = self->lon_dec;
	p->lon_dec = _tmp5_;
	_tmp6_ = self->time;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 (p->time);
	p->time = _tmp7_;
	_tmp8_ = self->elevation;
	p->elevation = _tmp8_;
	result = p;
	return result;
}


void gpx_point_set_position (GpxPoint* self, gdouble lat, gdouble lon) {
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = lat;
	self->lat_dec = _tmp0_;
	_tmp1_ = lon;
	self->lon_dec = _tmp1_;
	_tmp2_ = lat;
	self->lat = ((2 * G_PI) * _tmp2_) / 360.0;
	_tmp3_ = lon;
	self->lon = ((2 * G_PI) * _tmp3_) / 360.0;
}


time_t gpx_point_get_time (GpxPoint* self) {
	time_t result = 0;
	const gchar* _tmp0_ = NULL;
	time_t _tmp1_ = 0;
	struct tm ta = {0};
	const gchar* _tmp3_ = NULL;
	time_t _tmp4_ = 0;
	time_t _tmp5_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->time;
	if (_tmp0_ == NULL) {
		result = (time_t) 0;
		return result;
	}
	_tmp1_ = self->priv->utime;
	if (_tmp1_ > ((time_t) 0)) {
		time_t _tmp2_ = 0;
		_tmp2_ = self->priv->utime;
		result = _tmp2_;
		return result;
	}
	memset (&ta, 0, sizeof (struct tm));
	_tmp3_ = self->time;
	strptime (_tmp3_, "%FT%T%z", &ta);
	_tmp4_ = mktime (&ta);
	self->priv->utime = _tmp4_;
	_tmp5_ = self->priv->utime;
	result = _tmp5_;
	return result;
}


GpxPoint* gpx_point_construct (GType object_type) {
	GpxPoint* self = NULL;
	self = (GpxPoint*) g_type_create_instance (object_type);
	return self;
}


GpxPoint* gpx_point_new (void) {
	return gpx_point_construct (GPX_TYPE_POINT);
}


const gchar* gpx_point_get_name (GpxPoint* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void gpx_point_set_name (GpxPoint* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
}


static void gpx_value_point_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void gpx_value_point_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		gpx_point_unref (value->data[0].v_pointer);
	}
}


static void gpx_value_point_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = gpx_point_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer gpx_value_point_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* gpx_value_point_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		GpxPoint* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = gpx_point_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* gpx_value_point_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GpxPoint** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = gpx_point_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GpxParamSpecPoint* spec;
	g_return_val_if_fail (g_type_is_a (object_type, GPX_TYPE_POINT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer gpx_value_get_point (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT), NULL);
	return value->data[0].v_pointer;
}


void gpx_value_set_point (GValue* value, gpointer v_object) {
	GpxPoint* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GPX_TYPE_POINT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		gpx_point_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gpx_point_unref (old);
	}
}


void gpx_value_take_point (GValue* value, gpointer v_object) {
	GpxPoint* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GPX_TYPE_POINT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GPX_TYPE_POINT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		gpx_point_unref (old);
	}
}


static void gpx_point_class_init (GpxPointClass * klass) {
	gpx_point_parent_class = g_type_class_peek_parent (klass);
	GPX_POINT_CLASS (klass)->finalize = gpx_point_finalize;
	g_type_class_add_private (klass, sizeof (GpxPointPrivate));
}


static void gpx_point_instance_init (GpxPoint * self) {
	self->priv = GPX_POINT_GET_PRIVATE (self);
	self->priv->_name = NULL;
	self->lat = (gdouble) 1000;
	self->lon = (gdouble) 1000;
	self->lat_dec = (gdouble) 1000;
	self->lon_dec = (gdouble) 1000;
	self->distance = (gdouble) 0;
	self->speed = (gdouble) 0;
	self->stopped = FALSE;
	self->priv->utime = (time_t) 0;
	self->ref_count = 1;
}


static void gpx_point_finalize (GpxPoint* obj) {
	GpxPoint * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_POINT, GpxPoint);
	_g_free0 (self->priv->_name);
	_g_free0 (self->time);
}


/**
     * Represents a point in the track or a waypoint.
     */
GType gpx_point_get_type (void) {
	static volatile gsize gpx_point_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_point_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { gpx_value_point_init, gpx_value_point_free_value, gpx_value_point_copy_value, gpx_value_point_peek_pointer, "p", gpx_value_point_collect_value, "p", gpx_value_point_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GpxPointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_point_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxPoint), 0, (GInstanceInitFunc) gpx_point_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType gpx_point_type_id;
		gpx_point_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GpxPoint", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&gpx_point_type_id__volatile, gpx_point_type_id);
	}
	return gpx_point_type_id__volatile;
}


gpointer gpx_point_ref (gpointer instance) {
	GpxPoint* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void gpx_point_unref (gpointer instance) {
	GpxPoint* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		GPX_POINT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void _gpx_point_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL));
}


static void _g_list_free__gpx_point_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _gpx_point_unref0_, NULL);
	g_list_free (self);
}


GpxPoint* gpx_track_get_last (GpxTrack* self) {
	GpxPoint* result = NULL;
	GpxPoint* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->last;
	result = _tmp0_;
	return result;
}


/** This function will try to remove useless points */
void gpx_track_filter_points (GpxTrack* self) {
	GList* a = NULL;
	GList* b = NULL;
	GList* c = NULL;
	gdouble avg = 0.0;
	gdouble _tmp87_ = 0.0;
	gdouble _tmp88_ = 0.0;
	gdouble _tmp89_ = 0.0;
	gdouble _tmp91_ = 0.0;
	gint _tmp109_ = 0;
	g_return_if_fail (self != NULL);
	a = NULL;
	b = NULL;
	c = NULL;
	{
		GList* iter = NULL;
		GList* _tmp0_ = NULL;
		GList* _tmp1_ = NULL;
		_tmp0_ = self->points;
		_tmp1_ = g_list_first (_tmp0_);
		iter = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				GList* _tmp6_ = NULL;
				GList* _tmp7_ = NULL;
				GList* _tmp9_ = NULL;
				GList* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				GList* _tmp14_ = NULL;
				gboolean _tmp16_ = FALSE;
				gboolean _tmp18_ = FALSE;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					GList* _tmp4_ = NULL;
					GList* _tmp5_ = NULL;
					_tmp4_ = iter;
					_tmp5_ = _tmp4_->next;
					iter = _tmp5_;
				}
				_tmp2_ = FALSE;
				_tmp6_ = iter;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp7_ = b;
				if (_tmp7_ != NULL) {
					GList* _tmp8_ = NULL;
					_tmp8_ = b;
					c = _tmp8_;
				}
				_tmp9_ = a;
				if (_tmp9_ != NULL) {
					GList* _tmp10_ = NULL;
					_tmp10_ = a;
					b = _tmp10_;
				}
				_tmp11_ = iter;
				a = _tmp11_;
				_tmp14_ = a;
				if (_tmp14_ != NULL) {
					GList* _tmp15_ = NULL;
					_tmp15_ = b;
					_tmp13_ = _tmp15_ != NULL;
				} else {
					_tmp13_ = FALSE;
				}
				_tmp16_ = _tmp13_;
				if (_tmp16_) {
					GList* _tmp17_ = NULL;
					_tmp17_ = c;
					_tmp12_ = _tmp17_ != NULL;
				} else {
					_tmp12_ = FALSE;
				}
				_tmp18_ = _tmp12_;
				if (_tmp18_) {
					gdouble elapsed_ca = 0.0;
					GList* _tmp19_ = NULL;
					gconstpointer _tmp20_ = NULL;
					time_t _tmp21_ = 0;
					GList* _tmp22_ = NULL;
					gconstpointer _tmp23_ = NULL;
					time_t _tmp24_ = 0;
					gdouble elapsed_cb = 0.0;
					GList* _tmp25_ = NULL;
					gconstpointer _tmp26_ = NULL;
					time_t _tmp27_ = 0;
					GList* _tmp28_ = NULL;
					gconstpointer _tmp29_ = NULL;
					time_t _tmp30_ = 0;
					gdouble lat_rico_ca = 0.0;
					GList* _tmp31_ = NULL;
					gconstpointer _tmp32_ = NULL;
					gdouble _tmp33_ = 0.0;
					GList* _tmp34_ = NULL;
					gconstpointer _tmp35_ = NULL;
					gdouble _tmp36_ = 0.0;
					gdouble _tmp37_ = 0.0;
					gdouble lon_rico_ca = 0.0;
					GList* _tmp38_ = NULL;
					gconstpointer _tmp39_ = NULL;
					gdouble _tmp40_ = 0.0;
					GList* _tmp41_ = NULL;
					gconstpointer _tmp42_ = NULL;
					gdouble _tmp43_ = 0.0;
					gdouble _tmp44_ = 0.0;
					gdouble lat_rico_cb = 0.0;
					GList* _tmp45_ = NULL;
					gconstpointer _tmp46_ = NULL;
					gdouble _tmp47_ = 0.0;
					GList* _tmp48_ = NULL;
					gconstpointer _tmp49_ = NULL;
					gdouble _tmp50_ = 0.0;
					gdouble _tmp51_ = 0.0;
					gdouble lon_rico_cb = 0.0;
					GList* _tmp52_ = NULL;
					gconstpointer _tmp53_ = NULL;
					gdouble _tmp54_ = 0.0;
					GList* _tmp55_ = NULL;
					gconstpointer _tmp56_ = NULL;
					gdouble _tmp57_ = 0.0;
					gdouble _tmp58_ = 0.0;
					gdouble elv_rico_ca = 0.0;
					GList* _tmp59_ = NULL;
					gconstpointer _tmp60_ = NULL;
					gdouble _tmp61_ = 0.0;
					GList* _tmp62_ = NULL;
					gconstpointer _tmp63_ = NULL;
					gdouble _tmp64_ = 0.0;
					gdouble _tmp65_ = 0.0;
					gdouble elv_rico_cb = 0.0;
					GList* _tmp66_ = NULL;
					gconstpointer _tmp67_ = NULL;
					gdouble _tmp68_ = 0.0;
					GList* _tmp69_ = NULL;
					gconstpointer _tmp70_ = NULL;
					gdouble _tmp71_ = 0.0;
					gdouble _tmp72_ = 0.0;
					gdouble l = 0.0;
					gdouble _tmp73_ = 0.0;
					gdouble _tmp74_ = 0.0;
					gdouble _tmp75_ = 0.0;
					gdouble m = 0.0;
					gdouble _tmp76_ = 0.0;
					gdouble _tmp77_ = 0.0;
					gdouble _tmp78_ = 0.0;
					gdouble e = 0.0;
					gdouble _tmp79_ = 0.0;
					gdouble _tmp80_ = 0.0;
					gdouble _tmp81_ = 0.0;
					gdouble _tmp82_ = 0.0;
					_tmp19_ = a;
					_tmp20_ = _tmp19_->data;
					_tmp21_ = gpx_point_get_time ((GpxPoint*) _tmp20_);
					_tmp22_ = c;
					_tmp23_ = _tmp22_->data;
					_tmp24_ = gpx_point_get_time ((GpxPoint*) _tmp23_);
					elapsed_ca = (gdouble) (_tmp21_ - _tmp24_);
					_tmp25_ = a;
					_tmp26_ = _tmp25_->data;
					_tmp27_ = gpx_point_get_time ((GpxPoint*) _tmp26_);
					_tmp28_ = b;
					_tmp29_ = _tmp28_->data;
					_tmp30_ = gpx_point_get_time ((GpxPoint*) _tmp29_);
					elapsed_cb = (gdouble) (_tmp27_ - _tmp30_);
					_tmp31_ = a;
					_tmp32_ = _tmp31_->data;
					_tmp33_ = ((GpxPoint*) _tmp32_)->lat_dec;
					_tmp34_ = c;
					_tmp35_ = _tmp34_->data;
					_tmp36_ = ((GpxPoint*) _tmp35_)->lat_dec;
					_tmp37_ = elapsed_ca;
					lat_rico_ca = (_tmp33_ - _tmp36_) / ((gdouble) _tmp37_);
					_tmp38_ = a;
					_tmp39_ = _tmp38_->data;
					_tmp40_ = ((GpxPoint*) _tmp39_)->lon_dec;
					_tmp41_ = c;
					_tmp42_ = _tmp41_->data;
					_tmp43_ = ((GpxPoint*) _tmp42_)->lon_dec;
					_tmp44_ = elapsed_ca;
					lon_rico_ca = (_tmp40_ - _tmp43_) / ((gdouble) _tmp44_);
					_tmp45_ = b;
					_tmp46_ = _tmp45_->data;
					_tmp47_ = ((GpxPoint*) _tmp46_)->lat_dec;
					_tmp48_ = c;
					_tmp49_ = _tmp48_->data;
					_tmp50_ = ((GpxPoint*) _tmp49_)->lat_dec;
					_tmp51_ = elapsed_cb;
					lat_rico_cb = (_tmp47_ - _tmp50_) / ((gdouble) _tmp51_);
					_tmp52_ = b;
					_tmp53_ = _tmp52_->data;
					_tmp54_ = ((GpxPoint*) _tmp53_)->lon_dec;
					_tmp55_ = c;
					_tmp56_ = _tmp55_->data;
					_tmp57_ = ((GpxPoint*) _tmp56_)->lon_dec;
					_tmp58_ = elapsed_cb;
					lon_rico_cb = (_tmp54_ - _tmp57_) / ((gdouble) _tmp58_);
					_tmp59_ = a;
					_tmp60_ = _tmp59_->data;
					_tmp61_ = ((GpxPoint*) _tmp60_)->elevation;
					_tmp62_ = c;
					_tmp63_ = _tmp62_->data;
					_tmp64_ = ((GpxPoint*) _tmp63_)->elevation;
					_tmp65_ = elapsed_ca;
					elv_rico_ca = (_tmp61_ - _tmp64_) / ((gdouble) _tmp65_);
					_tmp66_ = a;
					_tmp67_ = _tmp66_->data;
					_tmp68_ = ((GpxPoint*) _tmp67_)->elevation;
					_tmp69_ = b;
					_tmp70_ = _tmp69_->data;
					_tmp71_ = ((GpxPoint*) _tmp70_)->elevation;
					_tmp72_ = elapsed_cb;
					elv_rico_cb = (_tmp68_ - _tmp71_) / ((gdouble) _tmp72_);
					_tmp73_ = lat_rico_ca;
					_tmp74_ = lat_rico_cb;
					_tmp75_ = fabs (1.0 - (_tmp73_ / _tmp74_));
					l = _tmp75_;
					_tmp76_ = lon_rico_ca;
					_tmp77_ = lon_rico_cb;
					_tmp78_ = fabs (1.0 - (_tmp76_ / _tmp77_));
					m = _tmp78_;
					_tmp79_ = elv_rico_ca;
					_tmp80_ = elv_rico_cb;
					_tmp81_ = fabs (1.0 - (_tmp79_ / _tmp80_));
					e = _tmp81_;
					_tmp82_ = l;
					if (_tmp82_ <= 0.2) {
						gdouble _tmp83_ = 0.0;
						_tmp83_ = m;
						if (_tmp83_ <= 0.2) {
							GList* _tmp84_ = NULL;
							gint _tmp85_ = 0;
							GList* _tmp86_ = NULL;
							_tmp84_ = b;
							self->points = g_list_remove_link (self->points, _tmp84_);
							_tmp85_ = self->filtered_points;
							self->filtered_points = _tmp85_ + 1;
							_tmp86_ = c;
							b = _tmp86_;
						}
					}
				}
			}
		}
	}
	gpx_track_recalculate (self);
	_tmp87_ = gpx_track_get_track_average (self);
	avg = _tmp87_ / 20;
	_tmp89_ = avg;
	if (_tmp89_ > ((gdouble) 2)) {
		_tmp88_ = (gdouble) 2;
	} else {
		gdouble _tmp90_ = 0.0;
		_tmp90_ = avg;
		_tmp88_ = _tmp90_;
	}
	_tmp91_ = _tmp88_;
	avg = _tmp91_;
	{
		GList* iter = NULL;
		GList* _tmp92_ = NULL;
		GList* _tmp93_ = NULL;
		_tmp92_ = self->points;
		_tmp93_ = g_list_first (_tmp92_);
		iter = _tmp93_;
		{
			gboolean _tmp94_ = FALSE;
			_tmp94_ = TRUE;
			while (TRUE) {
				gboolean _tmp95_ = FALSE;
				GList* _tmp98_ = NULL;
				GpxPoint* p = NULL;
				GList* _tmp99_ = NULL;
				gconstpointer _tmp100_ = NULL;
				gboolean _tmp101_ = FALSE;
				GpxPoint* _tmp102_ = NULL;
				gdouble _tmp103_ = 0.0;
				gboolean _tmp107_ = FALSE;
				_tmp95_ = _tmp94_;
				if (!_tmp95_) {
					GList* _tmp96_ = NULL;
					GList* _tmp97_ = NULL;
					_tmp96_ = iter;
					_tmp97_ = _tmp96_->next;
					iter = _tmp97_;
				}
				_tmp94_ = FALSE;
				_tmp98_ = iter;
				if (!(_tmp98_ != NULL)) {
					break;
				}
				_tmp99_ = iter;
				_tmp100_ = _tmp99_->data;
				p = (GpxPoint*) _tmp100_;
				_tmp102_ = p;
				_tmp103_ = _tmp102_->distance;
				if (_tmp103_ < 0.01) {
					_tmp101_ = TRUE;
				} else {
					GpxPoint* _tmp104_ = NULL;
					gdouble _tmp105_ = 0.0;
					gdouble _tmp106_ = 0.0;
					_tmp104_ = p;
					_tmp105_ = _tmp104_->speed;
					_tmp106_ = avg;
					_tmp101_ = _tmp105_ < _tmp106_;
				}
				_tmp107_ = _tmp101_;
				if (_tmp107_) {
					GpxPoint* _tmp108_ = NULL;
					_tmp108_ = p;
					_tmp108_->stopped = TRUE;
				}
			}
		}
	}
	_tmp109_ = self->filtered_points;
	g_debug ("gpx-parser.vala:177: Removed %i points", _tmp109_);
}


/**
 * This will recalculates all speeds and distances. Call this when the list was modified.
 */
void gpx_track_recalculate (GpxTrack* self) {
	GList* last = NULL;
	g_return_if_fail (self != NULL);
	last = NULL;
	self->total_distance = (gdouble) 0;
	self->max_speed = (gdouble) 0;
	self->max_elevation = 0.0;
	self->min_elevation = 0.0;
	{
		GList* iter = NULL;
		GList* _tmp0_ = NULL;
		GList* _tmp1_ = NULL;
		_tmp0_ = self->points;
		_tmp1_ = g_list_first (_tmp0_);
		iter = _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_ = FALSE;
				GList* _tmp6_ = NULL;
				GList* _tmp7_ = NULL;
				GList* _tmp50_ = NULL;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					GList* _tmp4_ = NULL;
					GList* _tmp5_ = NULL;
					_tmp4_ = iter;
					_tmp5_ = _tmp4_->next;
					iter = _tmp5_;
				}
				_tmp2_ = FALSE;
				_tmp6_ = iter;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp7_ = last;
				if (_tmp7_ != NULL) {
					GpxPoint* point = NULL;
					GList* _tmp8_ = NULL;
					gconstpointer _tmp9_ = NULL;
					gdouble _tmp10_ = 0.0;
					GList* _tmp11_ = NULL;
					gconstpointer _tmp12_ = NULL;
					GpxPoint* _tmp13_ = NULL;
					gdouble _tmp14_ = 0.0;
					GpxPoint* _tmp15_ = NULL;
					gdouble _tmp16_ = 0.0;
					GpxPoint* _tmp17_ = NULL;
					GList* _tmp18_ = NULL;
					gconstpointer _tmp19_ = NULL;
					GpxPoint* _tmp20_ = NULL;
					gdouble _tmp21_ = 0.0;
					GpxPoint* _tmp22_ = NULL;
					gdouble _tmp23_ = 0.0;
					gdouble _tmp24_ = 0.0;
					GpxPoint* _tmp27_ = NULL;
					gdouble _tmp28_ = 0.0;
					gdouble _tmp29_ = 0.0;
					GpxPoint* _tmp32_ = NULL;
					gdouble _tmp33_ = 0.0;
					gdouble _tmp34_ = 0.0;
					_tmp8_ = iter;
					_tmp9_ = _tmp8_->data;
					point = (GpxPoint*) _tmp9_;
					_tmp10_ = self->total_distance;
					_tmp11_ = last;
					_tmp12_ = _tmp11_->data;
					_tmp13_ = point;
					_tmp14_ = gpx_track_calculate_distance ((GpxPoint*) _tmp12_, _tmp13_);
					self->total_distance = _tmp10_ + _tmp14_;
					_tmp15_ = point;
					_tmp16_ = self->total_distance;
					_tmp15_->distance = _tmp16_;
					_tmp17_ = point;
					_tmp18_ = last;
					_tmp19_ = _tmp18_->data;
					_tmp20_ = point;
					_tmp21_ = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) _tmp19_, _tmp20_);
					_tmp17_->speed = _tmp21_;
					_tmp22_ = point;
					_tmp23_ = _tmp22_->elevation;
					_tmp24_ = self->max_elevation;
					if (_tmp23_ > _tmp24_) {
						GpxPoint* _tmp25_ = NULL;
						gdouble _tmp26_ = 0.0;
						_tmp25_ = point;
						_tmp26_ = _tmp25_->elevation;
						self->max_elevation = _tmp26_;
					}
					_tmp27_ = point;
					_tmp28_ = _tmp27_->elevation;
					_tmp29_ = self->min_elevation;
					if (_tmp28_ < _tmp29_) {
						GpxPoint* _tmp30_ = NULL;
						gdouble _tmp31_ = 0.0;
						_tmp30_ = point;
						_tmp31_ = _tmp30_->elevation;
						self->min_elevation = _tmp31_;
					}
					_tmp32_ = point;
					_tmp33_ = _tmp32_->speed;
					_tmp34_ = self->max_speed;
					if (_tmp33_ > _tmp34_) {
						GpxPoint* _tmp35_ = NULL;
						gdouble _tmp36_ = 0.0;
						_tmp35_ = point;
						_tmp36_ = _tmp35_->speed;
						self->max_speed = _tmp36_;
					}
				} else {
					GpxPoint* point = NULL;
					GList* _tmp37_ = NULL;
					gconstpointer _tmp38_ = NULL;
					GpxPoint* _tmp39_ = NULL;
					gdouble _tmp40_ = 0.0;
					gdouble _tmp41_ = 0.0;
					GpxPoint* _tmp44_ = NULL;
					gdouble _tmp45_ = 0.0;
					gdouble _tmp46_ = 0.0;
					GpxPoint* _tmp49_ = NULL;
					_tmp37_ = iter;
					_tmp38_ = _tmp37_->data;
					point = (GpxPoint*) _tmp38_;
					_tmp39_ = point;
					_tmp40_ = _tmp39_->elevation;
					_tmp41_ = self->max_elevation;
					if (_tmp40_ > _tmp41_) {
						GpxPoint* _tmp42_ = NULL;
						gdouble _tmp43_ = 0.0;
						_tmp42_ = point;
						_tmp43_ = _tmp42_->elevation;
						self->max_elevation = _tmp43_;
					}
					_tmp44_ = point;
					_tmp45_ = _tmp44_->elevation;
					_tmp46_ = self->min_elevation;
					if (_tmp45_ < _tmp46_) {
						GpxPoint* _tmp47_ = NULL;
						gdouble _tmp48_ = 0.0;
						_tmp47_ = point;
						_tmp48_ = _tmp47_->elevation;
						self->min_elevation = _tmp48_;
					}
					_tmp49_ = point;
					_tmp49_->distance = (gdouble) 0;
				}
				_tmp50_ = iter;
				last = _tmp50_;
			}
		}
	}
}


static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


void gpx_track_add_point (GpxTrack* self, GpxPoint* point) {
	GpxPoint* _tmp0_ = NULL;
	GpxPoint* _tmp1_ = NULL;
	GpxPoint* _tmp114_ = NULL;
	GpxPoint* _tmp115_ = NULL;
	GpxPoint* _tmp116_ = NULL;
	GpxPoint* _tmp117_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (point != NULL);
	_tmp0_ = point;
	_tmp0_->speed = 0.0;
	_tmp1_ = self->priv->last;
	if (_tmp1_ != NULL) {
		gdouble distance = 0.0;
		GpxPoint* _tmp2_ = NULL;
		GpxPoint* _tmp3_ = NULL;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		GpxPoint* _tmp7_ = NULL;
		gdouble _tmp8_ = 0.0;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		GpxPoint* _tmp11_ = NULL;
		gboolean _tmp14_ = FALSE;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp28_ = FALSE;
		gboolean _tmp29_ = FALSE;
		GpxPoint* _tmp30_ = NULL;
		gboolean _tmp33_ = FALSE;
		gboolean _tmp38_ = FALSE;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_ = FALSE;
		GpxPoint* _tmp49_ = NULL;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp57_ = FALSE;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_ = FALSE;
		GpxPoint* _tmp68_ = NULL;
		gboolean _tmp71_ = FALSE;
		gboolean _tmp76_ = FALSE;
		gboolean _tmp85_ = FALSE;
		GpxPoint* _tmp86_ = NULL;
		const gchar* _tmp87_ = NULL;
		gboolean _tmp90_ = FALSE;
		_tmp2_ = self->priv->last;
		_tmp3_ = point;
		_tmp4_ = gpx_track_calculate_distance (_tmp2_, _tmp3_);
		distance = _tmp4_;
		_tmp5_ = self->total_distance;
		_tmp6_ = distance;
		self->total_distance = _tmp5_ + _tmp6_;
		_tmp7_ = point;
		_tmp8_ = self->total_distance;
		_tmp7_->distance = _tmp8_;
		_tmp11_ = self->top;
		if (_tmp11_ == NULL) {
			_tmp10_ = TRUE;
		} else {
			GpxPoint* _tmp12_ = NULL;
			gdouble _tmp13_ = 0.0;
			_tmp12_ = self->top;
			_tmp13_ = _tmp12_->lat_dec;
			_tmp10_ = _tmp13_ == ((gdouble) 1000);
		}
		_tmp14_ = _tmp10_;
		if (_tmp14_) {
			_tmp9_ = TRUE;
		} else {
			GpxPoint* _tmp15_ = NULL;
			gdouble _tmp16_ = 0.0;
			GpxPoint* _tmp17_ = NULL;
			gdouble _tmp18_ = 0.0;
			_tmp15_ = self->top;
			_tmp16_ = _tmp15_->lat_dec;
			_tmp17_ = point;
			_tmp18_ = _tmp17_->lat_dec;
			_tmp9_ = _tmp16_ < _tmp18_;
		}
		_tmp19_ = _tmp9_;
		if (_tmp19_) {
			GpxPoint* _tmp20_ = NULL;
			GpxPoint* _tmp22_ = NULL;
			GpxPoint* _tmp23_ = NULL;
			gdouble _tmp24_ = 0.0;
			GpxPoint* _tmp25_ = NULL;
			GpxPoint* _tmp26_ = NULL;
			gdouble _tmp27_ = 0.0;
			_tmp20_ = self->top;
			if (_tmp20_ == NULL) {
				GpxPoint* _tmp21_ = NULL;
				_tmp21_ = gpx_point_new ();
				_gpx_point_unref0 (self->top);
				self->top = _tmp21_;
			}
			_tmp22_ = self->top;
			_tmp23_ = point;
			_tmp24_ = _tmp23_->lat_dec;
			_tmp22_->lat_dec = _tmp24_;
			_tmp25_ = self->top;
			_tmp26_ = point;
			_tmp27_ = _tmp26_->lat;
			_tmp25_->lat = _tmp27_;
		}
		_tmp30_ = self->top;
		if (_tmp30_ == NULL) {
			_tmp29_ = TRUE;
		} else {
			GpxPoint* _tmp31_ = NULL;
			gdouble _tmp32_ = 0.0;
			_tmp31_ = self->top;
			_tmp32_ = _tmp31_->lon_dec;
			_tmp29_ = _tmp32_ == ((gdouble) 1000);
		}
		_tmp33_ = _tmp29_;
		if (_tmp33_) {
			_tmp28_ = TRUE;
		} else {
			GpxPoint* _tmp34_ = NULL;
			gdouble _tmp35_ = 0.0;
			GpxPoint* _tmp36_ = NULL;
			gdouble _tmp37_ = 0.0;
			_tmp34_ = self->top;
			_tmp35_ = _tmp34_->lon_dec;
			_tmp36_ = point;
			_tmp37_ = _tmp36_->lon_dec;
			_tmp28_ = _tmp35_ < _tmp37_;
		}
		_tmp38_ = _tmp28_;
		if (_tmp38_) {
			GpxPoint* _tmp39_ = NULL;
			GpxPoint* _tmp41_ = NULL;
			GpxPoint* _tmp42_ = NULL;
			gdouble _tmp43_ = 0.0;
			GpxPoint* _tmp44_ = NULL;
			GpxPoint* _tmp45_ = NULL;
			gdouble _tmp46_ = 0.0;
			_tmp39_ = self->top;
			if (_tmp39_ == NULL) {
				GpxPoint* _tmp40_ = NULL;
				_tmp40_ = gpx_point_new ();
				_gpx_point_unref0 (self->top);
				self->top = _tmp40_;
			}
			_tmp41_ = self->top;
			_tmp42_ = point;
			_tmp43_ = _tmp42_->lon_dec;
			_tmp41_->lon_dec = _tmp43_;
			_tmp44_ = self->top;
			_tmp45_ = point;
			_tmp46_ = _tmp45_->lon;
			_tmp44_->lon = _tmp46_;
		}
		_tmp49_ = self->bottom;
		if (_tmp49_ == NULL) {
			_tmp48_ = TRUE;
		} else {
			GpxPoint* _tmp50_ = NULL;
			gdouble _tmp51_ = 0.0;
			_tmp50_ = self->bottom;
			_tmp51_ = _tmp50_->lat_dec;
			_tmp48_ = _tmp51_ == ((gdouble) 1000);
		}
		_tmp52_ = _tmp48_;
		if (_tmp52_) {
			_tmp47_ = TRUE;
		} else {
			GpxPoint* _tmp53_ = NULL;
			gdouble _tmp54_ = 0.0;
			GpxPoint* _tmp55_ = NULL;
			gdouble _tmp56_ = 0.0;
			_tmp53_ = self->bottom;
			_tmp54_ = _tmp53_->lat_dec;
			_tmp55_ = point;
			_tmp56_ = _tmp55_->lat_dec;
			_tmp47_ = _tmp54_ > _tmp56_;
		}
		_tmp57_ = _tmp47_;
		if (_tmp57_) {
			GpxPoint* _tmp58_ = NULL;
			GpxPoint* _tmp60_ = NULL;
			GpxPoint* _tmp61_ = NULL;
			gdouble _tmp62_ = 0.0;
			GpxPoint* _tmp63_ = NULL;
			GpxPoint* _tmp64_ = NULL;
			gdouble _tmp65_ = 0.0;
			_tmp58_ = self->bottom;
			if (_tmp58_ == NULL) {
				GpxPoint* _tmp59_ = NULL;
				_tmp59_ = gpx_point_new ();
				_gpx_point_unref0 (self->bottom);
				self->bottom = _tmp59_;
			}
			_tmp60_ = self->bottom;
			_tmp61_ = point;
			_tmp62_ = _tmp61_->lat_dec;
			_tmp60_->lat_dec = _tmp62_;
			_tmp63_ = self->bottom;
			_tmp64_ = point;
			_tmp65_ = _tmp64_->lat;
			_tmp63_->lat = _tmp65_;
		}
		_tmp68_ = self->bottom;
		if (_tmp68_ == NULL) {
			_tmp67_ = TRUE;
		} else {
			GpxPoint* _tmp69_ = NULL;
			gdouble _tmp70_ = 0.0;
			_tmp69_ = self->bottom;
			_tmp70_ = _tmp69_->lon_dec;
			_tmp67_ = _tmp70_ == ((gdouble) 1000);
		}
		_tmp71_ = _tmp67_;
		if (_tmp71_) {
			_tmp66_ = TRUE;
		} else {
			GpxPoint* _tmp72_ = NULL;
			gdouble _tmp73_ = 0.0;
			GpxPoint* _tmp74_ = NULL;
			gdouble _tmp75_ = 0.0;
			_tmp72_ = self->bottom;
			_tmp73_ = _tmp72_->lon_dec;
			_tmp74_ = point;
			_tmp75_ = _tmp74_->lon_dec;
			_tmp66_ = _tmp73_ > _tmp75_;
		}
		_tmp76_ = _tmp66_;
		if (_tmp76_) {
			GpxPoint* _tmp77_ = NULL;
			GpxPoint* _tmp79_ = NULL;
			GpxPoint* _tmp80_ = NULL;
			gdouble _tmp81_ = 0.0;
			GpxPoint* _tmp82_ = NULL;
			GpxPoint* _tmp83_ = NULL;
			gdouble _tmp84_ = 0.0;
			_tmp77_ = self->bottom;
			if (_tmp77_ == NULL) {
				GpxPoint* _tmp78_ = NULL;
				_tmp78_ = gpx_point_new ();
				_gpx_point_unref0 (self->bottom);
				self->bottom = _tmp78_;
			}
			_tmp79_ = self->bottom;
			_tmp80_ = point;
			_tmp81_ = _tmp80_->lon_dec;
			_tmp79_->lon_dec = _tmp81_;
			_tmp82_ = self->bottom;
			_tmp83_ = point;
			_tmp84_ = _tmp83_->lon;
			_tmp82_->lon = _tmp84_;
		}
		_tmp86_ = self->priv->last;
		_tmp87_ = _tmp86_->time;
		if (_tmp87_ != NULL) {
			GpxPoint* _tmp88_ = NULL;
			const gchar* _tmp89_ = NULL;
			_tmp88_ = point;
			_tmp89_ = _tmp88_->time;
			_tmp85_ = _tmp89_ != NULL;
		} else {
			_tmp85_ = FALSE;
		}
		_tmp90_ = _tmp85_;
		if (_tmp90_) {
			GpxPoint* _tmp91_ = NULL;
			GpxPoint* _tmp92_ = NULL;
			GpxPoint* _tmp93_ = NULL;
			gdouble _tmp94_ = 0.0;
			GpxPoint* _tmp95_ = NULL;
			gdouble _tmp96_ = 0.0;
			gdouble _tmp97_ = 0.0;
			GpxPoint* _tmp100_ = NULL;
			gdouble _tmp101_ = 0.0;
			gdouble _tmp102_ = 0.0;
			GpxPoint* _tmp105_ = NULL;
			gdouble _tmp106_ = 0.0;
			gdouble _tmp107_ = 0.0;
			_tmp91_ = point;
			_tmp92_ = self->priv->last;
			_tmp93_ = point;
			_tmp94_ = gpx_track_calculate_point_to_point_speed (self, _tmp92_, _tmp93_);
			_tmp91_->speed = _tmp94_;
			_tmp95_ = point;
			_tmp96_ = _tmp95_->speed;
			_tmp97_ = self->max_speed;
			if (_tmp96_ > _tmp97_) {
				GpxPoint* _tmp98_ = NULL;
				gdouble _tmp99_ = 0.0;
				_tmp98_ = point;
				_tmp99_ = _tmp98_->speed;
				self->max_speed = _tmp99_;
			}
			_tmp100_ = point;
			_tmp101_ = _tmp100_->elevation;
			_tmp102_ = self->max_elevation;
			if (_tmp101_ > _tmp102_) {
				GpxPoint* _tmp103_ = NULL;
				gdouble _tmp104_ = 0.0;
				_tmp103_ = point;
				_tmp104_ = _tmp103_->elevation;
				self->max_elevation = _tmp104_;
			}
			_tmp105_ = point;
			_tmp106_ = _tmp105_->elevation;
			_tmp107_ = self->min_elevation;
			if (_tmp106_ < _tmp107_) {
				GpxPoint* _tmp108_ = NULL;
				gdouble _tmp109_ = 0.0;
				_tmp108_ = point;
				_tmp109_ = _tmp108_->elevation;
				self->min_elevation = _tmp109_;
			}
		}
	} else {
		GpxPoint* _tmp110_ = NULL;
		gdouble _tmp111_ = 0.0;
		GpxPoint* _tmp112_ = NULL;
		gdouble _tmp113_ = 0.0;
		_tmp110_ = point;
		_tmp111_ = _tmp110_->elevation;
		self->max_elevation = _tmp111_;
		_tmp112_ = point;
		_tmp113_ = _tmp112_->elevation;
		self->min_elevation = _tmp113_;
	}
	_tmp114_ = point;
	_tmp115_ = _gpx_point_ref0 (_tmp114_);
	self->points = g_list_append (self->points, _tmp115_);
	_tmp116_ = point;
	_tmp117_ = _gpx_point_ref0 (_tmp116_);
	_gpx_point_unref0 (self->priv->last);
	self->priv->last = _tmp117_;
}


GpxTrack* gpx_track_cleanup_speed (GpxTrack* self) {
	GpxTrack* result = NULL;
	GpxTrack* retv = NULL;
	GpxTrack* _tmp0_ = NULL;
	GpxTrack* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	guint num_points = 0U;
	GList* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
	gdouble mean = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble deviation = 0.0;
	GList* list_copy = NULL;
	GList* _tmp6_ = NULL;
	GList* _tmp7_ = NULL;
	GList* iter = NULL;
	GList* _tmp8_ = NULL;
	GList* _tmp9_ = NULL;
	gdouble _tmp20_ = 0.0;
	guint _tmp21_ = 0U;
	gdouble sqrt_deviation = 0.0;
	gdouble _tmp22_ = 0.0;
	gdouble _tmp23_ = 0.0;
	GList* _tmp24_ = NULL;
	GList* _tmp25_ = NULL;
	guint i = 0U;
	GList* _tmp97_ = NULL;
	GList* _tmp98_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gpx_track_new ();
	retv = _tmp0_;
	_tmp1_ = retv;
	_tmp2_ = self->priv->_name;
	gpx_track_set_name (_tmp1_, _tmp2_);
	_tmp3_ = self->points;
	_tmp4_ = g_list_length (_tmp3_);
	num_points = _tmp4_;
	_tmp5_ = gpx_track_get_track_average (self);
	mean = _tmp5_;
	deviation = 0.0;
	_tmp6_ = self->points;
	_tmp7_ = g_list_copy (_tmp6_);
	list_copy = _tmp7_;
	_tmp8_ = list_copy;
	_tmp9_ = g_list_first (_tmp8_);
	iter = _tmp9_;
	while (TRUE) {
		GList* _tmp10_ = NULL;
		gdouble diff = 0.0;
		GList* _tmp11_ = NULL;
		gconstpointer _tmp12_ = NULL;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		gdouble _tmp17_ = 0.0;
		GList* _tmp18_ = NULL;
		GList* _tmp19_ = NULL;
		_tmp10_ = iter;
		if (!(_tmp10_ != NULL)) {
			break;
		}
		_tmp11_ = iter;
		_tmp12_ = _tmp11_->data;
		_tmp13_ = ((GpxPoint*) _tmp12_)->speed;
		_tmp14_ = mean;
		diff = _tmp13_ - _tmp14_;
		_tmp15_ = deviation;
		_tmp16_ = diff;
		_tmp17_ = diff;
		deviation = _tmp15_ + (_tmp16_ * _tmp17_);
		_tmp18_ = iter;
		_tmp19_ = _tmp18_->next;
		iter = _tmp19_;
	}
	_tmp20_ = deviation;
	_tmp21_ = num_points;
	deviation = _tmp20_ / _tmp21_;
	_tmp22_ = deviation;
	_tmp23_ = sqrt (_tmp22_);
	sqrt_deviation = _tmp23_;
	_tmp24_ = list_copy;
	_tmp25_ = g_list_first (_tmp24_);
	iter = _tmp25_;
	i = (guint) 0;
	while (TRUE) {
		GList* _tmp26_ = NULL;
		gdouble pspeed = 0.0;
		GList* _tmp27_ = NULL;
		gconstpointer _tmp28_ = NULL;
		gdouble _tmp29_ = 0.0;
		GList* _tmp30_ = NULL;
		GList* _tmp31_ = NULL;
		gdouble pdf = 0.0;
		gdouble _tmp36_ = 0.0;
		gdouble _tmp37_ = 0.0;
		gdouble _tmp38_ = 0.0;
		gdouble _tmp39_ = 0.0;
		gdouble _tmp40_ = 0.0;
		gdouble _tmp41_ = 0.0;
		gdouble _tmp42_ = 0.0;
		gdouble _tmp43_ = 0.0;
		gboolean _tmp44_ = FALSE;
		guint _tmp45_ = 0U;
		gdouble _tmp46_ = 0.0;
		gboolean _tmp50_ = FALSE;
		_tmp26_ = iter;
		if (!(_tmp26_ != NULL)) {
			break;
		}
		_tmp27_ = iter;
		_tmp28_ = _tmp27_->data;
		_tmp29_ = ((GpxPoint*) _tmp28_)->speed;
		pspeed = _tmp29_;
		_tmp30_ = iter;
		_tmp31_ = _tmp30_->next;
		if (_tmp31_ != NULL) {
			GList* _tmp32_ = NULL;
			GList* _tmp33_ = NULL;
			gconstpointer _tmp34_ = NULL;
			gdouble _tmp35_ = 0.0;
			_tmp32_ = iter;
			_tmp33_ = _tmp32_->next;
			_tmp34_ = _tmp33_->data;
			_tmp35_ = ((GpxPoint*) _tmp34_)->speed;
			pspeed = _tmp35_;
		}
		_tmp36_ = deviation;
		_tmp37_ = sqrt ((2 * G_PI) * _tmp36_);
		_tmp38_ = pspeed;
		_tmp39_ = mean;
		_tmp40_ = pspeed;
		_tmp41_ = mean;
		_tmp42_ = deviation;
		_tmp43_ = exp ((-((_tmp38_ - _tmp39_) * (_tmp40_ - _tmp41_))) / (2 * _tmp42_));
		pdf = (1 / _tmp37_) * _tmp43_;
		_tmp45_ = num_points;
		_tmp46_ = pdf;
		if ((_tmp45_ * _tmp46_) < 0.1) {
			GList* _tmp47_ = NULL;
			gconstpointer _tmp48_ = NULL;
			gboolean _tmp49_ = FALSE;
			_tmp47_ = iter;
			_tmp48_ = _tmp47_->data;
			_tmp49_ = ((GpxPoint*) _tmp48_)->stopped;
			_tmp44_ = !_tmp49_;
		} else {
			_tmp44_ = FALSE;
		}
		_tmp50_ = _tmp44_;
		if (_tmp50_) {
			GList* temp = NULL;
			GList* _tmp51_ = NULL;
			GList* _tmp52_ = NULL;
			GList* _tmp53_ = NULL;
			GList* _tmp54_ = NULL;
			_tmp51_ = iter;
			_tmp52_ = _tmp51_->prev;
			temp = _tmp52_;
			_tmp53_ = iter;
			list_copy = g_list_remove_link (list_copy, _tmp53_);
			_tmp54_ = temp;
			if (_tmp54_ != NULL) {
				GList* _tmp55_ = NULL;
				GList* _tmp56_ = NULL;
				GList* _tmp57_ = NULL;
				_tmp55_ = temp;
				iter = _tmp55_;
				_tmp56_ = iter;
				_tmp57_ = _tmp56_->next;
				if (_tmp57_ != NULL) {
					GList* _tmp58_ = NULL;
					GList* _tmp59_ = NULL;
					gconstpointer _tmp60_ = NULL;
					GList* _tmp61_ = NULL;
					gconstpointer _tmp62_ = NULL;
					GList* _tmp63_ = NULL;
					GList* _tmp64_ = NULL;
					gconstpointer _tmp65_ = NULL;
					gdouble _tmp66_ = 0.0;
					_tmp58_ = iter;
					_tmp59_ = _tmp58_->next;
					_tmp60_ = _tmp59_->data;
					_tmp61_ = iter;
					_tmp62_ = _tmp61_->data;
					_tmp63_ = iter;
					_tmp64_ = _tmp63_->next;
					_tmp65_ = _tmp64_->data;
					_tmp66_ = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) _tmp62_, (GpxPoint*) _tmp65_);
					((GpxPoint*) _tmp60_)->speed = _tmp66_;
				}
			} else {
				GList* _tmp67_ = NULL;
				GList* _tmp68_ = NULL;
				GList* _tmp69_ = NULL;
				i = (guint) 0;
				_tmp67_ = list_copy;
				_tmp68_ = g_list_first (_tmp67_);
				iter = _tmp68_;
				_tmp69_ = iter;
				if (_tmp69_ != NULL) {
					GList* _tmp70_ = NULL;
					gconstpointer _tmp71_ = NULL;
					GList* _tmp72_ = NULL;
					gconstpointer _tmp73_ = NULL;
					GList* _tmp74_ = NULL;
					GList* _tmp75_ = NULL;
					_tmp70_ = iter;
					_tmp71_ = _tmp70_->data;
					((GpxPoint*) _tmp71_)->speed = 0.0;
					_tmp72_ = iter;
					_tmp73_ = _tmp72_->data;
					((GpxPoint*) _tmp73_)->distance = 0.0;
					_tmp74_ = iter;
					_tmp75_ = _tmp74_->next;
					if (_tmp75_ != NULL) {
						GList* _tmp76_ = NULL;
						GList* _tmp77_ = NULL;
						gconstpointer _tmp78_ = NULL;
						GList* _tmp79_ = NULL;
						gconstpointer _tmp80_ = NULL;
						GList* _tmp81_ = NULL;
						GList* _tmp82_ = NULL;
						gconstpointer _tmp83_ = NULL;
						gdouble _tmp84_ = 0.0;
						GList* _tmp85_ = NULL;
						GList* _tmp86_ = NULL;
						gconstpointer _tmp87_ = NULL;
						GList* _tmp88_ = NULL;
						gconstpointer _tmp89_ = NULL;
						GList* _tmp90_ = NULL;
						GList* _tmp91_ = NULL;
						gconstpointer _tmp92_ = NULL;
						gdouble _tmp93_ = 0.0;
						_tmp76_ = iter;
						_tmp77_ = _tmp76_->next;
						_tmp78_ = _tmp77_->data;
						_tmp79_ = iter;
						_tmp80_ = _tmp79_->data;
						_tmp81_ = iter;
						_tmp82_ = _tmp81_->next;
						_tmp83_ = _tmp82_->data;
						_tmp84_ = gpx_track_calculate_distance ((GpxPoint*) _tmp80_, (GpxPoint*) _tmp83_);
						((GpxPoint*) _tmp78_)->distance = _tmp84_;
						_tmp85_ = iter;
						_tmp86_ = _tmp85_->next;
						_tmp87_ = _tmp86_->data;
						_tmp88_ = iter;
						_tmp89_ = _tmp88_->data;
						_tmp90_ = iter;
						_tmp91_ = _tmp90_->next;
						_tmp92_ = _tmp91_->data;
						_tmp93_ = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) _tmp89_, (GpxPoint*) _tmp92_);
						((GpxPoint*) _tmp87_)->speed = _tmp93_;
					}
				}
			}
		} else {
			GList* _tmp94_ = NULL;
			GList* _tmp95_ = NULL;
			guint _tmp96_ = 0U;
			_tmp94_ = iter;
			_tmp95_ = _tmp94_->next;
			iter = _tmp95_;
			_tmp96_ = i;
			i = _tmp96_ + 1;
		}
	}
	_tmp97_ = list_copy;
	_tmp98_ = g_list_first (_tmp97_);
	iter = _tmp98_;
	while (TRUE) {
		GList* _tmp99_ = NULL;
		GpxTrack* _tmp100_ = NULL;
		GList* _tmp101_ = NULL;
		gconstpointer _tmp102_ = NULL;
		GList* _tmp103_ = NULL;
		GList* _tmp104_ = NULL;
		_tmp99_ = iter;
		if (!(_tmp99_ != NULL)) {
			break;
		}
		_tmp100_ = retv;
		_tmp101_ = iter;
		_tmp102_ = _tmp101_->data;
		gpx_track_add_point (_tmp100_, (GpxPoint*) _tmp102_);
		_tmp103_ = iter;
		_tmp104_ = _tmp103_->next;
		iter = _tmp104_;
	}
	result = retv;
	_g_list_free0 (list_copy);
	return result;
}


/**
         * Calculate the speed of the full track
         *
         * @returns the average speed of the full track in km/h.
         */
gdouble gpx_track_get_track_average (GpxTrack* self) {
	gdouble result = 0.0;
	GList* first = NULL;
	GList* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* last = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GList* _tmp5_ = NULL;
	gboolean _tmp7_ = FALSE;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->points;
	_tmp1_ = g_list_first (_tmp0_);
	first = _tmp1_;
	_tmp2_ = self->points;
	_tmp3_ = g_list_last (_tmp2_);
	last = _tmp3_;
	_tmp5_ = first;
	if (_tmp5_ != NULL) {
		GList* _tmp6_ = NULL;
		_tmp6_ = last;
		_tmp4_ = _tmp6_ != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		GList* _tmp8_ = NULL;
		gconstpointer _tmp9_ = NULL;
		GList* _tmp10_ = NULL;
		gconstpointer _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
		_tmp8_ = first;
		_tmp9_ = _tmp8_->data;
		_tmp10_ = last;
		_tmp11_ = _tmp10_->data;
		_tmp12_ = gpx_track_calculate_point_to_point_speed (self, (GpxPoint*) _tmp9_, (GpxPoint*) _tmp11_);
		result = _tmp12_;
		return result;
	}
	result = (gdouble) 0;
	return result;
}


/**
         * Calculate the average speed between Point a and Point b on the track
         */
gdouble gpx_track_calculate_point_to_point_speed (GpxTrack* self, GpxPoint* a, GpxPoint* b) {
	gdouble result = 0.0;
	gdouble dist = 0.0;
	GpxPoint* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	GpxPoint* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	GpxPoint* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp9_ = FALSE;
	time_t ta = 0;
	GpxPoint* _tmp10_ = NULL;
	time_t _tmp11_ = 0;
	time_t tb = 0;
	GpxPoint* _tmp12_ = NULL;
	time_t _tmp13_ = 0;
	time_t _tmp14_ = 0;
	time_t _tmp15_ = 0;
	gdouble _tmp16_ = 0.0;
	time_t _tmp17_ = 0;
	time_t _tmp18_ = 0;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (a != NULL, 0.0);
	g_return_val_if_fail (b != NULL, 0.0);
	_tmp0_ = b;
	_tmp1_ = _tmp0_->distance;
	_tmp2_ = a;
	_tmp3_ = _tmp2_->distance;
	dist = _tmp1_ - _tmp3_;
	_tmp5_ = a;
	_tmp6_ = _tmp5_->time;
	if (_tmp6_ == NULL) {
		_tmp4_ = TRUE;
	} else {
		GpxPoint* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		_tmp7_ = b;
		_tmp8_ = _tmp7_->time;
		_tmp4_ = _tmp8_ == NULL;
	}
	_tmp9_ = _tmp4_;
	if (_tmp9_) {
		result = (gdouble) 0;
		return result;
	}
	_tmp10_ = a;
	_tmp11_ = gpx_point_get_time (_tmp10_);
	ta = _tmp11_;
	_tmp12_ = b;
	_tmp13_ = gpx_point_get_time (_tmp12_);
	tb = _tmp13_;
	_tmp14_ = tb;
	_tmp15_ = ta;
	if ((_tmp14_ - _tmp15_) == ((time_t) 0)) {
		result = (gdouble) 0;
		return result;
	}
	_tmp16_ = dist;
	_tmp17_ = tb;
	_tmp18_ = ta;
	result = _tmp16_ / ((_tmp17_ - _tmp18_) / (60.0 * 60.0));
	return result;
}


time_t gpx_track_get_total_time (GpxTrack* self) {
	time_t result = 0;
	GpxPoint* a = NULL;
	GpxPoint* b = NULL;
	GList* na = NULL;
	GList* _tmp0_ = NULL;
	GList* _tmp1_ = NULL;
	GList* nb = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GList* _tmp5_ = NULL;
	gboolean _tmp7_ = FALSE;
	GList* _tmp8_ = NULL;
	gconstpointer _tmp9_ = NULL;
	GpxPoint* _tmp10_ = NULL;
	GList* _tmp11_ = NULL;
	gconstpointer _tmp12_ = NULL;
	GpxPoint* _tmp13_ = NULL;
	time_t time = 0;
	GpxPoint* _tmp14_ = NULL;
	time_t _tmp15_ = 0;
	GpxPoint* _tmp16_ = NULL;
	time_t _tmp17_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->points;
	_tmp1_ = g_list_first (_tmp0_);
	na = _tmp1_;
	_tmp2_ = self->points;
	_tmp3_ = g_list_last (_tmp2_);
	nb = _tmp3_;
	_tmp5_ = na;
	if (_tmp5_ == NULL) {
		_tmp4_ = TRUE;
	} else {
		GList* _tmp6_ = NULL;
		_tmp6_ = nb;
		_tmp4_ = _tmp6_ == NULL;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		result = (time_t) 0;
		_gpx_point_unref0 (b);
		_gpx_point_unref0 (a);
		return result;
	}
	_tmp8_ = na;
	_tmp9_ = _tmp8_->data;
	_tmp10_ = _gpx_point_ref0 ((GpxPoint*) _tmp9_);
	_gpx_point_unref0 (a);
	a = _tmp10_;
	_tmp11_ = nb;
	_tmp12_ = _tmp11_->data;
	_tmp13_ = _gpx_point_ref0 ((GpxPoint*) _tmp12_);
	_gpx_point_unref0 (b);
	b = _tmp13_;
	_tmp14_ = b;
	_tmp15_ = gpx_point_get_time (_tmp14_);
	_tmp16_ = a;
	_tmp17_ = gpx_point_get_time (_tmp16_);
	time = _tmp15_ - _tmp17_;
	result = time;
	_gpx_point_unref0 (b);
	_gpx_point_unref0 (a);
	return result;
}


/**
         * Try not to calculate time that we "stopped"  in average
         */
gdouble gpx_track_calculate_moving_average (GpxTrack* self, GpxPoint* start, GpxPoint* stop, time_t* moving_time) {
	time_t _vala_moving_time = 0;
	gdouble result = 0.0;
	gdouble time = 0.0;
	gdouble distance = 0.0;
	GList* iter = NULL;
	GList* _tmp0_ = NULL;
	GpxPoint* _tmp1_ = NULL;
	GList* _tmp2_ = NULL;
	GList* _tmp3_ = NULL;
	GList* _tmp4_ = NULL;
	gdouble _tmp33_ = 0.0;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (start != NULL, 0.0);
	g_return_val_if_fail (stop != NULL, 0.0);
	time = (gdouble) 0;
	distance = (gdouble) 0;
	_vala_moving_time = (time_t) 0;
	_tmp0_ = self->points;
	_tmp1_ = start;
	_tmp2_ = g_list_find (_tmp0_, _tmp1_);
	iter = _tmp2_;
	_tmp3_ = iter;
	if (_tmp3_ == NULL) {
		result = (gdouble) 0;
		if (moving_time) {
			*moving_time = _vala_moving_time;
		}
		return result;
	}
	_tmp4_ = iter;
	if (_tmp4_ != NULL) {
		while (TRUE) {
			gboolean _tmp5_ = FALSE;
			GList* _tmp6_ = NULL;
			GList* _tmp7_ = NULL;
			GList* _tmp8_ = NULL;
			gboolean _tmp13_ = FALSE;
			GpxPoint* b = NULL;
			GList* _tmp14_ = NULL;
			gconstpointer _tmp15_ = NULL;
			GpxPoint* _tmp16_ = NULL;
			GpxPoint* _tmp17_ = NULL;
			gboolean _tmp18_ = FALSE;
			_tmp6_ = iter;
			_tmp7_ = _tmp6_->next;
			iter = _tmp7_;
			_tmp8_ = iter;
			if (_tmp8_ != NULL) {
				GList* _tmp9_ = NULL;
				GList* _tmp10_ = NULL;
				gconstpointer _tmp11_ = NULL;
				GpxPoint* _tmp12_ = NULL;
				_tmp9_ = iter;
				_tmp10_ = _tmp9_->prev;
				_tmp11_ = _tmp10_->data;
				_tmp12_ = stop;
				_tmp5_ = ((GpxPoint*) _tmp11_) != _tmp12_;
			} else {
				_tmp5_ = FALSE;
			}
			_tmp13_ = _tmp5_;
			if (!_tmp13_) {
				break;
			}
			_tmp14_ = iter;
			_tmp15_ = _tmp14_->data;
			_tmp16_ = _gpx_point_ref0 ((GpxPoint*) _tmp15_);
			b = _tmp16_;
			_tmp17_ = b;
			_tmp18_ = _tmp17_->stopped;
			if (!_tmp18_) {
				gdouble _tmp19_ = 0.0;
				GpxPoint* _tmp20_ = NULL;
				time_t _tmp21_ = 0;
				GList* _tmp22_ = NULL;
				GList* _tmp23_ = NULL;
				gconstpointer _tmp24_ = NULL;
				time_t _tmp25_ = 0;
				gdouble _tmp26_ = 0.0;
				GpxPoint* _tmp27_ = NULL;
				gdouble _tmp28_ = 0.0;
				GList* _tmp29_ = NULL;
				GList* _tmp30_ = NULL;
				gconstpointer _tmp31_ = NULL;
				gdouble _tmp32_ = 0.0;
				_tmp19_ = time;
				_tmp20_ = b;
				_tmp21_ = gpx_point_get_time (_tmp20_);
				_tmp22_ = iter;
				_tmp23_ = _tmp22_->prev;
				_tmp24_ = _tmp23_->data;
				_tmp25_ = gpx_point_get_time ((GpxPoint*) _tmp24_);
				time = _tmp19_ + (_tmp21_ - _tmp25_);
				_tmp26_ = distance;
				_tmp27_ = b;
				_tmp28_ = _tmp27_->distance;
				_tmp29_ = iter;
				_tmp30_ = _tmp29_->prev;
				_tmp31_ = _tmp30_->data;
				_tmp32_ = ((GpxPoint*) _tmp31_)->distance;
				distance = _tmp26_ + (_tmp28_ - _tmp32_);
			}
			_gpx_point_unref0 (b);
		}
	}
	_tmp33_ = time;
	_vala_moving_time = (time_t) _tmp33_;
	_tmp34_ = distance;
	_tmp35_ = time;
	result = _tmp34_ / (_tmp35_ / (60.0 * 60.0));
	if (moving_time) {
		*moving_time = _vala_moving_time;
	}
	return result;
}


/**
 * @param lon_a longitude in radians of point a
 * @param lat_a latitude in radians of point a
 * @param lon_b longitude in radians of point b
 * @param lat_a latitude in radians of point b
         * Calculate distance between point a and point b using great circular distance method
         * Elevation is not taken into account.
         *
         * @returns distance in km.		 
 */
gdouble gpx_track_calculate_distance_coords (gdouble lon_a, gdouble lat_a, gdouble lon_b, gdouble lat_b) {
	gdouble result = 0.0;
	gdouble retv = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_ = 0.0;
	gint _tmp13_ = 0;
	retv = (gdouble) 0;
	_tmp0_ = lat_a;
	_tmp1_ = sin (_tmp0_);
	_tmp2_ = lat_b;
	_tmp3_ = sin (_tmp2_);
	_tmp4_ = lat_a;
	_tmp5_ = cos (_tmp4_);
	_tmp6_ = lat_b;
	_tmp7_ = cos (_tmp6_);
	_tmp8_ = lon_b;
	_tmp9_ = lon_a;
	_tmp10_ = cos (_tmp8_ - _tmp9_);
	_tmp11_ = acos ((_tmp1_ * _tmp3_) + ((_tmp5_ * _tmp7_) * _tmp10_));
	retv = 6378.7 * _tmp11_;
	_tmp12_ = retv;
	_tmp13_ = isnan (_tmp12_);
	if (_tmp13_ == 1) {
		result = (gdouble) 0;
		return result;
	}
	result = retv;
	return result;
}


/**
         * @param a the first Gpx.Point
         * @param b the second Gpx.Point
         *
         * Calculate distance between point a and point b using great circular distance method
         * Elevation is not taken into account.
         *
         * @returns distance in km.
         */
gdouble gpx_track_calculate_distance (GpxPoint* a, GpxPoint* b) {
	gdouble result = 0.0;
	gboolean _tmp0_ = FALSE;
	GpxPoint* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	GpxPoint* _tmp3_ = NULL;
	gdouble _tmp4_ = 0.0;
	gboolean _tmp9_ = FALSE;
	GpxPoint* _tmp10_ = NULL;
	gdouble _tmp11_ = 0.0;
	GpxPoint* _tmp12_ = NULL;
	gdouble _tmp13_ = 0.0;
	GpxPoint* _tmp14_ = NULL;
	gdouble _tmp15_ = 0.0;
	GpxPoint* _tmp16_ = NULL;
	gdouble _tmp17_ = 0.0;
	gdouble _tmp18_ = 0.0;
	g_return_val_if_fail (a != NULL, 0.0);
	g_return_val_if_fail (b != NULL, 0.0);
	_tmp1_ = a;
	_tmp2_ = _tmp1_->lat;
	_tmp3_ = b;
	_tmp4_ = _tmp3_->lat;
	if (_tmp2_ == _tmp4_) {
		GpxPoint* _tmp5_ = NULL;
		gdouble _tmp6_ = 0.0;
		GpxPoint* _tmp7_ = NULL;
		gdouble _tmp8_ = 0.0;
		_tmp5_ = a;
		_tmp6_ = _tmp5_->lon;
		_tmp7_ = b;
		_tmp8_ = _tmp7_->lon;
		_tmp0_ = _tmp6_ == _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	_tmp9_ = _tmp0_;
	if (_tmp9_) {
		result = (gdouble) 0;
		return result;
	}
	_tmp10_ = a;
	_tmp11_ = _tmp10_->lon;
	_tmp12_ = a;
	_tmp13_ = _tmp12_->lat;
	_tmp14_ = b;
	_tmp15_ = _tmp14_->lon;
	_tmp16_ = b;
	_tmp17_ = _tmp16_->lat;
	_tmp18_ = gpx_track_calculate_distance_coords (_tmp11_, _tmp13_, _tmp15_, _tmp17_);
	result = _tmp18_;
	return result;
}


GpxTrack* gpx_track_construct (GType object_type) {
	GpxTrack * self = NULL;
	self = (GpxTrack*) g_object_new (object_type, NULL);
	return self;
}


GpxTrack* gpx_track_new (void) {
	return gpx_track_construct (GPX_TYPE_TRACK);
}


const gchar* gpx_track_get_name (GpxTrack* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void gpx_track_set_name (GpxTrack* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


static void gpx_track_class_init (GpxTrackClass * klass) {
	gpx_track_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxTrackPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_gpx_track_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gpx_track_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpx_track_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_TRACK_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void gpx_track_instance_init (GpxTrack * self) {
	self->priv = GPX_TRACK_GET_PRIVATE (self);
	self->priv->_name = NULL;
	self->filtered_points = 0;
	self->total_distance = 0.0;
	self->max_speed = (gdouble) 0;
	self->max_elevation = 0.0;
	self->min_elevation = 0.0;
	self->points = NULL;
	self->priv->last = NULL;
	self->top = NULL;
	self->bottom = NULL;
}


static void gpx_track_finalize (GObject* obj) {
	GpxTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_TRACK, GpxTrack);
	_g_free0 (self->priv->_name);
	__g_list_free__gpx_point_unref0_0 (self->points);
	_gpx_point_unref0 (self->priv->last);
	_gpx_point_unref0 (self->top);
	_gpx_point_unref0 (self->bottom);
	G_OBJECT_CLASS (gpx_track_parent_class)->finalize (obj);
}


/**
     * This class represents a Track in a gpx file.
     * The tracks contains the points connecting everything together.
     * Info like total distance, average speed, moving speed/time etc are available.
     */
GType gpx_track_get_type (void) {
	static volatile gsize gpx_track_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_track_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxTrackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_track_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxTrack), 0, (GInstanceInitFunc) gpx_track_instance_init, NULL };
		GType gpx_track_type_id;
		gpx_track_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxTrack", &g_define_type_info, 0);
		g_once_init_leave (&gpx_track_type_id__volatile, gpx_track_type_id);
	}
	return gpx_track_type_id__volatile;
}


static void _vala_gpx_track_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GpxTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_TRACK, GpxTrack);
	switch (property_id) {
		case GPX_TRACK_NAME:
		g_value_set_string (value, gpx_track_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_gpx_track_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GpxTrack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GPX_TYPE_TRACK, GpxTrack);
	switch (property_id) {
		case GPX_TRACK_NAME:
		gpx_track_set_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static GpxTrack* gpx_file_parse_track (GpxFile* self, xmlNode* node) {
	GpxTrack* result = NULL;
	GpxTrack* track = NULL;
	GpxTrack* _tmp0_ = NULL;
	xmlNode* trkseg = NULL;
	xmlNode* _tmp1_ = NULL;
	xmlNode* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gpx_track_new ();
	track = _tmp0_;
	_tmp1_ = node;
	_tmp2_ = _tmp1_->children;
	trkseg = _tmp2_;
	while (TRUE) {
		xmlNode* _tmp3_ = NULL;
		xmlNode* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		xmlNode* _tmp51_ = NULL;
		const gchar* _tmp52_ = NULL;
		xmlNode* _tmp63_ = NULL;
		xmlNode* _tmp64_ = NULL;
		_tmp3_ = trkseg;
		if (!(_tmp3_ != NULL)) {
			break;
		}
		_tmp4_ = trkseg;
		_tmp5_ = _tmp4_->name;
		if (g_strcmp0 (_tmp5_, "trkseg") == 0) {
			xmlNode* point = NULL;
			xmlNode* _tmp6_ = NULL;
			xmlNode* _tmp7_ = NULL;
			_tmp6_ = trkseg;
			_tmp7_ = _tmp6_->children;
			point = _tmp7_;
			while (TRUE) {
				xmlNode* _tmp8_ = NULL;
				xmlNode* _tmp9_ = NULL;
				const gchar* _tmp10_ = NULL;
				xmlNode* _tmp49_ = NULL;
				xmlNode* _tmp50_ = NULL;
				_tmp8_ = point;
				if (!(_tmp8_ != NULL)) {
					break;
				}
				_tmp9_ = point;
				_tmp10_ = _tmp9_->name;
				if (g_strcmp0 (_tmp10_, "trkpt") == 0) {
					gchar* lat = NULL;
					xmlNode* _tmp11_ = NULL;
					gchar* _tmp12_ = NULL;
					gchar* lon = NULL;
					xmlNode* _tmp13_ = NULL;
					gchar* _tmp14_ = NULL;
					gboolean _tmp15_ = FALSE;
					const gchar* _tmp16_ = NULL;
					gboolean _tmp18_ = FALSE;
					_tmp11_ = point;
					_tmp12_ = xmlGetProp (_tmp11_, "lat");
					lat = _tmp12_;
					_tmp13_ = point;
					_tmp14_ = xmlGetProp (_tmp13_, "lon");
					lon = _tmp14_;
					_tmp16_ = lat;
					if (_tmp16_ != NULL) {
						const gchar* _tmp17_ = NULL;
						_tmp17_ = lon;
						_tmp15_ = _tmp17_ != NULL;
					} else {
						_tmp15_ = FALSE;
					}
					_tmp18_ = _tmp15_;
					if (_tmp18_) {
						GpxPoint* p = NULL;
						GpxPoint* _tmp19_ = NULL;
						gdouble flat = 0.0;
						const gchar* _tmp20_ = NULL;
						gdouble _tmp21_ = 0.0;
						gdouble flon = 0.0;
						const gchar* _tmp22_ = NULL;
						gdouble _tmp23_ = 0.0;
						GpxPoint* _tmp24_ = NULL;
						gdouble _tmp25_ = 0.0;
						gdouble _tmp26_ = 0.0;
						xmlNode* info = NULL;
						xmlNode* _tmp27_ = NULL;
						xmlNode* _tmp28_ = NULL;
						GpxTrack* _tmp45_ = NULL;
						GpxPoint* _tmp46_ = NULL;
						_tmp19_ = gpx_point_new ();
						p = _tmp19_;
						_tmp20_ = lat;
						_tmp21_ = g_ascii_strtod (_tmp20_, NULL);
						flat = _tmp21_;
						_tmp22_ = lon;
						_tmp23_ = g_ascii_strtod (_tmp22_, NULL);
						flon = _tmp23_;
						_tmp24_ = p;
						_tmp25_ = flat;
						_tmp26_ = flon;
						gpx_point_set_position (_tmp24_, _tmp25_, _tmp26_);
						_tmp27_ = point;
						_tmp28_ = _tmp27_->children;
						info = _tmp28_;
						while (TRUE) {
							xmlNode* _tmp29_ = NULL;
							xmlNode* _tmp30_ = NULL;
							const gchar* _tmp31_ = NULL;
							xmlNode* _tmp43_ = NULL;
							xmlNode* _tmp44_ = NULL;
							_tmp29_ = info;
							if (!(_tmp29_ != NULL)) {
								break;
							}
							_tmp30_ = info;
							_tmp31_ = _tmp30_->name;
							if (g_strcmp0 (_tmp31_, "ele") == 0) {
								gchar* content = NULL;
								xmlNode* _tmp32_ = NULL;
								gchar* _tmp33_ = NULL;
								const gchar* _tmp34_ = NULL;
								_tmp32_ = info;
								_tmp33_ = xmlNodeGetContent (_tmp32_);
								content = _tmp33_;
								_tmp34_ = content;
								if (_tmp34_ != NULL) {
									GpxPoint* _tmp35_ = NULL;
									const gchar* _tmp36_ = NULL;
									gdouble _tmp37_ = 0.0;
									_tmp35_ = p;
									_tmp36_ = content;
									_tmp37_ = g_ascii_strtod (_tmp36_, NULL);
									_tmp35_->elevation = _tmp37_;
								}
								_g_free0 (content);
							} else {
								xmlNode* _tmp38_ = NULL;
								const gchar* _tmp39_ = NULL;
								_tmp38_ = info;
								_tmp39_ = _tmp38_->name;
								if (g_strcmp0 (_tmp39_, "time") == 0) {
									GpxPoint* _tmp40_ = NULL;
									xmlNode* _tmp41_ = NULL;
									gchar* _tmp42_ = NULL;
									_tmp40_ = p;
									_tmp41_ = info;
									_tmp42_ = xmlNodeGetContent (_tmp41_);
									_g_free0 (_tmp40_->time);
									_tmp40_->time = _tmp42_;
								}
							}
							_tmp43_ = info;
							_tmp44_ = _tmp43_->next;
							info = _tmp44_;
						}
						_tmp45_ = track;
						_tmp46_ = p;
						gpx_track_add_point (_tmp45_, _tmp46_);
						_gpx_point_unref0 (p);
					} else {
						xmlNode* _tmp47_ = NULL;
						const gchar* _tmp48_ = NULL;
						_tmp47_ = point;
						_tmp48_ = _tmp47_->name;
						g_message ("gpx-parser.vala:506: Failed to get point: %s\n", _tmp48_);
					}
					_g_free0 (lon);
					_g_free0 (lat);
				}
				_tmp49_ = point;
				_tmp50_ = _tmp49_->next;
				point = _tmp50_;
			}
		}
		_tmp51_ = trkseg;
		_tmp52_ = _tmp51_->name;
		if (g_strcmp0 (_tmp52_, "name") == 0) {
			GpxTrack* _tmp53_ = NULL;
			const gchar* _tmp54_ = NULL;
			const gchar* _tmp55_ = NULL;
			_tmp53_ = track;
			_tmp54_ = gpx_track_get_name (_tmp53_);
			_tmp55_ = _tmp54_;
			if (_tmp55_ == NULL) {
				GpxTrack* _tmp56_ = NULL;
				xmlNode* _tmp57_ = NULL;
				gchar* _tmp58_ = NULL;
				gchar* _tmp59_ = NULL;
				_tmp56_ = track;
				_tmp57_ = trkseg;
				_tmp58_ = xmlNodeGetContent (_tmp57_);
				_tmp59_ = _tmp58_;
				gpx_track_set_name (_tmp56_, _tmp59_);
				_g_free0 (_tmp59_);
			} else {
				GpxTrack* _tmp60_ = NULL;
				const gchar* _tmp61_ = NULL;
				const gchar* _tmp62_ = NULL;
				_tmp60_ = track;
				_tmp61_ = gpx_track_get_name (_tmp60_);
				_tmp62_ = _tmp61_;
				g_warning ("gpx-parser.vala:520: Track name allready set: %s\n", _tmp62_);
			}
		}
		_tmp63_ = trkseg;
		_tmp64_ = _tmp63_->next;
		trkseg = _tmp64_;
	}
	result = track;
	return result;
}


static void gpx_file_parse_waypoint (GpxFile* self, xmlNode* node) {
	gchar* lat = NULL;
	xmlNode* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* lon = NULL;
	xmlNode* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp7_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = node;
	_tmp1_ = xmlGetProp (_tmp0_, "lat");
	lat = _tmp1_;
	_tmp2_ = node;
	_tmp3_ = xmlGetProp (_tmp2_, "lon");
	lon = _tmp3_;
	_tmp5_ = lat;
	if (_tmp5_ != NULL) {
		const gchar* _tmp6_ = NULL;
		_tmp6_ = lon;
		_tmp4_ = _tmp6_ != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	_tmp7_ = _tmp4_;
	if (_tmp7_) {
		GpxPoint* p = NULL;
		GpxPoint* _tmp8_ = NULL;
		gdouble flat = 0.0;
		const gchar* _tmp9_ = NULL;
		gdouble _tmp10_ = 0.0;
		gdouble flon = 0.0;
		const gchar* _tmp11_ = NULL;
		gdouble _tmp12_ = 0.0;
		GpxPoint* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		xmlNode* info = NULL;
		xmlNode* _tmp16_ = NULL;
		xmlNode* _tmp17_ = NULL;
		GpxPoint* _tmp33_ = NULL;
		GpxPoint* _tmp34_ = NULL;
		_tmp8_ = gpx_point_new ();
		p = _tmp8_;
		_tmp9_ = lat;
		_tmp10_ = g_ascii_strtod (_tmp9_, NULL);
		flat = _tmp10_;
		_tmp11_ = lon;
		_tmp12_ = g_ascii_strtod (_tmp11_, NULL);
		flon = _tmp12_;
		_tmp13_ = p;
		_tmp14_ = flat;
		_tmp15_ = flon;
		gpx_point_set_position (_tmp13_, _tmp14_, _tmp15_);
		_tmp16_ = node;
		_tmp17_ = _tmp16_->children;
		info = _tmp17_;
		while (TRUE) {
			xmlNode* _tmp18_ = NULL;
			xmlNode* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			xmlNode* _tmp31_ = NULL;
			xmlNode* _tmp32_ = NULL;
			_tmp18_ = info;
			if (!(_tmp18_ != NULL)) {
				break;
			}
			_tmp19_ = info;
			_tmp20_ = _tmp19_->name;
			if (g_strcmp0 (_tmp20_, "name") == 0) {
				GpxPoint* _tmp21_ = NULL;
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				_tmp21_ = p;
				_tmp22_ = gpx_point_get_name (_tmp21_);
				_tmp23_ = _tmp22_;
				if (_tmp23_ == NULL) {
					GpxPoint* _tmp24_ = NULL;
					xmlNode* _tmp25_ = NULL;
					gchar* _tmp26_ = NULL;
					gchar* _tmp27_ = NULL;
					_tmp24_ = p;
					_tmp25_ = info;
					_tmp26_ = xmlNodeGetContent (_tmp25_);
					_tmp27_ = _tmp26_;
					gpx_point_set_name (_tmp24_, _tmp27_);
					_g_free0 (_tmp27_);
				} else {
					GpxPoint* _tmp28_ = NULL;
					const gchar* _tmp29_ = NULL;
					const gchar* _tmp30_ = NULL;
					_tmp28_ = p;
					_tmp29_ = gpx_point_get_name (_tmp28_);
					_tmp30_ = _tmp29_;
					g_warning ("gpx-parser.vala:551: Point name allready set: %s\n", _tmp30_);
				}
			}
			_tmp31_ = info;
			_tmp32_ = _tmp31_->next;
			info = _tmp32_;
		}
		_tmp33_ = p;
		_tmp34_ = _gpx_point_ref0 (_tmp33_);
		self->waypoints = g_list_append (self->waypoints, _tmp34_);
		_gpx_point_unref0 (p);
	}
	_g_free0 (lon);
	_g_free0 (lat);
}


static GpxTrack* gpx_file_parse_route (GpxFile* self, xmlNode* node) {
	GpxTrack* result = NULL;
	GpxTrack* track = NULL;
	GpxTrack* _tmp0_ = NULL;
	xmlNode* trkseg = NULL;
	xmlNode* _tmp1_ = NULL;
	xmlNode* _tmp2_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gpx_track_new ();
	track = _tmp0_;
	_tmp1_ = node;
	_tmp2_ = _tmp1_->children;
	trkseg = _tmp2_;
	while (TRUE) {
		xmlNode* _tmp3_ = NULL;
		xmlNode* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		xmlNode* _tmp56_ = NULL;
		xmlNode* _tmp57_ = NULL;
		_tmp3_ = trkseg;
		if (!(_tmp3_ != NULL)) {
			break;
		}
		_tmp4_ = trkseg;
		_tmp5_ = _tmp4_->name;
		if (g_strcmp0 (_tmp5_, "rtept") == 0) {
			gchar* lat = NULL;
			xmlNode* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			gchar* lon = NULL;
			xmlNode* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			const gchar* _tmp11_ = NULL;
			gboolean _tmp13_ = FALSE;
			_tmp6_ = trkseg;
			_tmp7_ = xmlGetProp (_tmp6_, "lat");
			lat = _tmp7_;
			_tmp8_ = trkseg;
			_tmp9_ = xmlGetProp (_tmp8_, "lon");
			lon = _tmp9_;
			_tmp11_ = lat;
			if (_tmp11_ != NULL) {
				const gchar* _tmp12_ = NULL;
				_tmp12_ = lon;
				_tmp10_ = _tmp12_ != NULL;
			} else {
				_tmp10_ = FALSE;
			}
			_tmp13_ = _tmp10_;
			if (_tmp13_) {
				GpxPoint* p = NULL;
				GpxPoint* _tmp14_ = NULL;
				gdouble flat = 0.0;
				const gchar* _tmp15_ = NULL;
				gdouble _tmp16_ = 0.0;
				gdouble flon = 0.0;
				const gchar* _tmp17_ = NULL;
				gdouble _tmp18_ = 0.0;
				GpxPoint* _tmp19_ = NULL;
				gdouble _tmp20_ = 0.0;
				gdouble _tmp21_ = 0.0;
				xmlNode* info = NULL;
				xmlNode* _tmp22_ = NULL;
				xmlNode* _tmp23_ = NULL;
				GpxTrack* _tmp40_ = NULL;
				GpxPoint* _tmp41_ = NULL;
				_tmp14_ = gpx_point_new ();
				p = _tmp14_;
				_tmp15_ = lat;
				_tmp16_ = g_ascii_strtod (_tmp15_, NULL);
				flat = _tmp16_;
				_tmp17_ = lon;
				_tmp18_ = g_ascii_strtod (_tmp17_, NULL);
				flon = _tmp18_;
				_tmp19_ = p;
				_tmp20_ = flat;
				_tmp21_ = flon;
				gpx_point_set_position (_tmp19_, _tmp20_, _tmp21_);
				_tmp22_ = trkseg;
				_tmp23_ = _tmp22_->children;
				info = _tmp23_;
				while (TRUE) {
					xmlNode* _tmp24_ = NULL;
					xmlNode* _tmp25_ = NULL;
					const gchar* _tmp26_ = NULL;
					xmlNode* _tmp38_ = NULL;
					xmlNode* _tmp39_ = NULL;
					_tmp24_ = info;
					if (!(_tmp24_ != NULL)) {
						break;
					}
					_tmp25_ = info;
					_tmp26_ = _tmp25_->name;
					if (g_strcmp0 (_tmp26_, "ele") == 0) {
						gchar* content = NULL;
						xmlNode* _tmp27_ = NULL;
						gchar* _tmp28_ = NULL;
						const gchar* _tmp29_ = NULL;
						_tmp27_ = info;
						_tmp28_ = xmlNodeGetContent (_tmp27_);
						content = _tmp28_;
						_tmp29_ = content;
						if (_tmp29_ != NULL) {
							GpxPoint* _tmp30_ = NULL;
							const gchar* _tmp31_ = NULL;
							gdouble _tmp32_ = 0.0;
							_tmp30_ = p;
							_tmp31_ = content;
							_tmp32_ = g_ascii_strtod (_tmp31_, NULL);
							_tmp30_->elevation = _tmp32_;
						}
						_g_free0 (content);
					} else {
						xmlNode* _tmp33_ = NULL;
						const gchar* _tmp34_ = NULL;
						_tmp33_ = info;
						_tmp34_ = _tmp33_->name;
						if (g_strcmp0 (_tmp34_, "time") == 0) {
							GpxPoint* _tmp35_ = NULL;
							xmlNode* _tmp36_ = NULL;
							gchar* _tmp37_ = NULL;
							_tmp35_ = p;
							_tmp36_ = info;
							_tmp37_ = xmlNodeGetContent (_tmp36_);
							_g_free0 (_tmp35_->time);
							_tmp35_->time = _tmp37_;
						}
					}
					_tmp38_ = info;
					_tmp39_ = _tmp38_->next;
					info = _tmp39_;
				}
				_tmp40_ = track;
				_tmp41_ = p;
				gpx_track_add_point (_tmp40_, _tmp41_);
				_gpx_point_unref0 (p);
			} else {
				xmlNode* _tmp42_ = NULL;
				const gchar* _tmp43_ = NULL;
				_tmp42_ = trkseg;
				_tmp43_ = _tmp42_->name;
				g_message ("gpx-parser.vala:600: Failed to get trkseg: %s\n", _tmp43_);
			}
			_g_free0 (lon);
			_g_free0 (lat);
		} else {
			xmlNode* _tmp44_ = NULL;
			const gchar* _tmp45_ = NULL;
			_tmp44_ = trkseg;
			_tmp45_ = _tmp44_->name;
			if (g_strcmp0 (_tmp45_, "name") == 0) {
				GpxTrack* _tmp46_ = NULL;
				const gchar* _tmp47_ = NULL;
				const gchar* _tmp48_ = NULL;
				_tmp46_ = track;
				_tmp47_ = gpx_track_get_name (_tmp46_);
				_tmp48_ = _tmp47_;
				if (_tmp48_ == NULL) {
					GpxTrack* _tmp49_ = NULL;
					xmlNode* _tmp50_ = NULL;
					gchar* _tmp51_ = NULL;
					gchar* _tmp52_ = NULL;
					_tmp49_ = track;
					_tmp50_ = trkseg;
					_tmp51_ = xmlNodeGetContent (_tmp50_);
					_tmp52_ = _tmp51_;
					gpx_track_set_name (_tmp49_, _tmp52_);
					_g_free0 (_tmp52_);
				} else {
					GpxTrack* _tmp53_ = NULL;
					const gchar* _tmp54_ = NULL;
					const gchar* _tmp55_ = NULL;
					_tmp53_ = track;
					_tmp54_ = gpx_track_get_name (_tmp53_);
					_tmp55_ = _tmp54_;
					g_warning ("gpx-parser.vala:611: Track name allready set: %s\n", _tmp55_);
				}
			}
		}
		_tmp56_ = trkseg;
		_tmp57_ = _tmp56_->next;
		trkseg = _tmp57_;
	}
	result = track;
	return result;
}


static gint gpx_file_read_file (GpxFile* self, guint8* buffer, int buffer_length1) {
	gint result = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	{
		gssize value = 0L;
		GFileInputStream* _tmp0_ = NULL;
		guint8* _tmp1_ = NULL;
		gint _tmp1__length1 = 0;
		gssize _tmp2_ = 0L;
		_tmp0_ = self->priv->stream;
		_tmp1_ = buffer;
		_tmp1__length1 = buffer_length1;
		_tmp2_ = g_input_stream_read ((GInputStream*) _tmp0_, _tmp1_, (gsize) _tmp1__length1, NULL, &_inner_error_);
		value = _tmp2_;
		if (_inner_error_ != NULL) {
			goto __catch0_g_error;
		}
		result = (gint) value;
		return result;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_critical ("gpx-parser.vala:635: error reading from stream: %s\n", _tmp4_);
		result = -1;
		_g_error_free0 (e);
		return result;
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return 0;
}


static gint gpx_file_close_file (GpxFile* self) {
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_log ("GPX PARSER", G_LOG_LEVEL_DEBUG, "gpx-parser.vala:641: Close_file()");
	_g_object_unref0 (self->priv->stream);
	self->priv->stream = NULL;
	result = 0;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GpxFile* gpx_file_construct (GType object_type, GFile* file) {
	GpxFile * self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	self = (GpxFile*) g_object_new (object_type, NULL);
	_tmp0_ = file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->file);
	self->file = _tmp1_;
	{
		GFileInputStream* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFileInputStream* _tmp4_ = NULL;
		xmlTextReader* reader = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		xmlTextReader* _tmp8_ = NULL;
		xmlTextReader* _tmp9_ = NULL;
		xmlTextReader* _tmp10_ = NULL;
		xmlTextReader* _tmp47_ = NULL;
		_tmp3_ = file;
		_tmp4_ = g_file_read (_tmp3_, NULL, &_inner_error_);
		_tmp2_ = _tmp4_;
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_g_object_unref0 (self->priv->stream);
		self->priv->stream = _tmp2_;
		_tmp5_ = self->file;
		_tmp6_ = g_file_get_uri (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = xmlReaderForIO ((xmlInputReadCallback) gpx_file_read_file, (xmlInputCloseCallback) gpx_file_close_file, self, _tmp7_, "", 0);
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp7_);
		reader = _tmp9_;
		_tmp10_ = reader;
		if (_tmp10_ != NULL) {
			gint doc = 0;
			xmlTextReader* _tmp11_ = NULL;
			gint _tmp12_ = 0;
			_tmp11_ = reader;
			_tmp12_ = xmlTextReaderRead (_tmp11_);
			doc = _tmp12_;
			while (TRUE) {
				gint _tmp13_ = 0;
				gchar* name = NULL;
				xmlTextReader* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				_tmp13_ = doc;
				if (!(_tmp13_ == 1)) {
					break;
				}
				_tmp14_ = reader;
				_tmp15_ = xmlTextReaderConstName (_tmp14_);
				_tmp16_ = g_strdup (_tmp15_);
				name = _tmp16_;
				_tmp17_ = name;
				if (g_strcmp0 (_tmp17_, "gpx") == 0) {
					gint doc2 = 0;
					xmlTextReader* _tmp18_ = NULL;
					gint _tmp19_ = 0;
					_tmp18_ = reader;
					_tmp19_ = xmlTextReaderRead (_tmp18_);
					doc2 = _tmp19_;
					while (TRUE) {
						gint _tmp20_ = 0;
						gchar* name2 = NULL;
						xmlTextReader* _tmp21_ = NULL;
						const gchar* _tmp22_ = NULL;
						gchar* _tmp23_ = NULL;
						const gchar* _tmp24_ = NULL;
						xmlTextReader* _tmp43_ = NULL;
						gint _tmp44_ = 0;
						_tmp20_ = doc2;
						if (!(_tmp20_ == 1)) {
							break;
						}
						_tmp21_ = reader;
						_tmp22_ = xmlTextReaderConstName (_tmp21_);
						_tmp23_ = g_strdup (_tmp22_);
						name2 = _tmp23_;
						_tmp24_ = name2;
						if (g_strcmp0 (_tmp24_, "trk") == 0) {
							xmlNode* node = NULL;
							xmlTextReader* _tmp25_ = NULL;
							xmlNode* _tmp26_ = NULL;
							GpxTrack* track = NULL;
							xmlNode* _tmp27_ = NULL;
							GpxTrack* _tmp28_ = NULL;
							GpxTrack* _tmp29_ = NULL;
							GpxTrack* _tmp30_ = NULL;
							GpxTrack* _tmp31_ = NULL;
							_tmp25_ = reader;
							_tmp26_ = xmlTextReaderExpand (_tmp25_);
							node = _tmp26_;
							_tmp27_ = node;
							_tmp28_ = gpx_file_parse_track (self, _tmp27_);
							track = _tmp28_;
							_tmp29_ = track;
							gpx_track_filter_points (_tmp29_);
							_tmp30_ = track;
							_tmp31_ = _g_object_ref0 (_tmp30_);
							self->tracks = g_list_append (self->tracks, _tmp31_);
							_g_object_unref0 (track);
						} else {
							const gchar* _tmp32_ = NULL;
							_tmp32_ = name2;
							if (g_strcmp0 (_tmp32_, "wpt") == 0) {
								xmlNode* node = NULL;
								xmlTextReader* _tmp33_ = NULL;
								xmlNode* _tmp34_ = NULL;
								xmlNode* _tmp35_ = NULL;
								_tmp33_ = reader;
								_tmp34_ = xmlTextReaderExpand (_tmp33_);
								node = _tmp34_;
								_tmp35_ = node;
								gpx_file_parse_waypoint (self, _tmp35_);
							} else {
								const gchar* _tmp36_ = NULL;
								_tmp36_ = name2;
								if (g_strcmp0 (_tmp36_, "rte") == 0) {
									xmlNode* node = NULL;
									xmlTextReader* _tmp37_ = NULL;
									xmlNode* _tmp38_ = NULL;
									GpxTrack* track = NULL;
									xmlNode* _tmp39_ = NULL;
									GpxTrack* _tmp40_ = NULL;
									GpxTrack* _tmp41_ = NULL;
									GpxTrack* _tmp42_ = NULL;
									_tmp37_ = reader;
									_tmp38_ = xmlTextReaderExpand (_tmp37_);
									node = _tmp38_;
									_tmp39_ = node;
									_tmp40_ = gpx_file_parse_route (self, _tmp39_);
									track = _tmp40_;
									_tmp41_ = track;
									_tmp42_ = _g_object_ref0 (_tmp41_);
									self->routes = g_list_append (self->routes, _tmp42_);
									_g_object_unref0 (track);
								}
							}
						}
						_tmp43_ = reader;
						_tmp44_ = xmlTextReaderNext (_tmp43_);
						doc2 = _tmp44_;
						_g_free0 (name2);
					}
				} else {
					xmlTextReader* _tmp45_ = NULL;
					gint _tmp46_ = 0;
					_tmp45_ = reader;
					_tmp46_ = xmlTextReaderRead (_tmp45_);
					doc = _tmp46_;
				}
				_g_free0 (name);
			}
		} else {
			g_message ("gpx-parser.vala:703: Failed to open file");
		}
		_tmp47_ = reader;
		xmlTextReaderClose (_tmp47_);
		_xmlFreeTextReader0 (reader);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GFile* _tmp48_ = NULL;
		gchar* _tmp49_ = NULL;
		gchar* _tmp50_ = NULL;
		GError* _tmp51_ = NULL;
		const gchar* _tmp52_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp48_ = self->file;
		_tmp49_ = g_file_get_uri (_tmp48_);
		_tmp50_ = _tmp49_;
		_tmp51_ = e;
		_tmp52_ = _tmp51_->message;
		g_critical ("gpx-parser.vala:709: failed to open file: '%s' error: %s", _tmp50_, _tmp52_);
		_g_free0 (_tmp50_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	return self;
}


GpxFile* gpx_file_new (GFile* file) {
	return gpx_file_construct (GPX_TYPE_FILE, file);
}


static void gpx_file_class_init (GpxFileClass * klass) {
	gpx_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxFilePrivate));
	G_OBJECT_CLASS (klass)->finalize = gpx_file_finalize;
}


static void gpx_file_instance_init (GpxFile * self) {
	self->priv = GPX_FILE_GET_PRIVATE (self);
	self->tracks = NULL;
	self->waypoints = NULL;
	self->routes = NULL;
	self->file = NULL;
	self->priv->stream = NULL;
}


static void gpx_file_finalize (GObject* obj) {
	GpxFile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GPX_TYPE_FILE, GpxFile);
	__g_list_free__g_object_unref0_0 (self->tracks);
	__g_list_free__gpx_point_unref0_0 (self->waypoints);
	__g_list_free__g_object_unref0_0 (self->routes);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->priv->stream);
	G_OBJECT_CLASS (gpx_file_parent_class)->finalize (obj);
}


/**
     * This is the top level class representing the gpx file it self.
     * This contains a list of tracks and waypoings.
     */
GType gpx_file_get_type (void) {
	static volatile gsize gpx_file_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_file_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxFile), 0, (GInstanceInitFunc) gpx_file_instance_init, NULL };
		GType gpx_file_type_id;
		gpx_file_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxFile", &g_define_type_info, 0);
		g_once_init_leave (&gpx_file_type_id__volatile, gpx_file_type_id);
	}
	return gpx_file_type_id__volatile;
}



